;******************************************************************************
;* DMS                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
;

DMS	dc.w	dmse-dms,dmst-dms,CN_Dms,typenum
	dc.b	CRU_Track,PSF_RecogFunc
	dc.w	$50
	dc.l	0
	dc.w	_dmst-dms,dmsupck-dms,0

DMST	PSNAME "Dms"

_DMST	moveq	#0,d0			;Unknown
	cmp.l	#"DMS!",(a0)
	bne.b	.out
	btst	#1,11(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Encrypted

DMSE	dc.w	doac10-dmse,dmset-dmse,CN_DmsE,typenum
	dc.b	CRU_Track,PSF_Encrypted!PSF_RecogFunc
	dc.w	$50
	dc.l	0
	dc.w	_dmset-dmse,dmsupck-dmse,0

DMSET	PSNAME "Dms Encrypted"

_DMSET	moveq	#0,d0			;Unknown
	cmp.l	#"DMS!",(a0)
	bne.b	.out
	btst	#1,11(a0)
	beq.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Unpack DMS File
;

DMS_HeaderSize	=	$34+$14
DMS_TrackBuf	=	20000
DMS_Buf1	=	68000
DMS_Buf2	=	1256*2+1882
DMS_Buf3	=	512
DMS_Buf4	=	8192
DMS_Buf5	=	16
DMS_Buf6	=	512
DMS_Buf7	=	2048*2

	STRUCTURE DmsStruct,0
	APTR	Dms_HMem
	APTR	Dms_CMem
	APTR	Dms_UMem
	APTR	Dms_TMem
	APTR	Dms_VMem
	APTR	Dms_EMem
	APTR	Dms_M1Mem
	APTR	Dms_M2Mem
	APTR	Dms_M3Mem
	APTR	Dms_M4Mem
	APTR	Dms_M5Mem

	UWORD	Dms_DCod
	UWORD	Dms_Chk
	UWORD	Dms_Flag
	UWORD	Dms_Cou
	UWORD	Dms_Cou1
	UWORD	Dms_Cou2
	UWORD	Dms_Cou3
	UWORD	Dms_Cou4

	APTR	Dms_Adr1
	APTR	Dms_Adr2
	APTR	Dms_Tmp1
	APTR	Dms_Tmp2
	APTR	Dms_Tmp3
	APTR	Dms_Tmp4
	APTR	Dms_Tmp5
	APTR	Dms_Tmp6
	APTR	Dms_Tmp7
	APTR	Dms_Tmp8
	APTR	Dms_Tmp9

	UWORD	Dms_Bit1
	UWORD	Dms_Bit2
	UWORD	Dms_Bit3
	LABEL	DmsStruct_SIZEOF


DMSUPCK	moveq	#UERR_Memory,d7
	move.l	#DmsStruct_SIZEOF,d0
	bsr.w	alcmem
	move.l	d0,UI_Temp1(a4)
	beq.w	dmsunoo
	move.l	d0,a3

	move.l	UI_FileName(a4),a0
	bsr.w	dmsopn
	beq.w	dmsunpo

	move.l	a6,-(sp)
	move.l	LIB_DosBase(a6),a6
	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#1,d3			;End
	jsr	Seek(a6)		;Get A 0 (Have To)

	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#-1,d3			;Beginning
	jsr	Seek(a6)		;Get File Length
	move.l	(sp)+,a6

	move.l	d0,UI_CrunchLen(a4)
	clr.l	UI_Temp(a4)
	move.l	a3,a5

	bsr.w	dmsalc			;Allocate Memory
	beq.w	dmsunpo

	move.l	Dms_HMem(a5),a0
	moveq	#4,d0
	bsr.w	dmsread			;Read Info
	bne.w	dmsunpo

	moveq	#UERR_Corrupt,d7
	cmp.l	#"DMS!",(a0)
	bne.w	dmsunpo

	move.l	Dms_HMem(a5),a0
	moveq	#$34,d0
	bsr.w	dmsread			;Read Header
	bne.w	dmsunpo

	moveq	#UERR_CRC,d7
	move.l	Dms_HMem(a5),a0
	moveq	#$32,d0
	bsr.w	dmscrc			;Calculate Header CRC
	cmp.w	$32(a0),d0
	bne.w	dmsunpo

	btst	#1,7(a0)		;Encrypted?
	beq.b	dmsnen			;Nip!
	move.l	a0,-(sp)
	lea	UI_PasswordStr(a4),a0
	bsr.w	dmspass
	move.l	(sp)+,a0

DMSNEN	moveq	#UERR_Old,d7
	cmp.w	#$6f,$2c(a0)		;Test Version
	bhi.w	dmsunpo

	move.w	$30(a0),d0
	subq.w	#5,d0
	beq.b	dmsupc1
	subq.w	#1,d0
	beq.b	dmsupc2
	bra.b	dmsupc3

DMSUPC1	move.w	#12,Dms_Bit1(a5)
	bra.b	dmsupc3

DMSUPC2	move.w	#13,Dms_Bit1(a5)
DMSUPC3	moveq	#1,d0
	move.w	Dms_Bit1(a5),d1
	asl.w	d1,d0
	move.w	d0,Dms_Bit3(a5)
	addq.w	#2,d1
	move.w	d1,Dms_Bit2(a5)
	clr.w	Dms_Flag(a5)

; Main Loop

DMSLOOP	move.l	Dms_HMem(a5),a3
	lea	$34(a3),a3
	move.l	a3,a0
	moveq	#$14,d0
	bsr.w	dmsread			;Read Small Header
	bne.w	dmsunpo

	move.l	UI_Temp2(a4),d0
	beq.w	dmsfin

	moveq	#UERR_Corrupt,d7
	cmp.w	#"TR",(a3)
	bne.w	dmsuno1

	moveq	#UERR_CRC,d7
	move.l	a3,a0
	moveq	#$12,d0
	bsr.w	dmscrc			;Calculate Header CRC
	cmp.w	$12(a3),d0
	bne.w	dmsuno1

	move.w	2(a3),d0		;Read Track Number
	cmp.w	#79,d0
	bgt.w	dmsfin
	move.l	Dms_CMem(a5),a0
	move.w	6(a3),d0		;Length
	bsr.w	dmsread			;Read Crunched Data
	bne.w	dmsuno1

	move.l	Dms_CMem(a5),a0
	move.w	6(a3),d0		;Length
	bsr.w	dmscrc			;Calculate Data CRC
	cmp.w	$10(a3),d0
	bne.w	dmsuno1

	btst	#CRUB_Encryp,UI_CrunchType(a4);Encrypted?
	beq.b	dmsnen1			;Nop!
	move.l	Dms_CMem(a5),a0
	move.w	6(a3),d0		;Length
	bsr.w	dmsdecr			;Decrypt Data

DMSNEN1	move.l	Dms_CMem(a5),a0		;Crunched Data
	move.l	Dms_UMem(a5),a1		;Decrunched Data
	bsr.w	dmsunp			;Unpack Data
	move.l	d0,UI_DecrunchLen(a4)
	beq.w	dmsuno1

	moveq	#UERR_CheckSum,d7
	move.w	Dms_Chk(a5),d0
	cmp.w	14(a3),d0		;Test Checksum
	bne.w	dmsuno1

	move.w	2(a3),d0		;Track Number
	cmp.w	#-1,d0			;Banner?
	bne.b	dmsnban			;Nap!

	moveq	#-1,d0
	btst	#UFB_Banner,UI_Flag(a4)
	bne.b	dmsjmp

DMSNBAN	tst.w	d0
	bmi.w	dmsloop			;Illegal Track!!
	mulu	#22*512,d0
	add.l	#22*512,UI_Temp(a4)

; Save Track!!!

DMSJMP	move.l	UI_TrackJump(a4),d1
	beq.w	dmsloop

	move.l	d0,UI_Offset(a4)
	divu	#22*512,d0
	move.w	d0,UI_Track(a4)
	move.l	Dms_UMem(a5),UI_DecrunchAdr(a4)

	movem.l	d1-d7/a0-a6,-(sp)
	btst	#UFB_NoA4,UI_Flag(a4)
	bne.b	.noa4
	move.l	d1,a0
	move.l	UI_UserData(a4),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d1-d7/a0-a6
	bra.b	.chk

.NOA4	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a2
	move.l	UI_TrackJump(a2),a0
	move.l	UI_UserData(a2),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d1-d7/a0-a6
.CHK	tst.w	d0
	beq.w	dmsloop
	moveq	#UERR_DevErr,d7
	bra.b	dmsunpo

; Finished

DMSFIN	move.l	UI_Temp(a4),UI_DecrunchLen(a4)
	moveq	#0,d7

; Get Out

DMSUNPO	move.w	d7,UI_ErrorNum(a4)
	bsr.w	dmsfre
	bsr.w	dmscls
	move.l	UI_Temp1(a4),a1
	bsr.w	fremem
	clr.l	UI_Temp1(a4)
	moveq	#-1,d0
	tst.w	d7
	beq.b	dmsunoo
	moveq	#0,d0
DMSUNOO	rts


DMSUNO1	move.l	UI_TrkErrJump(a4),d1
	beq.b	dmsunpo

	move.w	d7,UI_ErrorNum(a4)
	move.w	2(a3),d0		;Track
	mulu	#22*512,d0
	move.l	d0,UI_Offset(a4)
	move.l	Dms_UMem(a5),UI_DecrunchAdr(a4)

	movem.l	d1-d7/a0-a6,-(sp)
	btst	#UFB_NoA4,UI_Flag(a4)
	bne.b	.noa4
	move.l	d1,a0
	move.l	UI_UserData(a4),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d1-d7/a0-a6
	bra.b	.chk

.NOA4	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a2
	move.l	UI_TrkErrJump(a2),a0
	move.l	UI_UserData(a2),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d1-d7/a0-a6
.CHK	tst.w	d0
	bne.b	dmsunpo			;Cancel!
	bra.w	dmsloop			;Skip!
;------------------------------------------------------------------------------
; Open Archive File
;
; IN :	A0 = Filename
;
; OUT:	D0 = Success
;

DMSOPN	movem.l	d1-d2/a0-a1/a6,-(sp)
	moveq	#UERR_Open,d7

	move.l	LIB_DosBase(a6),a6
	move.l	a0,d1
	move.l	#1005,d2
	jsr	Open(a6)
	move.l	d0,UI_FileHandler(a4)

	movem.l	(sp)+,d1-d2/a0-a1/a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Close Archive File
;
; IN :	Nothing
;
; OUT:	Nothing
;

DMSCLS	movem.l	d0-d1/a0-a1/a6,-(sp)

	move.l	LIB_DosBase(a6),a6
	move.l	UI_FileHandler(a4),d1
	beq.b	dmscls1
	jsr	Close(a6)
	clr.l	UI_FileHandler(a4)

DMSCLS1	movem.l	(sp)+,d0-d1/a0-a1/a6
	rts
;------------------------------------------------------------------------------
; Read From Archive File
;
; IN :	D0 = Number Of Bytes
;	A0 = Start Address
;
; OUT:	D0 = Success
;

DMSREAD	movem.l	d1-d3/a0-a1/a6,-(sp)

	moveq	#UERR_ReadWrite,d7
	move.l	LIB_DosBase(a6),a6
	move.l	UI_FileHandler(a4),d1
	move.l	a0,d2
	moveq	#0,d3
	move.w	d0,d3
	jsr	Read(a6)
	move.l	d0,UI_Temp2(a4)

	cmp.l	#-1,d0
	beq.b	dmsrd1
	moveq	#0,d0

DMSRD1	movem.l	(sp)+,d1-d3/a0-a1/a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Allocate Memory
;
; IN :	Nothing
;
; OUT:	D0 = Success
;

DMSALC	moveq	#UERR_Memory,d7

	move.l	#DMS_HeaderSize,d0
	bsr.w	alcmem			;Allocate Header
	move.l	d0,Dms_HMem(a5)
	beq.w	dmsalco

	move.l	#DMS_TrackBuf,d0
	bsr.w	alccmem			;Allocate Unpacked Data
	move.l	d0,Dms_UMem(a5)
	beq.w	dmsalco

	move.l	#DMS_TrackBuf,d0
	bsr.w	alcmem			;Allocate Crunched Data
	move.l	d0,Dms_CMem(a5)
	beq.b	dmsalco

	move.l	#DMS_TrackBuf,d0
	bsr.w	alcmem			;Allocate Temp. Crunched Data
	move.l	d0,Dms_TMem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf1,d0
	bsr.w	alcmem			;Allocate Heavy Decruncher Buffer #1
	move.l	d0,Dms_VMem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf2,d0
	bsr.w	alcmem			;Allocate Heavy Decruncher Buffer #2
	move.l	d0,Dms_EMem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf3,d0
	bsr.w	alcmem			;Allocate Mini Buffer #1
	move.l	d0,Dms_M1Mem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf4,d0
	bsr.w	alcmem			;Allocate Mini Buffer #2
	move.l	d0,Dms_M2Mem(a5)
	beq.b	dmsalco

	moveq	#DMS_Buf5,d0
	bsr.w	alcmem			;Allocate Mini Buffer #3
	move.l	d0,Dms_M3Mem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf6,d0
	bsr.w	alcmem			;Allocate Mini Buffer #4
	move.l	d0,Dms_M4Mem(a5)
	beq.b	dmsalco

	move.l	#DMS_Buf7,d0
	bsr.w	alcmem			;Allocate Mini Buffer #5
	move.l	d0,Dms_M5Mem(a5)

DMSALCO	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Free Memory
;
; IN :	Nothing
;
; OUT:	Nothing
;

DMSFRE	movem.l	d1/a0-a1,-(sp)

	lea	Dms_HMem(a5),a0
	moveq	#11-1,d1
DMSFRE1	move.l	(a0)+,a1
	bsr.w	fremem
	dbra	d1,dmsfre1

	movem.l	(sp)+,d1/a0-a1
	rts
;------------------------------------------------------------------------------
; Calculate CRC
;
; IN :	D0 = Number Of Bytes
;	A0 = Start Address
;
; OUT:	D0 = CRC
;

DMSCRC	movem.l	d1-d2/a0-a1,-(sp)

	lea	dmstab,a1
	subq.w	#1,d0
	moveq	#0,d1
DMSCRC1	moveq	#0,d2
	move.b	(a0)+,d2
	eor.b	d1,d2
	add.w	d2,d2
	lsr.w	#8,d1
	move.w	(a1,d2.w),d2
	eor.w	d2,d1
	dbra	d0,dmscrc1
	move.w	d1,d0

	movem.l	(sp)+,d1-d2/a0-a1
	rts
;------------------------------------------------------------------------------
; Encrypt Password
;
; IN :	A0 = Password
;
; OUT:	Nothing
;

DMSPASS	movem.l	d0-d2/a0-a1,-(sp)
	lea	dmstab,a1
	clr.w	Dms_DCod(a5)

DMSPAS1	tst.b	(a0)
	beq.b	dmspas2
	move.w	Dms_DCod(a5),d0
	move.w	d0,d1
	lsr.w	#8,d1
	and.w	#$00ff,d1
	moveq	#0,d2
	move.b	(a0)+,d2
	eor.w	d2,d0
	and.w	#$00ff,d0
	moveq	#0,d2
	move.w	d0,d2
	add.l	d2,d2
	move.w	(a1,d2.l),d0
	eor.w	d0,d1
	move.w	d1,Dms_DCod(a5)
	bra.b	dmspas1

DMSPAS2	movem.l	(sp)+,d0-d2/a0-a1
	rts
;------------------------------------------------------------------------------
; Decrypt Data
;
; IN :	D0 = Number Of Bytes
;	A0 = Start Address
;
; OUT:	Nothing
;

DMSDECR	movem.l	d0-d1/d6-d7/a0/a3,-(sp)
	move.l	a0,a3
	move.w	d0,d7

DMSDEC1	move.w	d7,d0
	subq.w	#1,d7
	tst.w	d0
	beq.b	dmsdec2
	move.b	(a3),d6
	moveq	#0,d0
	move.b	(a3),d0
	move.w	Dms_DCod(a5),d1
	eor.w	d1,d0
	move.b	d0,(a3)+
	move.w	Dms_DCod(a5),d0
	lsr.w	#1,d0
	move.w	d0,Dms_DCod(a5)
	moveq	#0,d0
	move.b	d6,d0
	add.w	d0,Dms_DCod(a5)
	bra.b	dmsdec1

DMSDEC2	movem.l	(sp)+,d0-d1/d6-d7/a0/a3
	rts
;------------------------------------------------------------------------------
; Unpack Data
;
; IN :	A0 = Crunched Data
;	A1 = Decrunched Data
;
; OUT:	D0 = Decrunched Length
;

DMSUNP	movem.l	d5-d7/a2-a3,-(sp)
	moveq	#UERR_Corrupt,d7
	move.l	a0,a3
	move.l	a1,a2

	move.l	Dms_HMem(a5),a0
	lea	$34(a0),a0
	move.w	8(a0),d5
	ext.l	d5
	move.w	6(a0),d6		;Crunched Length
	ext.l	d6
	move.w	10(a0),d7		;Decrunched Length
	ext.l	d7
	moveq	#0,d0
	move.b	13(a0),d0		;Effective
	cmp.w	#7,d0
	bcc.w	dmsuno
	add.w	d0,d0
	move.w	dmsjtab(pc,d0.w),d0
	jmp	dmsjtab(pc,d0.w)

DMSJTAB	dc.w	dmsue1-dmsjtab,dmsue2-dmsjtab,dmsue3-dmsjtab,dmsue4-dmsjtab
	dc.w	dmsue5-dmsjtab,dmsue6-dmsjtab,dmsue6-dmsjtab

; None

DMSUE1	move.l	d6,d0
	move.l	a3,a0
	move.l	a2,a1
	bsr.w	dmsus1
	move.l	d0,d7
	bra.w	dmsuno

; Simple

DMSUE2	move.l	d6,d0
	move.l	a3,a0
	move.l	a2,a1
	bsr.w	dmsus2
	move.l	d0,d7
	bra.w	dmsuno

; Quick

DMSUE3	move.l	d6,d0
	move.l	d5,d1
	move.l	a3,a0
	move.l	Dms_TMem(a5),a1
	bsr.w	dmsus3
	move.l	Dms_TMem(a5),a0
	move.l	a2,a1
	bsr.w	dmsus2
	move.l	d0,d7
	bra.w	dmsuno

; Deep

DMSUE4	move.l	d6,d0
	move.l	d5,d1
	move.l	a3,a0
	move.l	Dms_TMem(a5),a1
	bsr.w	dmsus4
	move.l	Dms_TMem(a5),a0
	move.l	a2,a1
	bsr.w	dmsus2
	move.l	d0,d7
	bra.w	dmsuno

; Heavy1

DMSUE5	move.l	d6,d0
	move.l	d5,d1
	move.l	a3,a0
	move.l	Dms_TMem(a5),a1
	bsr.w	dmsus5
	move.l	Dms_TMem(a5),a0
	move.l	a2,a1
	bsr.w	dmsus2
	move.l	d0,d7
	bra.w	dmsuno

; Heavy2/Best

DMSUE6	move.l	Dms_HMem(a5),a0
	lea	$34(a0),a0
	btst	#2,12(a0)
	beq.b	dmsue7
	moveq	#0,d0
	move.b	12(a0),d0
	and.w	#2,d0
	subq.l	#2,sp
	move.w	d0,-(sp)
	move.l	d6,d0
	move.l	d5,d1
	move.l	a3,a0
	move.l	Dms_TMem(a5),a1
	bsr.w	dmsus9
	move.l	Dms_TMem(a5),a0
	move.l	a2,a1
	bsr.b	dmsus2
	addq.l	#4,sp
	move.l	d0,d7
	bra.w	dmsuno

DMSUE7	moveq	#0,d0
	move.b	12(a0),d0
	and.w	#2,d0
	subq.l	#2,sp
	move.w	d0,-(sp)
	move.l	d6,d0
	move.l	d5,d1
	move.l	a3,a0
	move.l	Dms_TMem(a5),a1
	bsr.w	dmsus9
	move.l	Dms_TMem(a5),a0
	move.l	a2,a1
	bsr.b	dmsus1
	addq.l	#4,sp
	move.l	d0,d7
	bra.w	dmsuno

; Unpack Subroutines

DMSUS1	movem.l	d0/d2,-(sp)
	subq.l	#1,d0
	moveq	#0,d1
	moveq	#0,d2
DMSUS1a	move.b	(a0)+,d2
	move.b	d2,(a1)+
	add.w	d2,d1
	dbra	d0,dmsus1a
	move.w	d1,Dms_Chk(a5)
	movem.l	(sp)+,d0/d2
	rts


DMSUS2	movem.l	d2-d3/a2,-(sp)
	move.l	a1,-(sp)
	lea	(a0,d0.l),a2		;End Address Of Crunched Data
	move.b	#$90,d2
	moveq	#0,d0
	moveq	#0,d3
DMSUS2a	cmp.l	a2,a0
	bge.b	dmsus2g
	move.b	(a0)+,d0
	cmp.b	d2,d0
	beq.b	dmsus2b
	move.b	d0,(a1)+
	add.w	d0,d3
	bra.b	dmsus2a

DMSUS2b	moveq	#0,d1
	move.b	(a0)+,d1
	bne.b	dmsus2c
	move.b	d0,(a1)+
	add.w	d0,d3
	bra.b	dmsus2a

DMSUS2c	cmp.b	#$ff,d1
	bne.b	dmsus2e
	move.b	(a0)+,d0
	move.b	(a0)+,d1
	lsl.w	#8,d1
	or.b	(a0)+,d1
	subq.w	#1,d1
DMSUS2d	move.b	d0,(a1)+
	add.w	d0,d3
	dbra	d1,dmsus2d
	bra.b	dmsus2a

DMSUS2e	move.b	(a0)+,d0
	subq.w	#1,d1
DMSUS2f	move.b	d0,(a1)+
	add.w	d0,d3
	dbra	d1,dmsus2f
	bra.b	dmsus2a

DMSUS2g	move.w	d3,Dms_Chk(a5)
	move.l	a1,d0
	sub.l	(sp)+,d0
	movem.l	(sp)+,d2-d3/a2
	rts


DMSUS3	movem.l	d2-d7/a2-a3,-(sp)
	move.l	a5,-(sp)
	lea	(a1,d1.l),a3
	move.l	Dms_VMem(a5),a2
	move.w	#$ff,d7
	tst.w	Dms_Flag(a5)
	bne.b	dmsus3b
	move.w	#1,Dms_Flag(a5)
	move.w	#$fb,d5
	move.l	a2,a5
	move.w	#$3e,d0
	moveq	#0,d1
DMSUS3a	move.l	d1,(a5)+
	dbra	d0,dmsus3a
	bra.b	dmsus3d

DMSUS3b	move.w	Dms_Cou(a5),d5
	moveq	#4,d0
DMSUS3c	addq.w	#1,d5
	and.w	d7,d5
	dbra	d0,dmsus3c

DMSUS3d	move.l	a1,a5
	moveq	#0,d6
DMSUS3e	cmp.l	a3,a1
	bge.w	dmsus3o
	moveq	#0,d1
	lsl.w	#1,d6
	bne.b	dmsus3f
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS3f	roxl.w	#1,d1
	tst.b	d1
	beq.b	dmsus3i
	moveq	#0,d1
	moveq	#7,d0
DMSUS3g	lsl.w	#1,d6
	bne.b	dmsus3h
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS3h	roxl.w	#1,d1
	dbra	d0,dmsus3g
	move.b	d1,(a1)+
	move.b	d1,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	bra.b	dmsus3e

DMSUS3i	moveq	#0,d3
	moveq	#1,d0
DMSUS3j	lsl.w	#1,d6
	bne.b	dmsus3k
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS3k	roxl.w	#1,d3
	dbra	d0,dmsus3j

	moveq	#0,d2
	moveq	#7,d0
DMSUS3l	lsl.w	#1,d6
	bne.b	dmsus3m
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS3m	roxl.w	#1,d2
	dbra	d0,dmsus3l
	neg.w	d2
	add.w	d5,d2
	subq.w	#1,d2
	and.w	d7,d2
	addq.w	#1,d3
	moveq	#0,d0
DMSUS3n	cmp.w	d0,d3
	blt.b	dmsus3e
	move.w	d2,d1
	add.w	d0,d1
	and.w	d7,d1
	move.b	(a2,d1.w),d1
	move.b	d1,(a1)+
	move.b	d1,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	addq.w	#1,d0
	bra.b	dmsus3n

DMSUS3o	move.l	(sp),a2
	move.w	d5,Dms_Cou(a2)
	sub.l	a5,a1
	move.l	a1,d0
	move.l	(sp)+,a5
	movem.l	(sp)+,d2-d7/a2-a3
	rts


DMSUS4	movem.l	d2-d7/a2-a3/a6,-(sp)
	move.l	a5,-(sp)
	lea	(a1,d1.l),a3
	move.l	Dms_VMem(a5),a2
	move.w	#$3fff,d7
	tst.w	Dms_Flag(a5)
	bne.b	dmsus4b
	move.w	#1,Dms_Flag(a5)
	move.w	#$3fbe,d5
	move.l	a2,a5
	move.w	#$fef,d0
	moveq	#0,d1
DMSUS4a	move.l	d1,(a5)+
	dbra	d0,dmsus4a
	bra.b	dmsus4d

DMSUS4b	move.w	Dms_Cou1(a5),d5
	moveq	#$41,d0
DMSUS4c	addq.w	#1,d5
	and.w	d7,d5
	dbra	d0,dmsus4c

DMSUS4d	move.l	a1,a5
	moveq	#0,d6
DMSUS4e	cmp.l	a3,a1
	bge.w	dmsus4q
	moveq	#0,d1
	lsl.w	#1,d6
	bne.b	dmsus4f
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS4f	roxl.w	#1,d1
	tst.b	d1
	beq.b	dmsus4i
	moveq	#0,d1
	moveq	#7,d0
DMSUS4g	lsl.w	#1,d6
	bne.b	dmsus4h
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS4h	roxl.w	#1,d1
	dbra	d0,dmsus4g
	move.b	d1,(a1)+
	move.b	d1,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	bra.b	dmsus4e

DMSUS4i	moveq	#0,d2
	moveq	#7,d0
DMSUS4j	lsl.w	#1,d6
	bne.b	dmsus4k
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS4k	roxl.w	#1,d2
	dbra	d0,dmsus4j

	lea	dmstab1,a6
	moveq	#0,d3
	move.b	(a6,d2.w),d3
	lea	dmstab2,a6
	moveq	#0,d0
	move.b	(a6,d2.w),d0
	subq.w	#1,d0
DMSUS4l	lsl.w	#1,d6
	bne.b	dmsus4m
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS4m	roxl.w	#1,d2
	dbra	d0,dmsus4l

	and.w	#$ff,d2
	lea	dmstab1,a6
	moveq	#0,d1
	move.b	(a6,d2.w),d1
	lsl.w	#8,d1
	lea	dmstab2,a6
	moveq	#0,d0
	move.b	(a6,d2.w),d0
	subq.w	#1,d0
DMSUS4n	lsl.w	#1,d6
	bne.b	dmsus4o
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS4o	roxl.w	#1,d2
	dbra	d0,dmsus4n

	and.w	#$ff,d2
	or.w	d1,d2
	neg.w	d2
	add.w	d5,d2
	subq.w	#1,d2
	and.w	d7,d2
	addq.w	#2,d3
	moveq	#0,d0
DMSUS4p	cmp.w	d0,d3
	blt.w	dmsus4e
	move.w	d2,d1
	add.w	d0,d1
	and.w	d7,d1
	move.b	(a2,d1.w),d1
	move.b	d1,(a1)+
	move.b	d1,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	addq.w	#1,d0
	bra.b	dmsus4p

DMSUS4q	move.l	(sp),a2
	move.w	d5,Dms_Cou1(a2)
	sub.l	a5,a1
	move.l	a1,d0
	move.l	(sp)+,a5
	movem.l	(sp)+,d2-d7/a2-a3/a6
	rts


DMSUS5	movem.l	d2-d7/a2-a3,-(sp)
	move.l	a5,-(sp)
	lea	(a1,d1.l),a3
	move.l	Dms_VMem(a5),a2
	move.w	#$3fff,d7
	tst.w	Dms_Flag(a5)
	bne.b	dmsus5b
	movem.l	a0-a1,-(sp)
	bsr.w	dmsus6
	movem.l	(sp)+,a0-a1
	move.w	#1,Dms_Flag(a5)
	move.w	#$3fc4,d5
	move.l	a2,a5
	move.w	#$ff1,d0
	moveq	#0,d1
DMSUS5a	move.l	d1,(a5)+
	dbra	d0,dmsus5a
	bra.b	dmsus5d

DMSUS5b	move.w	Dms_Cou2(a5),d5
	moveq	#$3b,d0
DMSUS5c	addq.w	#1,d5
	and.w	d7,d5
	dbra	d0,dmsus5c

DMSUS5d	move.l	a1,-(sp)
	moveq	#0,d6
DMSUS5e	cmp.l	a3,a1
	bge.w	dmsus5o
	moveq	#0,d3
	move.l	4(sp),a5
	move.l	Dms_EMem(a5),a5
	move.w	$4e4(a5),d3
DMSUS5f	cmp.w	#$273,d3
	bge.b	dmsus5h
	moveq	#0,d0
	lsl.w	#1,d6
	bne.b	dmsus5g
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS5g	roxl.w	#1,d0
	add.l	d3,d0
	add.l	d0,d0
	move.w	(a5,d0.l),d3
	bra.b	dmsus5f

DMSUS5h	sub.l	#$273,d3
	move.l	d3,d0
	movem.l	a0-a1,-(sp)
	bsr.w	dmsus7
	movem.l	(sp)+,a0-a1
	cmp.w	#$100,d3
	bge.b	dmsus5i
	move.b	d3,(a1)+
	move.b	d3,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	bra.b	dmsus5e

DMSUS5i	moveq	#0,d2
	moveq	#7,d0
DMSUS5j	lsl.w	#1,d6
	bne.b	dmsus5k
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS5k	roxl.w	#1,d2
	dbra	d0,dmsus5j

	lea	dmstab1,a5
	moveq	#0,d1
	move.b	(a5,d2.w),d1
	lsl.w	#8,d1
	lea	dmstab2,a5
	moveq	#0,d0
	move.b	(a5,d2.w),d0
	subq.w	#1,d0
DMSUS5l	lsl.w	#1,d6
	bne.b	dmsus5m
	move.w	(a0)+,d6
	move.w	#$10,ccr
	roxl.w	#1,d6
DMSUS5m	roxl.w	#1,d2
	dbra	d0,dmsus5l
	and.w	#$ff,d2
	or.w	d1,d2
	neg.w	d2
	add.w	d5,d2
	subq.w	#1,d2
	and.w	d7,d2
	sub.w	#$fd,d3
	moveq	#0,d0
DMSUS5n	cmp.w	d0,d3
	ble.w	dmsus5e
	move.w	d2,d1
	add.w	d0,d1
	and.w	d7,d1
	move.b	(a2,d1.w),d1
	move.b	d1,(a1)+
	move.b	d1,(a2,d5.w)
	addq.w	#1,d5
	and.w	d7,d5
	addq.w	#1,d0
	bra.b	dmsus5n

DMSUS5o	move.l	4(sp),a2
	move.w	d5,Dms_Cou2(a2)
	sub.l	(sp)+,a1
	move.l	a1,d0
	move.l	(sp)+,a5
	movem.l	(sp)+,d2-d7/a2-a3
	rts


DMSUS6	link	a5,#-16
	movem.l	d2-d3/d6-d7/a2-a3,-(sp)
	move.l	UI_Temp1(a4),a2
	move.l	Dms_EMem(a2),a2
	lea	$4e8(a2),a0
	lea	$75a(a0),a3
	moveq	#0,d7
DMSUS6a	cmp.w	#$13a,d7
	bge.b	dmsus6b
	move.w	d7,d0
	add.w	d0,d0
	move.w	#1,(a3,d0.w)
	move.w	d7,d0
	add.w	d0,d0
	move.w	d7,d1
	add.w	#$273,d1
	move.w	d1,(a2,d0.w)
	move.w	d7,d0
	add.w	d0,d0
	move.w	d0,d1
	add.w	#$4e6,d1
	move.w	d7,(a0,d1.w)
	addq.w	#1,d7
	bra.b	dmsus6a

DMSUS6b	moveq	#0,d7
	move.w	#$13a,d6
DMSUS6c	cmp.w	#$272,d6
	bgt.b	dmsus6d
	move.w	d6,d0
	add.w	d0,d0
	move.w	d7,d1
	add.w	d1,d1
	move.w	d7,d2
	add.w	d2,d2
	move.w	(a3,d1.w),d3
	add.w	2(a3,d2.w),d3
	move.w	d3,(a3,d0.w)
	move.w	d6,d0
	add.w	d0,d0
	move.w	d7,(a2,d0.w)
	move.w	d7,d0
	add.w	d0,d0
	move.w	d7,d1
	add.w	d1,d1
	move.w	d6,d2
	move.w	d2,2(a0,d1.w)
	move.w	d2,(a0,d0.w)
	addq.w	#2,d7
	addq.w	#1,d6
	bra.b	dmsus6c

DMSUS6d	move.w	#$ffff,$4e6(a3)
	clr.w	$4e4(a0)
	movem.l	(sp)+,d2-d3/d6-d7/a2-a3
	unlk	a5
	rts


DMSUS7	link	a5,#-$18
	movem.l	d4-d7/a2-a3,-(sp)
	move.l	d0,-$18(a5)
	move.l	UI_Temp1(a4),a0
	move.l	Dms_EMem(a0),a0
	lea	$4e8(a0),a2
	lea	$75a(a2),a3
	move.l	a0,-12(a5)
	cmp.w	#$8000,$4e4(a3)
	bne.b	dmsus7a
	bsr.w	dmsus8

DMSUS7a	move.w	-$16(a5),d0
	ext.l	d0
	add.l	d0,d0
	move.l	d0,d1
	add.l	#$4e6,d1
	move.w	(a2,d1.l),-$16(a5)
DMSUS7b	move.w	-$16(a5),d0
	ext.l	d0
	add.l	d0,d0
	addq.w	#1,(a3,d0.l)
	move.w	(a3,d0.l),d5
	move.w	-$16(a5),d4
	addq.w	#1,d4
	move.l	d4,d0
	ext.l	d0
	add.l	d0,d0
	cmp.w	(a3,d0.l),d5
	bls.b	dmsus7f
DMSUS7c	addq.w	#1,d4
	move.l	d4,d0
	ext.l	d0
	add.l	d0,d0
	cmp.w	(a3,d0.l),d5
	bhi.b	dmsus7c
	subq.w	#1,d4
	move.w	-$16(a5),d0
	ext.l	d0
	add.l	d0,d0
	move.l	d4,d1
	ext.l	d1
	add.l	d1,d1
	move.w	(a3,d1.l),(a3,d0.l)
	move.w	d5,(a3,d1.l)
	move.l	-12(a5),a0
	move.w	(a0,d0.l),d7
	move.l	d7,d0
	ext.l	d0
	add.l	d0,d0
	move.w	d4,(a2,d0.l)
	cmp.w	#$273,d7
	bge.b	dmsus7d
	move.w	d4,2(a2,d0.l)
DMSUS7d	move.l	d4,d0
	ext.l	d0
	add.l	d0,d0
	move.w	(a0,d0.l),d6
	move.w	d7,(a0,d0.l)
	move.l	d6,d0
	ext.l	d0
	add.l	d0,d0
	move.w	-$16(a5),d1
	move.w	d1,(a2,d0.l)
	cmp.w	#$273,d6
	bge.b	dmsus7e
	move.w	d1,2(a2,d0.l)
DMSUS7e	move.l	d1,d0
	ext.l	d0
	add.l	d0,d0
	move.w	d6,(a0,d0.l)
	move.w	d4,-$16(a5)
DMSUS7f	move.w	-$16(a5),d0
	ext.l	d0
	add.l	d0,d0
	move.w	(a2,d0.l),-$16(a5)
	tst.w	-$16(a5)
	bne.w	dmsus7b
	movem.l	(sp)+,d4-d7/a2-a3
	unlk	a5
	rts


DMSUS8	link	a5,#-$18
	movem.l	d2-d7/a2-a3,-(sp)
	move.l	UI_Temp1(a4),a2
	move.l	Dms_EMem(a2),a2
	lea	$4e8(a2),a0
	lea	$75a(a0),a3
	moveq	#0,d6
	moveq	#0,d7
	move.l	a0,-12(a5)
DMSUS8a	cmp.w	#$273,d7
	bge.b	dmsus8c
	move.l	d7,d0
	ext.l	d0
	add.l	d0,d0
	cmp.w	#$273,(a2,d0.l)
	blt.b	dmsus8b
	move.l	d6,d1
	ext.l	d1
	add.l	d1,d1
	move.w	(a3,d0.l),d2
	addq.w	#1,d2
	lsr.w	#1,d2
	move.w	d2,(a3,d1.l)
	move.w	(a2,d0.l),(a2,d1.l)
	addq.w	#1,d6
DMSUS8b	addq.w	#1,d7
	bra.b	dmsus8a

DMSUS8c	moveq	#0,d7
	move.w	#$13a,d6
DMSUS8d	cmp.w	#$273,d6
	bge.w	dmsus8k
	move.l	d7,d5
	addq.w	#1,d5
	move.l	d6,d0
	ext.l	d0
	add.l	d0,d0
	move.l	d7,d1
	ext.l	d1
	add.l	d1,d1
	move.l	d5,d2
	ext.l	d2
	add.l	d2,d2
	move.w	(a3,d1.l),d3
	add.w	(a3,d2.l),d3
	move.w	d3,(a3,d0.l)
	move.l	d3,d4
	move.l	d6,d5
	subq.w	#1,d5
DMSUS8e	move.l	d5,d0
	ext.l	d0
	add.l	d0,d0
	cmp.w	(a3,d0.l),d4
	bcc.b	dmsus8f
	subq.w	#1,d5
	bra.b	dmsus8e

DMSUS8f	addq.w	#1,d5
	move.l	d6,d0
	sub.w	d5,d0
	add.w	d0,d0
	move.w	d0,-$16(a5)
	move.l	d5,d1
	ext.l	d1
	add.l	d1,d1
	tst.w	d0
	ble.b	dmsus8h
	move.l	a3,a0
	add.l	d1,a0
	lea	2(a0),a1
	add.l	d0,a0
	add.l	d0,a1
	subq.w	#1,d0
DMSUS8g	move.b	-(a0),-(a1)
	dbra	d0,dmsus8g

DMSUS8h	move.w	d4,(a3,d1.l)
	move.w	-$16(a5),d0
	tst.w	d0
	ble.b	dmsus8j
	move.l	a2,a0
	add.l	d1,a0
	lea	2(a0),a1
	add.l	d0,a0
	add.l	d0,a1
	subq.w	#1,d0
DMSUS8i	move.b	-(a0),-(a1)
	dbra	d0,dmsus8i

DMSUS8j	move.w	d7,(a2,d1.l)
	addq.w	#2,d7
	addq.w	#1,d6
	bra.w	dmsus8d

DMSUS8k	moveq	#0,d7
DMSUS8l	cmp.w	#$273,d7
	bge.b	dmsus8n
	move.l	d7,d0
	ext.l	d0
	add.l	d0,d0
	move.w	(a2,d0.l),d5
	move.l	d5,d0
	ext.l	d0
	add.l	d0,d0
	move.l	-12(a5),a0
	move.w	d7,(a0,d0.l)
	cmp.w	#$273,d5
	bge.b	dmsus8m
	move.w	d7,2(a0,d0.l)
DMSUS8m	addq.w	#1,d7
	bra.b	dmsus8l

DMSUS8n	movem.l	(sp)+,d2-d7/a2-a3
	unlk	a5
	rts


DMSUS9	movem.l	d2-d7/a2-a6,-(sp)
	move.l	a1,a6
	lea	(a6,d1.l),a3
	move.l	Dms_VMem(a5),a2
	tst.w	Dms_Flag(a5)
	bne.b	dmsus9a
	move.w	#1,Dms_Flag(a5)
	clr.w	Dms_Cou3(a5)
DMSUS9a	move.l	a0,a5
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	moveq	#16,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9b
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9b	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	tst.w	$30(sp)
	beq.w	dmsus9v
	move.w	d5,d2
	moveq	#9,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9c
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9c	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	lsr.w	#7,d2
	bne.b	dmsus9g
	move.w	d5,d2
	moveq	#9,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9d
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9d	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	moveq	#0,d0
	move.w	#$1fd,d1
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M1Mem(a0),a0
DMSUS9e	move.b	d0,(a0)+
	dbra	d1,dmsus9e
	lsr.w	#7,d2
	move.w	#$fff,d1
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M2Mem(a0),a0
DMSUS9f	move.w	d2,(a0)+
	dbra	d1,dmsus9f
	bra.b	dmsus9l

DMSUS9g	move.w	d2,d3
	subq.w	#1,d3
	moveq	#11,d4
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M1Mem(a0),a0
DMSUS9h	move.w	d5,d0
	lsr.w	d4,d0
	move.b	d0,(a0)+
	moveq	#5,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9i
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9i	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	dbra	d3,dmsus9h

	move.w	#$1fe,d1
	sub.w	d2,d1
	ble.b	dmsus9k
	subq.w	#1,d1
	moveq	#0,d0
DMSUS9j	move.b	d0,(a0)+
	dbra	d1,dmsus9j

DMSUS9k	move.w	#$1fe,d0
	move.l	UI_Temp1(a4),a1
	move.l	Dms_M1Mem(a1),a0
	move.l	Dms_M2Mem(a1),a1
	moveq	#12,d1
	bsr.w	dmsus10

DMSUS9l	move.w	d5,d2
	moveq	#5,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9m
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9m	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	moveq	#16,d3
	subq.w	#5,d3
	lsr.w	d3,d2
	bne.b	dmsus9q
	move.w	d5,d2
	moveq	#5,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9n
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9n	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	moveq	#0,d0
	move.l	UI_Temp1(a4),a0
	move.w	Dms_Bit2(a0),d1
	subq.w	#1,d1
	move.l	Dms_M3Mem(a0),a0
DMSUS9o	move.b	d0,(a0)+
	dbra	d1,dmsus9o
	lsr.w	d3,d2
	move.w	#255,d1
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M4Mem(a0),a0
DMSUS9p	move.w	d2,(a0)+
	dbra	d1,dmsus9p
	bra.b	dmsus9v

DMSUS9q	move.w	d2,d3
	subq.w	#1,d3
	moveq	#12,d4
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M3Mem(a0),a0
DMSUS9r	move.w	d5,d0
	lsr.w	d4,d0
	move.b	d0,(a0)+
	moveq	#4,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9s
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9s	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	dbra	d3,dmsus9r

	move.l	UI_Temp1(a4),a1
	move.w	Dms_Bit2(a1),d1
	sub.w	d2,d1
	ble.b	dmsus9u
	subq.w	#1,d1
	moveq	#0,d0
DMSUS9t	move.b	d0,(a0)+
	dbra	d1,dmsus9t

DMSUS9u	move.l	UI_Temp1(a4),a1
	move.w	Dms_Bit2(a1),d0
	move.l	Dms_M3Mem(a1),a0
	move.l	Dms_M4Mem(a1),a1
	moveq	#8,d1
	bsr.w	dmsus10

DMSUS9v	move.l	UI_Temp1(a4),a0
	move.w	Dms_Bit3(a0),d1
	subq.w	#1,d1
	move.w	Dms_Cou3(a0),d4
	move.l	a6,-(sp)

DMSUS9w	cmp.l	a3,a6
	bge.w	dmss919
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M2Mem(a0),a0
	move.w	d5,d0
	lsr.w	#4,d0
	add.w	d0,d0
	move.w	(a0,d0.w),d3
	cmp.w	#$1fe,d3
	bge.b	dmsus9y
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M1Mem(a0),a0
	move.b	(a0,d3.w),d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9x
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9x	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	bra.b	dmsus94

DMSUS9y	moveq	#12,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus9z
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS9z	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M5Mem(a0),a0
	lea	DMS_Buf7/2(a0),a1
	moveq	#16,d0
DMSUS90	subq.w	#1,d0
	btst	d0,d5
	beq.b	dmsus91
	add.w	d3,d3
	move.w	(a0,d3.w),d3
	bra.b	dmsus92

DMSUS91	add.w	d3,d3
	move.w	(a1,d3.w),d3
DMSUS92	cmp.w	#$1fe,d3
	bge.b	dmsus90
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M1Mem(a0),a0
	move.b	(a0,d3.w),d0
	sub.b	#12,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus93
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS93	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
DMSUS94	cmp.w	#$100,d3
	bge.b	dmsus95
	move.b	d3,(a6)+
	move.b	d3,(a2,d4.w)
	addq.w	#1,d4
	and.w	d1,d4
	bra.w	dmsus9w

DMSUS95	move.l	UI_Temp1(a4),a0
	move.l	Dms_M4Mem(a0),a0
	move.w	d5,d0
	lsr.w	#8,d0
	add.w	d0,d0
	move.w	(a0,d0.w),d2
	move.l	UI_Temp1(a4),a0
	cmp.w	Dms_Bit2(a0),d2
	bge.b	dmsus97
	move.l	Dms_M3Mem(a0),a0
	move.b	(a0,d2.w),d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus96
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS96	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	bra.b	dmss913

DMSUS97	moveq	#8,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmsus98
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSUS98	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
	move.l	UI_Temp1(a4),a0
	move.l	Dms_M5Mem(a0),a0
	lea	DMS_Buf7/2(a0),a1
	moveq	#16,d0
DMSUS99	subq.w	#1,d0
	btst	d0,d5
	beq.b	dmss910
	add.w	d2,d2
	move.w	(a0,d2.w),d2
	bra.b	dmss911

DMSS910	add.w	d2,d2
	move.w	(a1,d2.w),d2
DMSS911	move.l	a2,-(sp)
	move.l	UI_Temp1(a4),a2
	cmp.w	Dms_Bit2(a2),d2
	move.l	(sp)+,a2
	bge.b	dmsus99

	move.l	UI_Temp1(a4),a0
	move.l	Dms_M3Mem(a0),a0
	move.b	(a0,d2.w),d0
	subq.b	#8,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmss912
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSS912	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
DMSS913	move.l	UI_Temp1(a4),a0
	move.w	Dms_Bit2(a0),d0
	subq.w	#1,d0
	cmp.w	d0,d2
	bne.b	dmss914
	move.w	Dms_Cou4(a0),d2
	bra.b	dmss917

DMSS914	tst.w	d2
	beq.b	dmss916
	subq.w	#1,d2
	moveq	#0,d0
	move.w	d5,d0
	lsl.l	d2,d0
	swap	d0
	bset	d2,d0
	exg	d2,d0
	lsl.w	d0,d5
	cmp.b	d6,d0
	ble.b	dmss915
	sub.b	d6,d0
	lsl.l	d6,d7
	move.w	(a5)+,d7
	moveq	#16,d6
DMSS915	lsl.l	d0,d7
	swap	d7
	or.w	d7,d5
	clr.w	d7
	swap	d7
	sub.b	d0,d6
DMSS916	move.l	UI_Temp1(a4),a0
	move.w	d2,Dms_Cou4(a0)

DMSS917	neg.w	d2
	add.w	d4,d2
	subq.w	#1,d2
	and.w	d1,d2
	sub.w	#$fd,d3
	moveq	#0,d0
DMSS918	cmp.w	d0,d3
	ble.w	dmsus9w
	and.w	d1,d2
	move.b	(a2,d2.w),(a6)
	move.b	(a6)+,(a2,d4.w)
	addq.w	#1,d4
	and.w	d1,d4
	addq.w	#1,d2
	addq.w	#1,d0
	bra.b	dmss918

DMSS919	move.l	UI_Temp1(a4),a0
	move.w	d4,Dms_Cou3(a0)
	sub.l	(sp)+,a6
	move.l	a6,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts


DMSUS10	link	a5,#-8
	movem.l	d2-d3/d6-d7/a2,-(sp)
	move.l	UI_Temp1(a4),a2
	move.l	d0,d7
	move.l	d1,d6
	movem.l	a0-a1,-8(a5)
	move.l	d7,d0
	move.l	-8(a5),Dms_Adr2(a2)
	move.l	-4(a5),Dms_Adr1(a2)
	moveq	#1,d1
	move.l	d1,d2
	asl.w	d6,d2
	move.w	d2,Dms_Tmp3(a2)
	bpl.b	dmss10a
	addq.w	#1,d2
DMSS10a	asr.w	#1,d2
	move.l	d6,d3
	addq.w	#1,d3
	move.w	#$ffff,Dms_Tmp1(a2)
	clr.w	Dms_Tmp8(a2)
	move.w	d0,Dms_Tmp2(a2)
	move.w	d0,Dms_Tmp7(a2)
	move.w	d1,Dms_Tmp5(a2)
	move.w	d1,Dms_Tmp4(a2)
	move.w	d2,Dms_Tmp9(a2)
	move.w	d3,Dms_Tmp6(a2)
	bsr.b	dmsus11
	bsr.b	dmsus11
	movem.l	(sp)+,d2-d3/d6-d7/a2
	unlk	a5
	rts


DMSUS11	link	a5,#-4
	move.l	d7,-(sp)
	move.l	UI_Temp1(a4),a2
	move.w	Dms_Tmp4(a2),d0
	cmp.w	Dms_Tmp5(a2),d0
	bne.b	dmss11e
DMSS11a	addq.w	#1,Dms_Tmp1(a2)
	move.w	Dms_Tmp1(a2),d0
	cmp.w	Dms_Tmp2(a2),d0
	bge.b	dmss11d
	moveq	#0,d0
	move.l	Dms_Adr2(a2),a0
	move.w	Dms_Tmp1(a2),d1
	move.b	(a0,d1.w),d0
	cmp.w	Dms_Tmp4(a2),d0
	bne.b	dmss11a
	move.w	Dms_Tmp8(a2),d7
	move.w	Dms_Tmp9(a2),d0
	add.w	d0,Dms_Tmp8(a2)
DMSS11b	cmp.w	Dms_Tmp8(a2),d7
	bcc.b	dmss11c
	move.w	d7,d0
	ext.l	d0
	add.l	d0,d0
	addq.w	#1,d7
	move.l	Dms_Adr1(a2),a0
	move.w	Dms_Tmp1(a2),(a0,d0.l)
	bra.b	dmss11b

DMSS11c	move.w	Dms_Tmp1(a2),d0
	bra.w	dmss11h

DMSS11d	move.w	#$ffff,Dms_Tmp1(a2)
	addq.w	#1,Dms_Tmp4(a2)
	move.w	Dms_Tmp9(a2),d0
	lsr.w	#1,d0
	move.w	d0,Dms_Tmp9(a2)
DMSS11e	addq.w	#1,Dms_Tmp5(a2)
	move.w	Dms_Tmp5(a2),d0
	cmp.w	Dms_Tmp6(a2),d0
	bge.b	dmss11f
	bsr.w	dmsus11
	bsr.w	dmsus11
	bra.b	dmss11g

DMSS11f	moveq	#32,d1
	cmp.w	d1,d0
	bhi.b	dmss11g
	move.w	Dms_Tmp7(a2),d7
	addq.w	#1,Dms_Tmp7(a2)
	move.w	Dms_Tmp2(a2),d0
	add.w	d0,d0
	subq.w	#1,d0
	cmp.w	d0,d7
	move.w	d7,d0
	ext.l	d0
	add.l	d0,d0
	move.l	d0,4(sp)
	bsr.w	dmsus11
	move.l	Dms_M5Mem(a2),a0
	lea	DMS_Buf7/2(a0),a0
	move.l	4(sp),d1
	move.w	d0,(a0,d1.l)
	move.w	d7,d0
	ext.l	d0
	add.l	d0,d0
	move.l	d0,4(sp)
	bsr.w	dmsus11
	move.l	Dms_M5Mem(a2),a0
	move.l	4(sp),d1
	move.w	d0,(a0,d1.l)
	move.w	Dms_Tmp5(a2),d0
	move.w	Dms_Tmp6(a2),d1
	cmp.w	d0,d1
	bne.b	dmss11g
	moveq	#0,d1
	move.w	Dms_Tmp8(a2),d1
	add.l	d1,d1
	addq.w	#1,Dms_Tmp8(a2)
	move.l	Dms_Adr1(a2),a0
	move.w	d7,(a0,d1.l)
DMSS11g	subq.w	#1,Dms_Tmp5(a2)
	move.l	d7,d0
DMSS11h	move.l	(sp)+,d7
	unlk	a5
	rts

; Unpack Get Out

DMSUNO	moveq	#0,d0
	move.l	UI_Temp1(a4),a0
	move.l	Dms_HMem(a0),a0
	lea	$34(a0),a0
;	move.b	12(a0),d0
;	and.w	#1,d0
;	move.w	d0,
	move.l	d7,d0
	movem.l	(sp)+,d5-d7/a2-a3
	rts
;------------------------------------------------------------------------------
