;******************************************************************************
;* High Pressure Cruncher                                                     *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
;

HPC	dc.w	hpcu-hpc,hpct-hpc,CN_HPC,typenum
	dc.b	CRU_Address,0
	dc.w	$22c
	dc.l	0
	dc.w	hpcd-hpc,_hpc-hpc,0

HPCT	PSNAME	"High Pressure Cruncher"

HPCD	dc.w	$10,12-1
HPCTAB	dc.l	$24482649,$61000084,$2800d5c4,$6100007c
	dc.l	$d3c02600,$08790001,$00bfe001,$18220244
	dc.l	$00ff1022,$e1488044,$12226100,$001a0c83

_HPC	moveq	#$24,d0
	bra.b	uhpc
;------------------------------------------------------------------------------
; Unlinked

HPCU	dc.w	hous14-hpcu,hpcut-hpcu,CN_HPCU,typenum
	dc.b	CRU_Address,PSF_NoHunk!PSF_RecogFunc
	dc.w	$208
	dc.l	0
	dc.w	_hpcut-hpcu,_hpcu-hpcu,0

HPCUT	PSNAME	"High Pressure Cruncher Unlinked"

_HPCUT
	moveq	#$10,d1
	moveq	#12-1,d2
	lea	hpctab(pc),a1
	bra.w	chktab


_HPCU	moveq	#0,d0
;	bra.b	uhpc
;------------------------------------------------------------------------------
; High Pressure Cruncher Decruncher Routine
;

UHPC	add.l	d0,a0
	move.l	$0c(a0),UI_Address(a4)
	move.l	$52(a0),UI_JumpAdr(a4)

	moveq	#0,d5
	move.b	$db(a0),d5
	move.w	$13c(a0),d6
	move.w	$144(a0),d7
	move.l	$b0(a0),d1		;Crunched Length
	lea	$1e4(a0),a0
	add.l	d1,a0

	move.l	-(a0),d0		;Number Of Bytes Decrunched
	move.l	d0,a6
	bsr.w	alcmem
	move.l	d0,a5
	tst.l	d0
	beq.b	uhpco

	move.l	d0,a1
	move.l	a1,a2
	add.l	a6,a2
	move.l	-(a0),d4
	bsr.w	bytunp1
	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	tst.l	d0
	bne.b	uhpc2

	move.l	4(a5),d0		;Final Crunched Length
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	bne.b	uhpc3
	move.w	#UERR_Memory,UI_ErrorNum(a4)
UHPC2	move.l	a5,a1
	bsr.w	fremem
	bra.b	uhpco

UHPC3	move.l	d0,a1
	move.l	a1,a2
	add.l	4(a5),a1
	move.l	a5,a0
	add.l	(a5),a0
	moveq	#-1,d2

UHPC4	move.b	-(a0),d1
	move.b	-(a0),d0
	lsl.w	#8,d0
	or.b	d1,d0
	subq.w	#1,d0
	tst.b	-(a0)
	beq.b	uhpc6
	move.b	-(a0),d1
UHPC5	move.b	d1,-(a1)
	cmp.l	a2,a1
	dbeq	d0,uhpc5
	bra.b	uhpc7

UHPC6	move.b	-(a0),-(a1)
	cmp.l	a2,a1
	dbeq	d0,uhpc6
UHPC7	cmp.w	d2,d0
	beq.b	uhpc4
	move.l	a5,a1
	bsr.w	fremem
	moveq	#-1,d0
	rts

UHPCO	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
