;******************************************************************************
;* IAM Packer                                                                 *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0 ATM5

IAM10ATM dc.w	iam10atmd-iam10atm,iam10atmt-iam10atm,CN_IAM10Atm5,typenum
	dc.b	CRU_Object,0
	dc.w	$378
	dc.l	0
	dc.w	iam10atmda-iam10atm,_iam10atm-iam10atm,0

IAM10ATMT PSNAME "IAM Packer 1.0 (ATM5)"

IAM10ATMDA dc.w	$176,12-1
	dc.l	$48e7fffe,$0c984154,$4d356600,$01824e52
	dc.l	$ffe42018,$4bf00804,$2f00284d,$49ecfff4
	dc.l	$20182c48,$ddc0534e,$1e266000,$00fc3a03

_IAM10ATM
	move.l	$18(a0),d0
	lsl.l	#2,d0
	bsr.w	alcdmem			;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	lea	$364(a0),a0
	move.l	d0,a1
	move.l	4(a0),UI_DecrunchLen(a4)

	move.l	LIB_SysBase(a6),a6
	move.l	-4(a0),d0		;Size
	lsl.l	#2,d0			;In Bytes
	jsr	CopyMemQuick(a6)	;Copy Crunched Data To Decrunch Buffer

	move.l	UI_DecrunchAdr(a4),a0
	bsr.w	iamatm
.OUT	rts
;------------------------------------------------------------------------------
; 1.0 ATM5 Data

IAM10ATMD dc.w	iam10ice-iam10atmd,iam10atmdt-iam10atmd,CN_IAM10Atm5D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	16
	dc.l	"ATM5"
	dc.w	0,_iam10atmd-iam10atmd,0

IAM10ATMDT PSNAME "IAM Packer 1.0 Data (ATM5)"

_IAM10ATMD
	move.l	4(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#$100,d0
	bsr.w	alcdmem			;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.l	LIB_SysBase(a6),a6
	move.l	d0,a1			;Destination
	moveq	#12,d0
	add.l	8(a0),d0		;Size
	jsr	CopyMem(a6)		;Copy Crunched Data To Decrunch Buffer

	move.l	UI_DecrunchAdr(a4),a0
	bsr.w	iamatm
.OUT	rts
;------------------------------------------------------------------------------
; 1.0 ICE!

IAM10ICE dc.w	iam10iced-iam10ice,iam10icet-iam10ice,CN_IAM10Ice,typenum
	dc.b	CRU_Object,0
	dc.w	$348
	dc.l	0
	dc.w	iam10iceda-iam10ice,_iam10ice-iam10ice,0

IAM10ICET PSNAME "IAM Packer 1.0 (ICE!)"

IAM10ICEDA dc.w	$176,12-1
	dc.l	$4e53ff88,$48e7fffe,$49e80078,$2c4c617e
	dc.l	$0c804943,$4521666e,$61744bf0,$08f8616e
	dc.l	$2e80ddc0,$224e7077,$172151c8,$fffc264e

_IAM10ICE
	move.l	$18(a0),d0
	lsl.l	#2,d0
	bsr.w	alcdmem			;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	lea	$334(a0),a0
	move.l	d0,a1
	move.l	8(a0),UI_DecrunchLen(a4)

	move.l	LIB_SysBase(a6),a6
	move.l	-4(a0),d0		;Size
	lsl.l	#2,d0			;In Bytes
	jsr	CopyMemQuick(a6)	;Copy Crunched Data To Decrunch Buffer

	move.l	UI_DecrunchAdr(a4),a0
	bsr.w	iamice
.OUT	rts
;------------------------------------------------------------------------------
; 1.0 ICE! Data

IAM10ICED dc.w	imp31-iam10iced,iam10icedt-iam10iced,CN_IAM10IceD,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	16
	dc.l	"ICE!"
	dc.w	0,_iam10iced-iam10iced,0

IAM10ICEDT PSNAME "IAM Packer 1.0 Data (ICE!)"

_IAM10ICED
	move.l	8(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#$100,d0
	bsr.w	alcdmem			;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.l	LIB_SysBase(a6),a6
	move.l	d0,a1			;Destination
	move.l	4(a0),d0		;Size
	jsr	CopyMem(a6)		;Copy Crunched Data To Decrunch Buffer

	move.l	UI_DecrunchAdr(a4),a0
	bsr.w	iamice
.OUT	rts
;------------------------------------------------------------------------------
; IAM/ATM5 Decruncher
;
; IN :	A0 = Pointer To (De)crunched Data
;
; OUT:	Nothing
;

IAMATM	link	a2,#-$1c
	addq.l	#4,a0
	move.l	(a0)+,d0
	lea	4(a0,d0.l),a5
	move.l	d0,-(sp)
	move.l	a5,a4
	lea	-12(a4),a4
	move.l	(a0)+,d0
	move.l	a0,a6
	add.l	d0,a6
	subq.l	#1,a6
	move.b	-(a6),d7
	bra.w	iamat32

IAMATM1	move.w	d3,d5
IAMATM2	add.b	d7,d7
IAMATM3	dbcs	d5,iamatm2
	beq.b	iamatm6
	bcc.b	iamatm4
	sub.w	d3,d5
	neg.w	d5
	bra.b	iamatm9

IAMATM4	moveq	#3,d6
	bsr.b	iamat15
	beq.b	iamatm5
	bra.b	iamatm8

IAMATM5	moveq	#7,d6
	bsr.b	iamat15
	beq.b	iamatm7
	add.w	#15,d5
	bra.b	iamatm8

IAMATM6	move.b	-(a6),d7
	addx.b	d7,d7
	bra.b	iamatm3

IAMATM7	moveq	#13,d6
	bsr.b	iamat15
	add.w	#$10e,d5
IAMATM8	add.w	d3,d5
IAMATM9	lea	iamatt1(pc),a4
	move.w	d5,d2
	bne.b	iamat19
	add.b	d7,d7
	bne.b	iamat10
	move.b	-(a6),d7
	addx.b	d7,d7
IAMAT10	bcs.b	iamat11
	moveq	#1,d6
	bra.b	iamat20

IAMAT11	moveq	#3,d6
	bsr.b	iamat15
	tst.b	-$1c(a2)
	beq.b	iamat12
	move.b	-$12(a2,d5.w),-(a5)
	bra.w	iamat31

IAMAT12	move.b	(a5),d0
	btst	#3,d5
	bne.b	iamat13
	bra.b	iamat14

IAMAT13	add.b	#$f0,d5
IAMAT14	sub.b	d5,d0
	move.b	d0,-(a5)
	bra.w	iamat31

IAMAT15	clr.w	d5
IAMAT16	add.b	d7,d7
	beq.b	iamat18
IAMAT17	addx.w	d5,d5
	dbra	d6,iamat16
	tst.w	d5
	rts

IAMAT18	move.b	-(a6),d7
	addx.b	d7,d7
	bra.b	iamat17

IAMAT19	moveq	#2,d6
IAMAT20	bsr.b	iamat15
	move.w	d5,d4
	move.b	14(a4,d4.w),d6
	ext.w	d6
	tst.b	-$1b(a2)
	bne.b	iamat21
	addq.w	#4,d6
	bra.b	iamat25

IAMAT21	bsr.b	iamat15
	move.w	d5,d1
	lsl.w	#4,d1
	moveq	#2,d6
	bsr.b	iamat15
	cmp.b	#7,d5
	blt.b	iamat23
	moveq	#0,d6
	bsr.b	iamat15
	beq.b	iamat22
	moveq	#2,d6
	bsr.b	iamat15
	add.w	d5,d5
	or.w	d1,d5
	bra.b	iamat26

IAMAT22	or.b	-$1a(a2),d1
	bra.b	iamat24

IAMAT23	or.b	-$19(a2,d5.w),d1
IAMAT24	move.w	d1,d5
	bra.b	iamat26

IAMAT25	bsr.b	iamat15
IAMAT26	add.w	d4,d4
	beq.b	iamat27
	add.w	-2(a4,d4.w),d5
IAMAT27	lea	1(a5,d5.w),a4
	move.b	-(a4),-(a5)
IAMAT28	move.b	-(a4),-(a5)
	dbra	d2,iamat28
	bra.b	iamat31

IAMAT29	add.b	d7,d7
	bne.b	iamat30
	move.b	-(a6),d7
	addx.b	d7,d7
IAMAT30	bcs.w	iamatm1
	move.b	-(a6),-(a5)
IAMAT31	cmp.l	a5,a3
	bne.b	iamat29
	cmp.l	a6,a0
	beq.b	iamat40
IAMAT32	moveq	#0,d6
	bsr.w	iamat15
	beq.b	iamat35
	move.b	-(a6),d0
	lea	-$1a(a2),a1
	move.b	d0,(a1)+
	moveq	#1,d1
	moveq	#6,d2
IAMAT33	cmp.b	d0,d1
	bne.b	iamat34
	addq.w	#2,d1
IAMAT34	move.b	d1,(a1)+
	addq.w	#2,d1
	dbra	d2,iamat33
	st	-$1b(a2)
	bra.b	iamat36

IAMAT35	sf	-$1b(a2)
IAMAT36	moveq	#0,d6
	bsr.w	iamat15
	beq.b	iamat38
	lea	-$12(a2),a1
	moveq	#15,d0
IAMAT37	move.b	-(a6),(a1)+
	dbra	d0,iamat37
	st	-$1c(a2)
	bra.b	iamat39

IAMAT38	sf	-$1c(a2)
IAMAT39	clr.w	d3
	move.b	-(a6),d3
	move.b	-(a6),d0
	lsl.w	#8,d0
	move.b	-(a6),d0
	move.l	a5,a3
	sub.w	d0,a3
	bra.b	iamat29

IAMAT40	move.l	(sp)+,d0
	lsr.l	#4,d0
	lea	-12(a6),a6
IAMAT41	move.l	(a5)+,(a6)+
	move.l	(a5)+,(a6)+
	move.l	(a5)+,(a6)+
	move.l	(a5)+,(a6)+
	dbra	d0,iamat41
	unlk	a2
	rts

IAMATT1	dc.w	$0020,$0060,$0160,$0360,$0760,$0f60,$1f60
	dc.b	0,1,3,4,5,6,7,8
;------------------------------------------------------------------------------
; IAM/ICE Decruncher
;
; IN :	A0 = Pointer To (De)crunched Data
;
; OUT:	Nothing
;

IAMICE	link	a3,#-$78
	movem.l	d0-d7/a0-a6,-(sp)
	lea	$78(a0),a4
	move.l	a4,a6
	addq.l	#4,a0
	move.l	(a0)+,d0
	lea	-8(a0,d0.l),a5
	move.l	(a0)+,d0
	move.l	d0,(sp)
	add.l	d0,a6
	move.l	a6,a1
	moveq	#$78-1,d0
IAMICE1	move.b	-(a1),-(a3)
	dbra	d0,iamice1

	move.l	a6,a3
	move.b	-(a5),d7
	bsr.b	iamic10
	move.l	a3,a5
	bsr.b	iamic14
	bcc.b	iamic4a
	move.w	#$0f9f,d7
	bsr.b	iamic14
	bcc.b	iamice2
	moveq	#15,d0
	bsr.b	iamic16
	move.w	d1,d7
IAMICE2	moveq	#3,d6
IAMICE3	move.w	-(a3),d4
	moveq	#3,d5
IAMICE4	add.w	d4,d4
	addx.w	d0,d0
	add.w	d4,d4
	addx.w	d1,d1
	add.w	d4,d4
	addx.w	d2,d2
	add.w	d4,d4
	addx.w	d3,d3
	dbra	d5,iamice4
	dbra	d6,iamice3
	movem.w	d0-d3,(a3)
	dbra	d7,iamice2

IAMIC4a	movem.l	(sp),d0-d7/a0-a3
IAMICE5	move.b	(a4)+,(a0)+
	subq.l	#1,d0
	bne.b	iamice5

	moveq	#$78-1,d0
IAMICE6	move.b	-(a3),-(a5)
	dbra	d0,iamice6

IAMICE7	movem.l	(sp)+,d0-d7/a0-a6
	unlk	a3
	rts

IAMIC10	bsr.b	iamic14
	bcc.b	iamic13
	moveq	#0,d1
	bsr.b	iamic14
	bcc.b	iamic12
	lea	iamict1(pc),a1
	moveq	#4,d3
IAMIC11	move.l	-(a1),d0
	bsr.b	iamic16
	swap	d0
	cmp.w	d0,d1
	dbne	d3,iamic11
	add.l	$14(a1),d1
IAMIC12	move.b	-(a5),-(a6)
	dbra	d1,iamic12
IAMIC13	cmp.l	a4,a6
	bgt.b	iamic19
	rts

IAMIC14	add.b	d7,d7
	bne.b	iamic15
	move.b	-(a5),d7
	addx.b	d7,d7
IAMIC15	rts

IAMIC16	moveq	#0,d1
IAMIC17	add.b	d7,d7
	bne.b	iamic18
	move.b	-(a5),d7
	addx.b	d7,d7
IAMIC18	addx.w	d1,d1
	dbra	d0,iamic17
	rts

IAMIC19	lea	iamict2(pc),a1
	moveq	#3,d2
IAMIC20	bsr.b	iamic14
	dbcc	d2,iamic20
	moveq	#0,d4
	moveq	#0,d1
	move.b	1(a1,d2.w),d0
	ext.w	d0
	bmi.b	iamic21
	bsr.b	iamic16
IAMIC21	move.b	6(a1,d2.w),d4
	add.w	d1,d4
	beq.b	iamic23
	lea	iamict3(pc),a1
	moveq	#1,d2
IAMIC22	bsr.b	iamic14
	dbcc	d2,iamic22
	moveq	#0,d1
	move.b	1(a1,d2.w),d0
	ext.w	d0
	bsr.b	iamic16
	add.w	d2,d2
	add.w	6(a1,d2.w),d1
	bpl.b	iamic25
	sub.w	d4,d1
	bra.b	iamic25

IAMIC23	moveq	#0,d1
	moveq	#5,d0
	moveq	#-1,d2
	bsr.b	iamic14
	bcc.b	iamic24
	moveq	#8,d0
	moveq	#$3f,d2
IAMIC24	bsr.b	iamic16
	add.w	d2,d1
IAMIC25	lea	2(a6,d4.w),a1
	add.w	d1,a1
	move.b	-(a1),-(a6)
IAMIC26	move.b	-(a1),-(a6)
	dbra	d4,iamic26
	bra.w	iamic10

	dc.l	$7fff000e,$00ff0007,$00070002,$00030001,$00030001
IAMICT1	dc.l	$0000010d,$0000000e,$00000007,$00000004,$00000001
IAMICT2	dc.b	9,1,0,-1,-1,8,4,2,1,0
IAMICT3	dc.b	11,4,7,0,1,31,-1,-1,0,31,0,0,0,0,0,0,0,0
;------------------------------------------------------------------------------
