;******************************************************************************
;* Lzx                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Lzx

LZX	dc.w	mast31-lzx,lzxt-lzx,CN_Lzx,typenum
	dc.b	CRU_Archive,PSF_RecogFunc
	dc.w	StartLoad
	dc.l	0
	dc.w	_lzxt-lzx,ulzx-lzx,0

LZXT	PSNAME	"Lzx"

_LZXT
	moveq	#0,d0			;Unknown
	cmp.w	#"LZ",(a0)
	bne.b	.out
	cmp.b	#"X",2(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Unpack A LZX File
;

ULZX	bsr.w	fdout			;Find Output File
	beq.w	ulzxo
	bsr.w	cacclr			;Clear Caches

	lea	lzxstr(pc),a0
	lea	UI_ExecuteString(a4),a1
ULZX1	move.b	(a0)+,(a1)+		;Copy Start Of The String
	bne.b	ulzx1

	move.b	#">",-1(a1)
	lea	UI_OutputFile(a4),a0
ULZX2	move.b	(a0)+,(a1)+		;Copy Output
	bne.b	ulzx2

	subq.l	#1,a1
	lea	lzxstr1(pc),a0
ULZX3	move.b	(a0)+,(a1)+		;Copy End Of The String
	bne.b	ulzx3

	move.b	#$22,-1(a1)
	move.l	UI_Filename(a4),a0
ULZX4	move.b	(a0)+,(a1)+		;Copy Archive Name
	bne.b	ulzx4
	move.b	#$22,-1(a1)

	move.b	#" ",(a1)+
	move.l	UI_Path(a4),d0
	beq.b	ulzx5a

	move.b	#$22,(a1)+
	move.l	d0,a0
ULZX5	move.b	(a0)+,(a1)+		;Copy Path
	bne.b	ulzx5
	move.b	#$22,-1(a1)
ULZX5a	clr.b	(a1)

	btst	#UFB_OneFile,UI_Flag(a4);One File At The Time
	bne.b	ulzxone			;Yup!!

; Unpack The Whole Archive

	tst.l	UI_LhaPattern(a4)
	beq.b	ulzx7
	move.b	#" ",(a1)+
	move.l	UI_LhaPattern(a4),a0
ULZX6	move.b	(a0)+,(a1)+		;Copy Pattern
	bne.b	ulzx6

ULZX7	move.w	#UERR_Extern,UI_ErrorNum(a4)
	bsr.w	exestr			;Execute String
	beq.b	ulzx8
	lea	lzxrd(pc),a0
	bsr.w	scandir			;Scan Directory And Load File
ULZXO	rts

ULZX8	bsr.w	udel			;Delete Temp Directory
	rts

; Unpack One File At The Time

ULZXONE	move.b	#" ",(a1)+
	move.l	a1,-(sp)

	move.l	#StartLoad,d0
	bsr.w	alcmem			;Allocate Header Buffer
	beq.w	ulzxono
	move.l	d0,-(sp)		;Store Memory Address

	move.l	LIB_DosBase(a5),a6
	move.l	UI_FileName(a4),d1
	move.l	#1005,d2
	jsr	Open(a6)
	tst.l	d0
	beq.w	ulzxoo1
	move.l	d0,-(sp)		;Store File Handler

	moveq	#10,d7			;Seek Value

; One File Loop

OLZXLOP	move.l	(sp),d1			;File Handler
	move.l	d7,d2
	moveq	#-1,d3
	jsr	Seek(a6)

	move.l	(sp),d1
	move.l	4(sp),d2
	move.l	#StartLoad,d3
	jsr	Read(a6)
	cmp.l	#-1,d0
	beq.b	ulzxoo2
	tst.l	d0
	beq.b	ulzxoo2

	bsr.w	cacclr			;Clear Caches
	move.l	4(sp),a0
	move.b	9(a0),d0
	lsl.l	#8,d0
	move.b	8(a0),d0
	lsl.l	#8,d0
	move.b	7(a0),d0
	lsl.l	#8,d0
	move.b	6(a0),d0
	add.l	d0,d7			;Crunched Length
	add.l	#31,d7			;Header Length

	moveq	#0,d0
	move.b	30(a0),d0		;Filename Length
	add.l	d0,d7
	subq.w	#1,d0

	move.l	8(sp),a1		;String Address
	lea	31(a0),a0
OLZXLP1	move.b	(a0)+,d1
	beq.b	olzxlp2
	move.b	d1,(a1)+
	dbra	d0,olzxlp1
OLZXLP2	clr.b	(a1)

	move.l	8(sp),a1
	cmp.b	#"*",(a1)		;Display Text File?
	beq.b	olzxlop			;Yip, Don't extract!!

	move.l	d7,-(sp)
	move.w	#UERR_Extern,UI_ErrorNum(a4)
	bsr.w	exestr			;Execute String
	bne.b	olzxlp3
	move.l	(sp)+,d7
	bra.b	ulzxo2a

OLZXLP3	lea	lzxrd(pc),a0
	bsr.w	scandir			;Scan Directory And Load File
	move.l	(sp)+,d7
	tst.l	d0
	beq.b	ulzxo2a
	bra.w	olzxlop

; Stop Single File Unpacking

ULZXOO2	moveq	#-1,d0
ULZXO2a	move.l	d0,d7
	move.l	(sp)+,d1
	jsr	Close(a6)

ULZXOO1	move.l	(sp)+,a1
	bsr.w	fremem			;Free Header Buffer

ULZXONO	move.l	(sp)+,a1
	move.l	d7,d0
	rts

LZXSTR	dc.b	"lzx ",0
LZXSTR1	dc.b	" x ",0
	even
;------------------------------------------------------------------------------
; Lzx Output Reader
;
; IN :	D7 = Size Of File
;	A0 = Start Address Of File
;	A1 = Jump Address
;
; OUT:	Nothing
;

LZXRD	subq.l	#1,d7
	cmp.b	#$1b,(a0)+
	bne.b	lzxrd
	cmp.b	#$5b,(a0)
	bne.b	lzxrd

LZXRD0	subq.l	#1,d7
	cmp.b	#$0a,(a0)+
	bne.b	lzxrd0

LZXRD1	cmp.l	#68,d7			;End Of File
	ble.b	lzxrdo			;Yup!

LZXRD2	subq.l	#1,d7
	cmp.b	#$0d,(a0)+
	bne.b	lzxrd2
	cmp.b	#":",25(a0)
	bne.b	lzxrd2

	sub.l	#27,d7
	lea	27(a0),a0

	lea	UI_LoadName(a4),a2
LZXRD3	subq.l	#1,d7
	move.b	(a0)+,(a2)+		;Copy Filename
	cmp.b	#$0a,(a0)
	bne.b	lzxrd3
	clr.b	(a2)
	addq.l	#1,a0
	subq.l	#1,d7

	movem.l	a0-a1/d7,-(sp)
	jsr	(a1)
	movem.l	(sp)+,a0-a1/d7
	bra.b	lzxrd1

LZXRDO	rts
;------------------------------------------------------------------------------
