; $VER: Unpack Library 42.71
;

	INCDIR	"Includes3.0:Include3.0/"
	INCLUDE	"Own/SystemBases.i"
	INCLUDE	"Own/SystemStructures.i"
	INCLUDE	"Own/SystemOffsets.i"
	INCLUDE	"Own/Unpack.i"
	INCLUDE	"Own/Xpk.i"

OBJ		=	0		;Change This To 1 For Object Code

; Library Data

LN_Name		=	10
LN_Type		=	8
NT_Library	=	9

LIBB_Summing	=	0
LIBB_Changed	=	1
LIBB_SumUsed	=	2
LIBB_DelExp	=	3

LIBF_Summing	=	1<<LIBB_Summing
LIBF_Changed	=	1<<LIBB_Changed
LIBF_SumUsed	=	1<<LIBB_SumUsed
LIBF_DelExp	=	1<<LIBB_DelExp

; Macros

INBYTE	MACRO
	dc.b	%11100000,0
	dc.w	\1
	dc.b	\2,0
	ENDM

INWORD	MACRO
	dc.b	%11010000,0
	dc.w	\1,\2
	ENDM

INLONG	MACRO
	dc.b	%11000000,0
	dc.w	\1
	dc.l	\2
	ENDM


; Other Stuff

STARTLOAD	=	1868		;Has To Be Longword Aliged

	STRUCTURE UI,UI_Private
	APTR	UI_CrunchAdrTemp
	LONG	UI_CrunchLenTemp
	LONG	UI_FileHandler
	LONG	UI_Lock
	LONG	UI_OldLock
	APTR	UI_InfoAdr
	APTR	UI_PackerStruct
	APTR	UI_LastNamePoi
	APTR	UI_GetUnpLastName
	UWORD	UI_GetUnpLastNum
	ULONG	UI_Temp
	ULONG	UI_Temp1
	ULONG	UI_Temp2
	STRUCT	UI_UnpList,UnpListStruct_SIZEOF
	STRUCT	UI_Registers,16*4
	STRUCT	UI_LoadName,2*108
	STRUCT	UI_ExecuteString,256
	STRUCT	UI_OutputFile,16
	STRUCT	UI_PasswordStr,256
	LABEL	siz

	STRUCTURE PackerStruct,0
	WORD	PS_Next
	WORD	PS_Name
	UWORD	PS_CrunchNumber
	UWORD	PS_TypeNumber
	UBYTE	PS_Type
	UBYTE	PS_Flags
	WORD	PS_MinSize
	ULONG	PS_TestData
	WORD	PS_Recog
	WORD	PS_Unpack
	WORD	PS_DiskUnpack
	LABEL	PackerStruct_SIZEOF


PSFB_Encrypted	=	0
PSFB_Data	=	1
PSFB_NoHunk	=	6
PSFB_RecogFunc	=	7

PSF_Encrypted	=	1<<PSFB_Encrypted
PSF_Data	=	1<<PSFB_Data
PSF_NoHunk	=	1<<PSFB_NoHunk
PSF_RecogFunc	=	1<<PSFB_RecogFunc


	SECTION	Unpack.library,CODE

START	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
LIBNAME	UNPACKNAME

LIBID	dc.b	"Unpack.library 42.71 (20-November-1995)",13,10,0
	dc.b	"Coded by Thomas Neumann for SHI (Safe Hex International). "
	even
;------------------------------------------------------------------------------
; ROMTAG Structure

ROMTAG	dc.w	$4afc			;ROMTAG Indentifier
	dc.l	romtag
	dc.l	slut
	dc.b	$80			;Flags
	dc.b	UnpackVersion
	dc.b	$09			;Type Of Module
	dc.b	$00			;Initialization Priority
	dc.l	libname
	dc.l	libid
	dc.l	autinit			;Pointer To AUTOINIT Table
;------------------------------------------------------------------------------
; AUTOINIT Table

AUTINIT	dc.l	LibraryStruct_SIZEOF	;Size Of Structure AFTER Base Address
	dc.l	vector			;Pointer To Vector Table
	dc.l	inittab			;Pointer To Init Structure
	dc.l	init			;Pointer To Init Routine
;------------------------------------------------------------------------------
; Init Table

INITTAB	INBYTE	LN_Type,NT_Library
	INBYTE	LIB_Flags,LIBF_SumUsed!LIBF_Changed
	INWORD	LIB_Version,UnpackVersion
	INWORD	LIB_Revision,UnpackRevision
	INLONG	LN_Name,libname
	INLONG	LIB_IDString,libid
	dc.l	0
;------------------------------------------------------------------------------
; Vector Table

VECTOR	dc.w	-1
	dc.w	opnlib-vector,clslib-vector,expunge-vector,extfunc-vector
	dc.w	_AllocCInfo-vector,_FreeCInfo-vector
	dc.w	_DetermineFile-vector,_Unpack-vector,_TestHunk-vector
	dc.w	_UnpackNum-vector,_UnpackList-vector,_UnpackListNext-vector
	dc.w	_LoadFile-vector,_FreeFile-vector
	dc.w	_UseDrive-vector,_UnuseDrive-vector,_SendCmd-vector
	dc.w	_NewUnpackNum-vector,_GetUnpacker-vector
	dc.w	-1
;------------------------------------------------------------------------------
; Init Routine

INIT	movem.l	d1-d7/a0-a6,-(sp)
	move.l	d0,a4			;Base Address
	move.l	a0,LIB_SegList(a4)

	move.l	4.w,a6
	move.l	a6,LIB_SysBase(a4)

	lea	dosname(pc),a1
	jsr	OldOpenLibrary(a6)
	move.l	d0,LIB_DosBase(a4)

	lea	intname(pc),a1
	jsr	OldOpenLibrary(a6)
	move.l	d0,LIB_IntBase(a4)

	move.l	a4,d0
	movem.l	(sp)+,d1-d7/a0-a6
	rts

DOSNAME	dc.b	"dos.library",0
INTNAME	dc.b	"intuition.library",0
	even
;------------------------------------------------------------------------------
; Offset  -6: Open Library

OPNLIB	addq.w	#1,LIB_OpenCnt(a6)
	bclr	#LIBB_DelExp,LIB_Flags(a6)
	move.l	a6,d0
	rts
;------------------------------------------------------------------------------
; Offset -12: Close Library

CLSLIB	moveq	#0,d0
	subq.w	#1,LIB_OpenCnt(a6)
	bne.b	clslibo
	btst	#LIBB_DelExp,LIB_Flags(a6)
	bne.b	expunge
CLSLIBO	rts
;------------------------------------------------------------------------------
; Offset -18: Expunge

EXPUNGE	movem.l	d1-d7/a0-a6,-(sp)
	move.l	a6,a4
	tst.w	LIB_OpenCnt(a4)
	beq.b	exp1
	bset	#LIBB_DelExp,LIB_Flags(a4)
	moveq	#0,d0
	bra.b	expungo

EXP1	move.l	4.w,a6
	move.l	LIB_IntBase(a4),a1
	jsr	CloseLibrary(a6)

	move.l	LIB_DosBase(a4),a1
	jsr	CloseLibrary(a6)

	IF	OBJ<>0
	move.l	LIB_SegList(a4),d2
	move.l	a4,a1
	jsr	Remove(a6)

	move.l	a4,a1
	moveq	#0,d0
	move.w	LIB_NegSize(a4),d0
	sub.l	d0,a1
	add.w	LIB_PosSize(a4),d0
	jsr	FreeMem(a6)
	move.l	d2,d0
	ENDC

EXPUNGO	movem.l	(sp)+,d1-d7/a0-a6
	rts
;------------------------------------------------------------------------------
; Offset -24: ExtFunc

EXTFUNC	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
*******************************************************************************
* Library Functions                                                           *
*******************************************************************************
;------------------------------------------------------------------------------
; Offset -30: AllocCInfo
;
; IN :	Nothing
;
; OUT:	D0 = Memory Start Address (Or Zero For Error)
;

_AllocCInfo
	move.l	a6,-(sp)

	move.l	LIB_SysBase(a6),a6
	move.l	#2+UnpackInfo_SIZEOF,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)		;Allocate Structure
	tst.l	d0
	beq.b	alcinfo

	move.l	d0,a0
	move.w	#"UI",(a0)+
	move.l	a0,d0

	lea	UI_LoadName(a0),a1
	move.l	a1,UI_LoadNamePoi(a0)
	lea	FirstStruct(pc),a1
	move.l	a1,UI_GetUnpLastName(a0)

	lea	outname(pc),a1
	lea	UI_OutputFile(a0),a6
ALCINF1	move.b	(a1)+,(a6)+
	bne.b	alcinf1

ALCINFO	move.l	(sp)+,a6
	rts

OUTNAME	dc.b	"T:OutputFile.00",0
	even
;-----------------------------------------------------------------------------
; Offset -36: FreeCInfo
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	Nothing
;

_FreeCInfo
	move.l	a6,-(sp)
	move.l	a0,d0
	beq.b	freinfo

	cmp.w	#"UI",-2(a0)
	bne.b	freinfo

	move.l	LIB_SysBase(a6),a6
	lea	-2(a0),a1
	move.l	#2+UnpackInfo_SIZEOF,d0
	jsr	FreeMem(a6)		;Free Structure Again

FREINFO	move.l	(sp)+,a6	
	rts
;------------------------------------------------------------------------------
; Offset -42: DetermineFile
;
; IN :	A0 = Crunch Info Start Address
;	A1 = Filename
;
; OUT:	D0 = Success (0=Error)
;	If you get an error, you can see in the UI_ErrorType flag in the
;	crunch structure what went wrong.
;

_DetermineFile
	movem.l	d2-d7/a2-a6,-(sp)
	move.l	a0,a4
	move.l	LIB_DosBase(a6),a6

	clr.l	UI_CruncherName(a4)
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)
	clr.l	UI_Address(a4)
	clr.l	UI_JumpAdr(a4)
	clr.w	UI_ErrorNum(a4)
	clr.w	UI_CrunchNum(a4)
	clr.b	UI_CrunchType(a4)

	btst	#UFB_NoLoad,UI_Flag(a4)
	bne.w	checkit

	move.l	a1,UI_Filename(a4)
	clr.l	UI_CrunchLen(a4)

	move.l	#startload,d0
	bsr.w	alcmem			;Allocate Header
	move.l	d0,UI_CrunchAdr(a4)
	beq.w	memerr

; Well, Do We Have To Change The Protection Bits

	btst	#UFB_Protect,UI_Flag(a4)
	beq.b	noprot1

	move.l	#FileInfoBlock_SIZEOF,d0
	bsr.w	alcmem			;Allocate File Info Block
	tst.l	d0
	beq.w	memerr
	move.l	d0,a3

	move.l	UI_Filename(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock File
	move.l	d0,d3
	bne.b	lockok
	move.l	a3,a1
	bsr.w	fremem			;Free File Info Block
	bra.w	filerr

LOCKOK	move.l	d3,d1
	move.l	a3,d2
	jsr	Examine(a6)		;Get Info Block

	move.l	d3,d1
	jsr	Unlock(a6)		;And Unlock File

	moveq	#-1,d0
	move.l	FileInfoBlock_Protection(a3),d1
	move.l	d1,d2
	and.l	#$0000000f,d1
	beq.b	noprot
	move.l	d1,d0
	move.l	UI_Filename(a4),d1
	and.l	#$fffffff0,d2		;Mask
	jsr	SetProtection(a6)	;Change Protection Bits

NOPROT	move.l	a3,a1
	bsr.w	fremem			;Free File Info Block
	tst.w	d0
	beq.w	prterr

; Read Header

NOPROT1	move.l	UI_Filename(a4),d1
	move.l	#1005,d2
	jsr	Open(a6)		;Open File
	move.l	d0,UI_FileHandler(a4)
	beq.w	filerr

FILEOK	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#1,d3			;End
	jsr	Seek(a6)		;Get A 0 (Have To)

	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#-1,d3			;Beginning
	jsr	Seek(a6)		;Get File Length
	move.l	d0,UI_Temp(a4)

	move.l	UI_FileHandler(a4),d1
	move.l	UI_CrunchAdr(a4),d2
	move.l	#StartLoad,d3
	jsr	Read(a6)		;Read Header
	move.l	d0,d7

	move.l	UI_FileHandler(a4),d1
	jsr	Close(a6)		;Close File
	clr.l	UI_FileHandler(a4)

	cmp.l	#-1,d7
	beq.w	rwerr
	move.l	d7,UI_CrunchLen(a4)

; Determine Header

CHECKIT	bsr.w	cacclr			;Clear Caches
	tst.l	UI_CrunchAdr(a4)
	beq.w	deterr
	move.l	UI_CrunchLen(a4),d7
	beq.w	deterr
	addq.l	#1,d7

	lea	FirstStruct(pc),a3
	move.l	UI_CrunchAdr(a4),a2

CHKLOOP	cmp.w	PS_MinSize(a3),d7
	bls.b	chknxt
	btst	#PSFB_Data,PS_Flags(a3)
	beq.b	nodata
	move.l	(a2),d0
	cmp.l	PS_TestData(a3),d0
	beq.b	found
	bra.b	chknxt

; Use Recog Table

NODATA	move.w	PS_Recog(a3),d0
	beq.b	chknxt
	btst	#PSFB_RecogFunc,PS_Flags(a3)
	bne.b	rfunc
	lea	(a3,d0.w),a0
	move.l	a2,a1
	cmp.l	#$3f3,(a1)
	bne.b	chknxt
	move.l	16(a1),d0
	sub.l	12(a1),d0
	lsl.l	#2,d0
	lea	32(a1,d0.l),a1
	move.w	(a0)+,d0
	lea	(a1,d0.w),a1
	move.w	(a0)+,d0
CHECK	cmpm.l	(a0)+,(a1)+
	bne.b	chknxt
	dbra	d0,check
	bra.b	found

; Call Recog Function

RFUNC	lea	(a3,d0.w),a1
	movem.l	d1-d7/a0-a6,-(sp)
	move.l	a2,a0
	jsr	(a1)
	movem.l	(sp)+,d1-d7/a0-a6
	tst.w	d0
	bne.b	found

CHKNXT	move.w	(a3),d0
	beq.b	deterr
	lea	(a3,d0.w),a3
	bra.b	chkloop

; We Found It!!!!

FOUND	move.l	a3,UI_PackerStruct(a4)
	move.w	PS_Name(a3),d0
	lea	(a3,d0.w),a0
	move.l	a0,UI_CruncherName(a4)
	move.w	PS_CrunchNumber(a3),UI_CrunchNum(a4)

	move.b	PS_Type(a3),d0
	btst	#PSFB_Encrypted,PS_Flags(a3)
	beq.b	nocrypt
	bset	#CRUB_Encryp,d0
NOCRYPT	move.b	d0,UI_CrunchType(a4)

; Clean Up

	moveq	#-1,d0
DETOUT	btst	#UFB_NoLoad,UI_Flag(a4)
	bne.b	nofree
	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem			;Free Header
	clr.l	UI_CrunchAdr(a4)

NOFREE	move.l	UI_Temp(a4),UI_CrunchLen(a4)
	clr.l	UI_Temp(a4)
	bsr.w	ferr			;Find Error
	movem.l	(sp)+,d2-d7/a2-a6
	rts

; Memory Error

MEMERR	moveq	#UERR_Memory,d1
ERROR	move.w	d1,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	detout

; File Error

FILERR	moveq	#UERR_Open,d1
	bra.b	error

; Protection Error

PRTERR	moveq	#UERR_Protect,d1
	bra.b	error

; Read/Write Error

RWERR	moveq	#UERR_ReadWrite,d1
	bra.b	error

; Determine Error

DETERR	moveq	#UERR_Determine,d1
	bra.b	error
;------------------------------------------------------------------------------
; Offset -48: Unpack
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	D0 = Success (0=Error)
;	If you get an error, you can see in the UI_ErrorType flag in the
;	crunch structure what went wrong.
;

_Unpack
	movem.l	d2-d7/a2-a6,-(sp)
	movem.l	d0-d7/a0-a6,UI_Registers(a0)
	move.l	a0,a4
	sf	UI_UseFilenamePointer(a4)

	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	arctrk
	cmp.b	#CRU_Track,d0
	bne.w	narctrk

; Archive/Track File, Start To Ask For Password If Needed

ARCTRK	btst	#CRUB_Encryp,UI_CrunchType(a4)
	beq.b	.pascon
	move.w	#UERR_PasswordReq,UI_ErrorNum(a4)
	tst.l	UI_Password(a4)
	beq.b	.ownpas
	movem.l	d1-d7/a0-a6,-(sp)
	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a1
	move.l	UI_Password(a1),a0
	jsr	(a0)			;Call User Password Routine
	movem.l	(sp)+,d1-d7/a0-a6
	tst.l	d0
	beq.w	err1

	move.l	d0,a0
	lea	UI_PasswordStr(a4),a1
.COPPAS	move.b	(a0)+,(a1)+
	bne.b	.coppas
	bra.b	.tstpas


.OWNPAS	bsr.w	getpass			;Get Password
	tst.l	d0
	beq.w	err1
.TSTPAS	moveq	#0,d0
	tst.b	UI_PasswordStr(a4)
	beq.w	err1

; Start To Decrunch File

.PASCON	move.w	#UERR_Unpack,UI_ErrorNum(a4)
	move.l	UI_PackerStruct(a4),a3
	move.w	PS_Unpack(a3),d0
	beq.w	err1
	lea	(a3,d0.w),a1
	move.w	#UERR_Memory,UI_ErrorNum(a4)

	movem.l	d1-d7/a0-a6,-(sp)
	move.l	a6,a5			;Library Base Address
	jsr	(a1)			;Unpack File
	bsr.w	cacclr			;Clear Caches
	movem.l	(sp)+,d1-d7/a0-a6
	bra.w	err1			;Get Out

; Load The File

NARCTRK	btst	#UFB_NoLoad,UI_Flag(a4)
	bne.b	noload
	move.l	a4,a0
	jsr	upLoadFile(a6)		;Load The File Into Memory
	tst.l	d0
	beq.w	err1

	move.l	UI_DecrunchAdr(a4),UI_CrunchAdr(a4)
	move.l	UI_DecrunchLen(a4),UI_CrunchLen(a4)

; Test Crunched Data

NOLOAD	move.l	UI_CrunchAdr(a4),UI_CrunchAdrTemp(a4)
	move.l	UI_CrunchLen(a4),UI_CrunchLenTemp(a4)
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)

	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Object,d0
	beq.b	object
	cmp.b	#CRU_Address,d0
	bne.w	nobject
OBJECT	move.l	UI_PackerStruct(a4),a3
	btst	#PSFB_NoHunk,PS_Flags(a3)
	bne.w	nobject
	move.w	#UERR_Hunk,UI_ErrorNum(a4)
	move.l	UI_CrunchAdrTemp(a4),a0
	jsr	upTestHunk(a6)
	tst.w	d0
	beq.w	err

; Move Hunk_Header If There Is A Hunk_Name Hunk

	move.l	UI_CrunchAdrTemp(a4),a1
	move.l	16(a1),d0
	sub.l	12(a1),d0
	lsl.l	#2,d0
	lea	24(a1,d0.l),a1		;Destination
	cmp.l	#$3e8,(a1)		;Hunk_Name
	bne.b	nonameh
	move.l	4(a1),d0
	lsl.l	#2,d0
	addq.l	#8,d0
	sub.l	d0,UI_CrunchLenTemp(a4)
	lea	(a1,d0.l),a0		;Destination

.COPY	cmp.l	UI_CrunchAdrTemp(a4),a1
	beq.b	.fin
	move.l	-(a1),-(a0)
	bra.b	.copy

.FIN	addq.l	#4,a0
	move.l	a0,UI_CrunchAdrTemp(a4)

; Move Hunk_Header If The Last Hunk Is A FLID Hunk

NONAMEH	move.l	UI_CrunchAdrTemp(a4),a1
	move.l	16(a1),d0
	sub.l	12(a1),d0
	move.l	d0,d1
	lsl.l	#2,d0
	lea	24(a1,d0.l),a1
	lea	-4(a1),a0

.LOOP	move.l	(a1)+,d0
	and.l	#$3fffffff,d0
	sub.l	#$3e7,d0		;Hunk_Unit
	beq.b	.name
	subq.l	#1,d0			;Hunk_Name
	beq.b	.name
	subq.l	#1,d0			;Hunk_Code
	beq.b	.code
	subq.l	#1,d0			;Hunk_Data
	beq.b	.code
	subq.l	#1,d0			;Hunk_BSS
	beq.b	.bss
	subq.l	#1,d0			;Hunk_Reloc32
	beq.b	.reloc
	subq.l	#1,d0			;Hunk_Reloc16
	beq.b	.reloc
	subq.l	#1,d0			;Hunk_Reloc8
	beq.b	.reloc
	subq.l	#3,d0			;Hunk_Debug
	beq.b	.name
	subq.l	#1,d0			;Hunk_End
	beq.b	.loop
	bra.b	nobject

.RELOC	move.l	(a1)+,d0
	beq.b	.loop
	addq.l	#1,d0
	lsl.l	#2,d0
	add.l	d0,a0
	bra.b	.reloc

.BSS	subq.w	#1,d1
	bmi.b	.test
	addq.l	#4,a1
	bra.b	.loop

.NAME	move.l	(a1)+,d0
	and.l	#$3fffffff,d0
	lsl.l	#2,d0
	add.l	d0,a1
	bra.b	.loop

.CODE	subq.w	#1,d1
	bmi.b	.test
	move.l	(a1)+,d0
	and.l	#$3fffffff,d0
	lsl.l	#2,d0
	add.l	d0,a1
	bra.b	.loop

.TEST	cmp.l	#$3ea,-4(a1)
	bne.b	nobject
	cmp.l	#"FLID",4(a1)
	bne.b	nobject
	move.l	(a1),d0
	addq.l	#4,d0			;Len_in_Header+Hunk_Data+Len+Hunk_End
	lsl.l	#2,d0
	sub.l	d0,UI_CrunchLenTemp(a4)

.COPY	cmp.l	UI_CrunchAdrTemp(a4),a0
	beq.b	.fin
	move.l	-(a0),4(a0)
	bra.b	.copy

.FIN	addq.l	#4,a0
	move.l	a0,UI_CrunchAdrTemp(a4)
	subq.l	#1,8(a0)
	subq.l	#1,16(a0)

; Ask For Password If Needed

NOBJECT	btst	#CRUB_Encryp,UI_CrunchType(a4)
	beq.b	passcon
	move.w	#UERR_PasswordReq,UI_ErrorNum(a4)
	tst.l	UI_Password(a4)
	beq.b	ownpass
	movem.l	d1-d7/a0-a6,-(sp)
	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a1
	move.l	UI_Password(a1),a0
	jsr	(a0)			;Call User Password Routine
	movem.l	(sp)+,d1-d7/a0-a6
	tst.l	d0
	beq.w	err

	move.l	d0,a0
	lea	UI_PasswordStr(a4),a1
COPPASS	move.b	(a0)+,(a1)+
	bne.b	coppass
	bra.b	tstpass


OWNPASS	bsr.w	getpass			;Get Password
	tst.l	d0
	beq.w	err
TSTPASS	moveq	#0,d0
	tst.b	UI_PasswordStr(a4)
	beq.w	err

; Start To Decrunch File

PASSCON	move.w	#UERR_Unpack,UI_ErrorNum(a4)
	move.l	UI_PackerStruct(a4),a3
	move.w	PS_Unpack(a3),d0
	beq.w	err
	lea	(a3,d0.w),a1
	move.w	#UERR_Memory,UI_ErrorNum(a4)

	movem.l	d1-d7/a0-a6,-(sp)
	move.l	UI_CrunchAdrTemp(a4),a0
	jsr	(a1)			;Unpack File
	bsr.w	cacclr			;Clear Caches
	movem.l	(sp)+,d1-d7/a0-a6
	tst.w	d0
	bne.b	noerr
	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)
	bra.b	err

NOERR	btst	#UFB_NoLoad,UI_Flag(a4)
	bne.b	noload1
	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_CrunchAdr(a4)
	clr.l	UI_CrunchAdrTemp(a4)
	clr.l	UI_CrunchLen(a4)
	clr.l	UI_CrunchLenTemp(a4)

NOLOAD1	bsr.b	unpaga			;Unpack Again (Recursive)
	bsr.w	cacclr			;Clear Caches

; Start User Routine

	tst.l	UI_Jump(a4)
	beq.b	clrup
	movem.l	d0-d7/a0-a6,-(sp)
	btst	#UFB_NoA4,UI_Flag(a4)
	bne.b	noa4
	move.l	UI_Jump(a4),a0
	move.l	UI_UserData(a4),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d0-d7/a0-a6
	bra.b	clrup

NOA4	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a2
	move.l	UI_Jump(a2),a0
	move.l	UI_UserData(a2),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d0-d7/a0-a6

; Clean Up

CLRUP	btst	#UFB_NoFree,UI_Flag(a4)
	bne.b	nofree1
	move.l	a4,a0
	jsr	upFreeFile(a6)

NOFREE1	moveq	#-1,d0

ERR	btst	#UFB_NoLoad,UI_Flag(a4)
	bne.b	err1
	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem			;Free Crunched File
	clr.l	UI_CrunchAdr(a4)
	clr.l	UI_CrunchAdrTemp(a4)
	clr.l	UI_CrunchLen(a4)
	clr.l	UI_CrunchLenTemp(a4)

ERR1	ext.l	d0
	bsr.w	ferr			;Find Error Message
	movem.l	(sp)+,d2-d7/a2-a6
	rts
;------------------------------------------------------------------------------
; Unpack Recursive
;

UNPAGA	movem.l	d0-d7/a0-a6,-(sp)
	jsr	upAllocCInfo(a6)
	tst.l	d0
	beq.w	unpagao
	move.l	d0,a3
	move.l	#2*256,d0
	bsr.w	alcmem			;Allocate Space To Filename
	move.l	d0,UI_Path(a3)
	beq.w	unpago1

	move.l	d0,a0
	move.l	UI_Path(a4),d7
	beq.b	unpaga2
	move.l	d7,a1
	move.w	#250-1,d7
UNPAGA1	move.b	(a1)+,(a0)+		;Copy Path
	dbeq	d7,unpaga1

	subq.l	#2,a0
	cmp.b	#":",(a0)+
	beq.b	unpaga2
	cmp.b	#"/",-1(a0)
	beq.b	unpaga2
	move.b	#"/",-1(a0)

UNPAGA2	move.b	#"-",(a0)+		;Directory Name
	lea	UI_LoadName(a4),a1
UNPAGA3	move.b	(a1)+,(a0)+		;Copy Filename
	bne.b	unpaga3
	move.b	#"/",-1(a0)
	clr.b	(a0)

	move.b	#UFN_NoFree!UFN_NoLoad,UI_Flag(a3)
	btst	#UFB_Delete,UI_Flag(a4)
	beq.b	unpaga4
	bset	#UFB_Delete,UI_Flag(a3)

UNPAGA4	move.l	UI_DecrunchAdr(a4),UI_CrunchAdr(a3)
	move.l	UI_DecrunchLen(a4),UI_CrunchLen(a3)
	lea	UI_LoadName(a4),a0
	move.l	a0,UI_Filename(a3)

	move.l	a3,a0
	sub.l	a1,a1
	jsr	upDetermineFile(a6)
	tst.w	d0
	beq.b	unpago2
	move.b	UI_CrunchType(a3),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Track,d0
	beq.b	unpago2
	cmp.b	#CRU_Archive,d0
	bne.b	unpaga5
	move.l	UI_Jump(a4),UI_Jump(a3)

UNPAGA5	move.l	a3,a0
	jsr	upUnpack(a6)
	tst.w	d0
	beq.b	unpago2

	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem			;Free Old File

	move.l	UI_DecrunchAdr(a3),UI_DecrunchAdr(a4)
	move.l	UI_DecrunchLen(a3),UI_DecrunchLen(a4)

	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	unpago2
	move.b	UI_CrunchType(a3),UI_CrunchType(a4)
	move.l	UI_CruncherName(a3),UI_CruncherName(a4)
	move.w	UI_CrunchNum(a3),UI_CrunchNum(a4)
	move.l	UI_Address(a3),UI_Address(a4)
	move.l	UI_JumpAdr(a3),UI_JumpAdr(a4)

UNPAGO2	move.l	UI_Path(a3),a1
	bsr.w	fremem

UNPAGO1	move.l	a3,a0
	jsr	upFreeCInfo(a6)

UNPAGAO	movem.l	(sp)+,d0-d7/a0-a6
	rts
;------------------------------------------------------------------------------
; Offset -54: TestHunk
;
; IN :	A0 = Start Address Of File To Test
;
; OUT:	D0 = Success (0=Error)
;

_TestHunk
	movem.l	d2-d7/a2-a6,-(sp)
	cmp.l	#$3f3,(a0)
	bne.b	tsthnk3

	lea	hjmptab(pc),a2
	moveq	#0,d7			;Number Of Hunks
	moveq	#0,d5			;Number Of Hunks Used For Hunk_End
TSTHNK1	move.l	(a0)+,d1
	and.l	#$3fffffff,d1
	cmp.l	#$03e7,d1
	blt.b	tsthnk2
	cmp.l	#$03fb,d1
	bgt.b	tsthnk2
	sub.l	#$03e7,d1
	add.w	d1,d1
	move.w	(a2,d1.w),d1
	jsr	(a2,d1.w)		;Jump To The Hunk Test Routine

	tst.l	d7
	bmi.b	tsthnk3			;Negative Hunk Number Left!!!
	tst.w	d0
	beq.b	tsthnk2			;We Get An Error, Make Extra Check
	tst.l	d5
	beq.b	tsthnk4
	bra.b	tsthnk1

TSTHNK2	tst.l	d7			;Well, If We Got An Error & No Hunks
	beq.b	tsthnk4			;Left, The File Is Ok!!

TSTHNK3	moveq	#0,d0
	bra.b	tsthnko

TSTHNK4	moveq	#-1,d0
TSTHNKO	movem.l	(sp)+,d2-d7/a2-a6
	rts

HJMPTAB	dc.w	h3e7-hjmptab,h3e8-hjmptab,h3e9-hjmptab,h3ea-hjmptab
	dc.w	h3eb-hjmptab,h3ec-hjmptab,h3ed-hjmptab,h3ee-hjmptab
	dc.w	h3ef-hjmptab,h3f0-hjmptab,h3f1-hjmptab,h3f2-hjmptab
	dc.w	h3f3-hjmptab,h3f4-hjmptab,h3f5-hjmptab,h3f6-hjmptab
	dc.w	h3f7-hjmptab,h3f8-hjmptab,h3f9-hjmptab,h3fa-hjmptab
	dc.w	h3fb-hjmptab

; Hunk_Code & Hunk_Data

H3E9
H3EA	subq.l	#1,d7

; Hunk_Unit, Hunk_Name & Hunk_Debug

H3E7
H3E8
H3F1
H3FA
H3FB	move.l	(a0)+,d1
	and.l	#$3fffffff,d1
	lsl.l	#2,d1
	add.l	d1,a0
	moveq	#-1,d0
	rts

; Hunk_End & Hunk_Break

H3F2	subq.l	#1,d5
H3F6	moveq	#-1,d0
	rts

; Hunk_BSS

H3EB	addq.l	#4,a0
	subq.l	#1,d7
	moveq	#-1,d0
	rts

; Hunk_Reloc32, Hunk_Reloc16 & Hunk_Reloc8

H3EC
H3ED
H3EE
H3F7
H3F8
H3F9	move.l	(a0)+,d1
	beq.b	h3ee1
	addq.l	#1,d1
	lsl.l	#2,d1
	add.l	d1,a0
	bra.b	h3ee
H3EE1	moveq	#-1,d0
	rts

; Hunk_Ext & Hunk_Symbol

H3EF
H3F0	move.b	(a0),d2
	move.l	(a0)+,d1
	beq.b	h3f6
	and.l	#$3fffffff,d1
	lsl.l	#2,d1
	add.l	d1,a0
	tst.b	d1			;Ext_Symb
	beq.b	h3ef
	cmp.b	#1,d1			;Ext_Def
	beq.b	h3ef
	cmp.b	#2,d1			;Ext_Abs
	beq.b	h3ef
	cmp.b	#3,d1			;Ext_Res
	beq.b	h3ef
	cmp.b	#129,d1			;Ext_Ref32
	beq.b	h3ef
	cmp.b	#130,d1			;Ext_Common
	beq.b	h3ef
	cmp.b	#131,d1			;Ext_Ref16
	beq.b	h3ef
	cmp.b	#132,d1			;Ext_Ref8
	beq.b	h3ef
	moveq	#0,d0
	rts

; Hunk_Header

H3F3	move.l	(a0)+,d1
	beq.b	h3f31
	lsl.l	#2,d1
	add.l	d1,a0
	bra.b	h3f3

H3F31	move.l	8(a0),d6
	sub.l	4(a0),d6
	addq.l	#1,d6
	add.l	d6,d7
	add.l	d6,d5

	addq.l	#3,d6
	lsl.l	#2,d6
	add.l	d6,a0
	moveq	#-1,d0
	rts

; Hunk_???

H3F4	moveq	#0,d0
	rts

; Hunk_Overlay

H3F5	move.l	(a0)+,d1
	beq.b	h3f52
	lsl.l	#2,d1
	lea	4(a0,d1.l),a0
H3F51	moveq	#-1,d0
	rts

H3F52	cmp.l	#$03f6,(a0)+
	bne.b	h3f51
	moveq	#0,d7
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Offset -60: UnpackNum
;
; IN :	Nothing
;
; OUT:	D0 = Library Version Number
;	D1 = Library Revision Number
;	D2 = Number Of Unpackers The Library Can Determine & Unpack
;	D3 = Number Of Different Unpackers
;

_UnpackNum
	lea	FirstStruct(pc),a0
	moveq	#0,d2
UNPNUM1	addq.w	#1,d2
	move.w	(a0),d0
	beq.b	unpnum2
	lea	(a0,d0.w),a0
	bra.b	unpnum1

UNPNUM2	moveq	#typenum,d3
	moveq	#UnpackVersion,d0
	moveq	#UnpackRevision,d1
	rts
;------------------------------------------------------------------------------
; Offset -66: UnpackList
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	A1 = Pointer To The First Unpacker Name
;

_UnpackList
	lea	FirstStruct(pc),a1
	move.l	a1,UI_LastNamePoi(a0)
	move.w	PS_Name(a1),d0
	lea	(a1,d0.w),a1
	rts
;------------------------------------------------------------------------------
; Offset -72: UnpackListNext
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	A1 = Pointer To The Next Unpacker Name
;	D0 = No More Unpackers (0=No More)
;

_UnpackListNext
	move.l	UI_LastNamePoi(a0),a1
	move.w	(a1),d0
	beq.b	unpliso
	lea	(a1,d0.w),a1
	move.l	a1,UI_LastNamePoi(a0)
	move.w	PS_Name(a1),d0
	lea	(a1,d0.w),a1
	moveq	#-1,d0
	rts

UNPLISO	moveq	#0,d0
	move.l	d0,a1
	rts
;------------------------------------------------------------------------------
; Offset -78: LoadFile
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	D0 = Success (0=Error)
;	If you get an error, you can see in the UI_ErrorType flag in the
;	crunch structure what went wrong.
;

_LoadFile
	movem.l	d2-d7/a2-a6,-(sp)
	move.l	a0,a4
	move.l	a6,a5

	move.w	#UERR_Open,UI_ErrorNum(a4)
	move.l	LIB_DosBase(a6),a6
	move.l	UI_FileName(a4),d1
	move.l	#1005,d2
	jsr	Open(a6)
	move.l	d0,UI_FileHandler(a4)	;Open File
	beq.b	ldfilo

	move.l	d0,d1
	moveq	#0,d2
	moveq	#1,d3			;End
	jsr	Seek(a6)		;Get A 0 (Have To)

	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#-1,d3			;Beginning
	jsr	Seek(a6)		;Get File Length

	move.l	d0,UI_DecrunchLen(a4)
	beq.b	ldfil1

	move.w	#UERR_Memory,UI_ErrorNum(a4)
	bsr.w	alcmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	ldfil1

	move.w	#UERR_ReadWrite,UI_ErrorNum(a4)
	move.l	UI_FileHandler(a4),d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Read(a6)		;Read The File
	cmp.l	#-1,d0			;Read/Write Error
	bne.b	ldfil1			;Nup!
	exg	a5,a6
	move.l	a4,a0
	jsr	upFreeFile(a6)
	exg	a5,a6
	moveq	#0,d0

LDFIL1	move.l	d0,-(sp)
	move.l	UI_FileHandler(a4),d1
	jsr	Close(a6)		;Close File
	clr.l	UI_FileHandler(a4)
	move.l	(sp)+,d0

LDFILO	bsr.w	cacclr			;Clear Caches
	bsr.w	ferr			;Find Error Message
	movem.l	(sp)+,d2-d7/a2-a6
	rts
;------------------------------------------------------------------------------
; Offset -84: FreeFile
;
; IN :	A0 = Crunch Info Start Address
;
; OUT:	Nothing
;

_FreeFile
	move.l	UI_DecrunchAdr(a0),a1
	bsr.w	fremem

	IF	OBJ<>0
	clr.l	UI_DecrunchAdr(a0)
	clr.l	UI_DecrunchLen(a0)
	ENDC
	rts
;------------------------------------------------------------------------------
; Offset -90: UseDrive
;
; IN :	A0 = Crunch Info Structure
;	A1 = Pointer To Drive Name
;
; OUT:	D0 = Pointer To Device Structure or Zero For An Error
;

_UseDrive
	movem.l	d2-d3/d6-d7/a2-a6,-(sp)
	move.l	a0,a4

	move.l	a6,-(sp)
	move.l	LIB_DosBase(a6),a2
	move.l	DosBase_Root(a2),a2
	move.l	RootNode_Info(a2),d0
	lsl.l	#2,d0
	move.l	d0,a2
	move.l	DosInfo_DevInfo(a2),d0
	lsl.l	#2,d0
	move.l	d0,a2
	move.w	#UERR_Device,UI_ErrorNum(a4)
	moveq	#0,d0

; Search For The Name

USEDRI1	tst.l	DeviceNode_Type(a2)
	bne.b	usedri4
	move.l	DeviceNode_Name(a2),d6
	lsl.l	#2,d6
	move.l	d6,a3
	move.l	a1,a5
	moveq	#0,d7
	move.b	(a3)+,d7		;Get Length Of String
	subq.w	#1,d7
USEDRI2	move.b	(a5)+,d6
	cmp.b	#"A",d6
	blt.b	usedri3
	and.b	#%11011111,d6
USEDRI3	cmp.b	(a3)+,d6
	bne.b	usedri4
	dbra	d7,usedri2
	bra.b	usedri5			;Found Drive!

USEDRI4	tst.l	(a2)
	beq.w	usedrio
	move.l	(a2),d6
	lsl.l	#2,d6
	move.l	d6,a2
	bra.b	usedri1

; Drive Found!!

USEDRI5	move.l	DeviceNode_Startup(a2),d1
	beq.w	usedrio			;No Device!!!
	lsl.l	#2,d1
	move.l	d1,a2
	move.l	(a2),d2			;Unit
	move.l	FileSysStartupMsg_Flags(a2),d3
	move.l	FileSysStartupMsg_Device(a2),d6
	lsl.l	#2,d6
	move.l	d6,a2			;Device Name As BPTR
	move.l	a1,a3			;Drive Name

; Init I/O Structures

	move.w	#UERR_Memory,UI_ErrorNum(a4)
	move.l	#DriveStruct_SIZEOF,d0
	bsr.w	alcmem
	tst.l	d0
	beq.b	usedrio
	move.l	d0,-(sp)
	move.l	d0,a5
	move.l	a4,DRV_UnpackInfo(a5)

	lea	DRV_DevName(a5),a0
	moveq	#0,d7
	move.b	(a2)+,d7
	subq.w	#1,d7
USEDRI6	move.b	(a2)+,(a0)+
	dbra	d7,usedri6
	clr.b	(a0)

	lea	DRV_DriveName(a5),a0
	moveq	#6-1,d7
USEDRI7	move.b	(a3)+,(a0)+
	dbeq	d7,usedri7

	move.w	#UERR_DevOpen,UI_ErrorNum(a4)
	move.l	LIB_SysBase(a6),a6
	sub.l	a1,a1
	jsr	FindTask(a6)
	lea	DRV_MsgPort(a5),a1
	move.l	d0,MsgPort_SigTask(a1)
	jsr	AddPort(a6)

	lea	DRV_IOStdReq(a5),a1
	move.l	d2,d0			;Unit
	move.l	d3,d1			;Flags
	lea	DRV_DevName(a5),a0
	jsr	OpenDevice(a6)		;Open Device
	tst.l	d0
	beq.b	usedri8
	move.l	(sp)+,a1
	bsr.w	fremem
	moveq	#0,d0
	bra.b	usedrio

USEDRI8	lea	DRV_IOStdReq(a5),a1
	lea	DRV_MsgPort(a5),a0
	move.l	a0,Message_ReplyPort(a1)

	move.l	4(sp),a6		;Unpack Base Address
	lea	DRV_DriveName(a5),a0
	moveq	#-1,d0
	bsr.b	drbusy			;Make Drive Busy
	move.l	(sp)+,d0

USEDRIO	addq.l	#4,sp
	bsr.w	ferr
	movem.l	(sp)+,d2-d3/d6-d7/a2-a6
	rts
;------------------------------------------------------------------------------
; Offset -96: UnuseDrive
;
; IN :	A0 = Drive Structure
;
; OUT:	Nothing
;

_UnuseDrive
	movem.l	a5-a6,-(sp)
	move.l	a0,d0
	beq.b	unuseo
	move.l	d0,a5

	lea	DRV_DriveName(a5),a0
	moveq	#0,d0
	bsr.b	drbusy			;Make Drive UnBusy

	move.l	LIB_SysBase(a6),a6
	lea	DRV_IOStdReq(a5),a1
	move.w	#9,IOStdReq_Command(a1)	;Stop The Motor
	clr.l	IOStdReq_Length(a1)
	jsr	DoIO(a6)

	lea	DRV_MsgPort(a5),a1
	jsr	RemPort(a6)
	lea	DRV_IOStdReq(a5),a1
	jsr	CloseDevice(a6)

	move.l	a5,a1
	bsr.w	fremem

UNUSEO	movem.l	(sp)+,a5-a6
	rts
;------------------------------------------------------------------------------
; Make Drive BUSY
;
; IN :	A0 = Drive Name
;	D0 = On/Off Flag (0=On)
;
; OUT:	Nothing
;

	STRUCTURE BusyStruct,0
	STRUCT	BY_Message,Message_SIZEOF
	STRUCT	BY_DosPacket,DosPacket_SIZEOF
	LABEL	BusyStruct_SIZEOF


DRBUSY	movem.l	d7/a2/a4-a6,-(sp)
	move.l	a6,a5
	move.l	d0,d7
	move.l	a0,a4

	move.l	LIB_SysBase(a5),a6
	moveq	#BusyStruct_SIZEOF,d0
	bsr.w	alcmem
	tst.l	d0
	beq.b	drbusyo
	move.l	d0,-(sp)

	sub.l	a1,a1
	jsr	FindTask(a6)
	move.l	d0,-(sp)

	move.l	4(sp),a2		;Packet Address
	lea	BY_DosPacket(a2),a0
	move.l	a0,Message_Node+Node_Name(a2)
	move.l	a2,BY_DosPacket+DosPacket_Link(a2)

	move.l	(sp),a0			;Task
	lea	Process_MsgPort(a0),a0
	move.l	a0,BY_DosPacket+DosPacket_Port(a2)
	move.l	#31,BY_DosPacket+DosPacket_Type(a2);Inhibit
	move.l	d7,BY_DosPacket+DosPacket_Arg1(a2) ;On/Off Flag

	move.l	LIB_DosBase(a5),a6
	move.l	a4,d1
	jsr	DeviceProc(a6)
	move.l	d0,a0
	move.l	a2,a1

	move.l	LIB_SysBase(a5),a6
	jsr	PutMsg(a6)
	move.l	(sp),a0
	lea	Process_MsgPort(a0),a0
	jsr	WaitPort(a6)
	move.l	(sp),a0
	lea	Process_MsgPort(a0),a0
	jsr	GetMsg(a6)

	addq.l	#4,sp
	move.l	(sp)+,a1
	bsr.w	fremem			;Free Packet Memory Again

DRBUSYO	movem.l	(sp)+,d7/a2/a4-a6
	rts
;------------------------------------------------------------------------------
; Offset -102: SendCmd
;
; IN :	A0 = Drive Structure
;	A1 = Start Address Of Data
;	D0 = Command
;	D1 = Offset
;	D2 = Length
;
; OUT:	D0 = Device Error Number
;

_SendCmd
	movem.l	d2/a2-a3/a6,-(sp)
	move.l	DRV_UnpackInfo(a0),a3
	move.w	#UERR_DevErr,UI_ErrorNum(a3)
	move.l	a1,a3

	move.l	LIB_SysBase(a6),a6
	lea	DRV_IOStdReq(a0),a1
	move.l	a1,a2
	move.w	d0,IOStdReq_Command(a1)
	move.l	a3,IOStdReq_Data(a1)
	move.l	d1,IOStdReq_Offset(a1)
	move.l	d2,IOStdReq_Length(a1)
	jsr	DoIO(a6)		;Send Command

	moveq	#0,d0
	move.b	IOStdReq_Error(a2),d0
	movem.l	(sp)+,d2/a2-a3/a6
	rts
;------------------------------------------------------------------------------
; Offset -108: NewUnpackNum
;
; IN :	Nothing
;
; OUT:	A0 = Pointer To Number Structure
;

_NewUnpackNum
	movem.l	d2-d3,-(sp)
	jsr	upUnpackNum(a6)
	lea	numstr(pc),a0
	move.w	d0,NS_Version(a0)
	move.w	d1,NS_Revision(a0)
	move.w	d3,NS_Types(a0)
	move.w	d2,NS_Unpackers(a0)
	movem.l	(sp)+,d2-d3
	rts

NUMSTR	blk.b	NumberStruct_SIZEOF,0
;------------------------------------------------------------------------------
; Offset -114: GetUnpacker
;
; IN :	A0 = Crunch Info Structure
;	D0 = Unpacker Number
;
; OUT:	D0 = Pointer To Unpacker List Structure
;

_GetUnpacker
	move.l	a2,-(sp)

	move.w	d0,d1
	sub.w	UI_GetUnpLastNum(a0),d0
	bpl.b	.getun1
	move.w	d1,d0
	lea	FirstStruct(pc),a1
	move.l	a1,UI_GetUnpLastName(a0)
.GETUN1	move.w	d1,UI_GetUnpLastNum(a0)

	move.l	UI_GetUnpLastName(a0),a1
	subq.w	#1,d0
	bmi.b	.getun3
.GETUN2	move.w	(a1),d1
	beq.b	.getuo1			;No More Entries
	lea	(a1,d1.w),a1
	dbra	d0,.getun2
.GETUN3	move.l	a1,UI_GetUnpLastName(a0)

	lea	UI_UnpList(a0),a0
	move.w	PS_Name(a1),d0
	lea	(a1,d0.w),a2
	move.l	a2,UL_Name(a0)

	move.w	PS_CrunchNumber(a1),UL_CrunchNum(a0)
	move.w	PS_TypeNumber(a1),UL_TypeNum(a0)
	move.b	PS_Type(a1),UL_Type(a0)

	clr.b	UL_Flags(a0)
	btst	#PSFB_Encrypted,PS_Flags(a1)
	beq.b	.getun4
	bset	#ULFB_Encrypted,UL_Flags(a0)

.GETUN4	move.l	a0,d0
	bra.b	.getuno

.GETUO1	moveq	#0,d0
.GETUNO	move.l	(sp)+,a2
	rts
;------------------------------------------------------------------------------
;******************************************************************************
;* Subroutines                                                                *
;******************************************************************************
;------------------------------------------------------------------------------
; Allocate Memory
;
; IN :	D0 = Size In Bytes
;
; OUT:	D0 = Address Or Zero For Error
;

ALCDMEM	movem.l	d1-d2/a0-a1/a6,-(sp)	;Allocate Decrunch Memory
	move.l	#$10001,d1
	btst	#UFB_ChipMem,UI_Flag(a4)
	beq.b	alcmem1
	move.l	#$10002,d1
	bra.b	alcmem1

ALCCMEM	movem.l	d1-d2/a0-a1/a6,-(sp)	;Allocate Chip Memory
	move.l	#$10002,d1
	bra.b	alcmem1

ALCMEM	movem.l	d1-d2/a0-a1/a6,-(sp)	;Allocate Any Memory
	move.l	#$10001,d1

ALCMEM1	move.l	4.w,a6
	addq.l	#4,d0
	move.l	d0,d2
	jsr	AllocMem(a6)
	tst.l	d0
	beq.b	alcmemo
	move.l	d0,a0
	move.l	d2,(a0)+
	move.l	a0,d0
ALCMEMO	movem.l	(sp)+,d1-d2/a0-a1/a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Free Memory
;
; IN :	A1 = Memory Address
;
; OUT:	Nothing
;

FREMEM	movem.l	d0-d1/a0-a1/a6,-(sp)
	move.l	a1,d0
	beq.b	frememo

	move.l	4.w,a6
	move.l	-(a1),d0
	jsr	FreeMem(a6)
FREMEMO	movem.l	(sp)+,d0-d1/a0-a1/a6
	rts
;------------------------------------------------------------------------------
; Clear Caches
;
; IN :	Nothing
;
; OUT:	Nothing
;

CACCLR	movem.l	d0-d1/a0-a1/a6,-(sp)

	move.l	4.w,a6
	cmp.w	#37,Library_Version(a6)
	blt.b	cacclro
	jsr	CacheClearU(a6)		;Clear Caches

CACCLRO	movem.l	(sp)+,d0-d1/a0-a1/a6
	rts
;------------------------------------------------------------------------------
; Find Error Message
;
; IN :	A4 = Unpack Structure
;	D0 = Success
;
; OUT:	Nothing
;

FERR	tst.l	d0
	beq.b	ferr1
	clr.w	UI_ErrorNum(a4)
	clr.l	UI_ErrorMsg(a4)
	rts

FERR1	lea	errtab-2(pc),a0
	move.w	UI_ErrorNum(a4),d1
	add.w	d1,d1
	move.w	(a0,d1.w),d1
	lea	2(a0,d1.w),a0
	move.l	a0,UI_ErrorMsg(a4)
	rts

ERRTAB	dc.w	opnmsg-errtab,rdwrmsg-errtab,memmsg-errtab
	dc.w	detmsg-errtab,passmsg-errtab,hunkmsg-errtab
	dc.w	extmsg-errtab,curmsg-errtab,devmsg-errtab
	dc.w	dopnmsg-errtab,crcmsg-errtab,chkmsg-errtab
	dc.w	oldmsg-errtab,derrmsg-errtab,prtmsg-errtab
	dc.w	outmsg-errtab,olibmsg-errtab,unkmsg-errtab
	dc.w	unpmsg-errtab,rpasmsg-errtab,dirmsg-errtab

OPNMSG	dc.b	"Can't open file",0
RDWRMSG	dc.b	"Read/Write error",0
MEMMSG	dc.b	"Out of memory",0
DETMSG	dc.b	"Unable to identify",0
PASSMSG	dc.b	"Illegal password",0
HUNKMSG	dc.b	"Error in hunk structure",0
EXTMSG	dc.b	"Extern error occurs",0
CURMSG	dc.b	"Crunched data is corrupt",0
DEVMSG	dc.b	"Illegal device",0
DOPNMSG	dc.b	"Couldn't open device or create port",0
CRCMSG	dc.b	"CRC checksum error",0
CHKMSG	dc.b	"Checksum error",0
OLDMSG	dc.b	"Decruncher in library too old",0
DERRMSG	dc.b	"Error from device",0
PRTMSG	dc.b	"Couldn't set protection bits to normal",0
OUTMSG	dc.b	"Couldn't open text output file",0
OLIBMSG	dc.b	"Couldn't open library",0
UNKMSG	dc.b	"Unknown error",0
UNPMSG	dc.b	"Can't unpack",0
RPASMSG	dc.b	"Password Required",0
DIRMSG	dc.b	"Can't make directory",0
	even
;------------------------------------------------------------------------------
; Get Password
;
; IN :	Nothing
;
; OUT:	D0 = Success (0=Error)
;

GETPASS	movem.l	d2-d7/a2-a6,-(sp)
	lea	UI_PasswordStr(a4),a5

	move.l	4.w,a3
	move.l	LIB_IntBase(a6),a6
	exg	a3,a6
	jsr	Forbid(a6)

	lea	paswin(pc),a0
	move.l	IntuitionBase_ActiveScreen(a3),a1;Get Active Screen Handler
	move.l	a1,30(a0)		;And Store It
	move.w	Screen_Width(a1),d0
	move.w	Screen_Height(a1),d1
	sub.w	#160,d0
	sub.w	#10,d1
	lsr.w	#1,d0
	lsr.w	#1,d1
	sub.w	#30,d1
	move.w	d0,(a0)
	move.w	d1,2(a0)
	jsr	Permit(a6)

	exg	a3,a6
	jsr	OpenWindow(a6)
	move.l	d0,-(sp)
	move.l	d0,a2
	move.l	Window_UserPort(a2),a2
	exg	a3,a6

GETPAS1	move.l	a2,a0
	jsr	WaitPort(a6)
	move.l	a2,a0
	jsr	GetMsg(a6)
	move.l	d0,a1
	move.w	IntuiMessage_Code(a1),d5;Get Key
	jsr	ReplyMsg(a6)
	cmp.b	#13,d5			;Return?
	beq.b	getpas2			;Yup!
	move.b	d5,(a5)+
	bra.b	getpas1

GETPAS2	clr.b	(a5)			;Null Terminate Password
	exg	a3,a6
	move.l	(sp)+,a0
	jsr	CloseWindow(a6)
	moveq	#-1,d0

GETPASO	movem.l	(sp)+,d2-d7/a2-a6
	rts

PASWIN	dc.w	0,0,160,10
	dc.b	2,1
	dc.l	$200000,$11006,0,0,wintit,0,0
	dc.w	0,0,0,0,15

WINTIT	dc.b	"Password",0
	even
;------------------------------------------------------------------------------
; Find Output File
;

FDOUT	move.l	a6,-(sp)
	move.w	#UERR_Output,UI_ErrorNum(a4)

	move.l	LIB_DosBase(a5),a6
	lea	UI_OutputFile(a4),a2
	move.b	#"0",13(a2)
	move.b	#"0",14(a2)
	moveq	#0,d7

FDOUT1	move.l	a2,d1
	move.l	#1005,d2
	jsr	Open(a6)		;File Exists?
	move.l	d0,d6
	beq.b	fdout2

	move.l	d0,d1
	jsr	Close(a6)		;Close File

	addq.b	#1,14(a2)
	cmp.b	#$3a,14(a2)
	bne.b	fdout1
	move.b	#"0",14(a2)
	addq.b	#1,13(a2)

	cmp.b	#$3a,13(a2)
	bne.b	fdout1
	bra.b	fdouto

FDOUT2	moveq	#-1,d7
FDOUTO	move.l	(sp)+,a6
	tst.w	d7
	rts
;------------------------------------------------------------------------------
; Execute String
;

EXESTR	move.l	a6,-(sp)
	bsr.w	cacclr			;Clear Caches
	move.l	LIB_DosBase(a5),a6
	move.l	#nilname,d1
	move.l	#1004,d2
	jsr	Open(a6)		;Open NIL:
	move.l	d0,-(sp)

	lea	UI_ExecuteString(a4),a0
	move.l	a0,d1			;String
	move.l	(sp),d2			;Input
	moveq	#0,d3			;Output
	jsr	Execute(a6)

	jsr	IoErr(a6)		;Get Error Number
	not.l	d0
	cmp.l	#-1,d0
	beq.b	exestr1
	moveq	#0,d0

EXESTR1	move.l	d0,d7
	move.l	(sp)+,d1
	jsr	Close(a6)		;Close NIL:
	move.l	(sp)+,a6
	move.l	d7,d0
	rts

NILNAME	dc.b	"NIL:",0
	even
;------------------------------------------------------------------------------
; Scan Directory And Load File
;
; IN :	A0 = Pointer To An Archive Reader Routine
;
; OUT:	D0 = Success (0=Error)
;

SCANDIR	move.l	a6,-(sp)
	move.l	a0,-(sp)

	move.l	LIB_DosBase(a5),a6
	lea	UI_OutputFile(a4),a3

	move.l	a3,d1
	move.l	#1005,d2
	jsr	Open(a6)		;Open Output File
	move.l	d0,d6
	beq.w	scoerr

	move.l	d6,d1
	moveq	#0,d2
	moveq	#1,d3			;End
	jsr	Seek(a6)
	move.l	d6,d1
	moveq	#0,d2
	moveq	#-1,d3			;Beginning
	jsr	Seek(a6)
	move.l	d0,d7			;Number Of Bytes

	bsr.w	alcmem			;Allocate Output File
	bne.b	scand1
	move.l	d6,d1
	jsr	Close(a6)		;Close File
	bra.w	scmerr

SCAND1	move.l	d0,-(sp)
	move.l	d0,d2
	move.l	d7,d3
	move.l	d6,d1
	jsr	Read(a6)		;Read Output File

	move.l	d0,-(sp)
	move.l	d6,d1
	jsr	Close(a6)		;Close File
	move.l	(sp)+,d0

	cmp.l	#-1,d0
	bne.b	scand2
	move.l	(sp)+,a1
	bsr.w	fremem			;Free Output File
	bra.b	screrr

SCAND2	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Lock(a4)
	bne.b	scand3

	move.l	(sp)+,a1
	bsr.w	fremem			;Free Output File
	bra.b	sceerr

SCAND3	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,UI_OldLock(a4)

	move.l	(sp),a0
	lea	scanjmp(pc),a1
	move.l	4(sp),a2
	jsr	(a2)			;Scan Output From Archive Decruncher

	move.l	(sp)+,a1
	bsr.w	fremem			;Free Output File

; Get Out

	move.l	UI_OldLock(a4),d1
	jsr	CurrentDir(a6)
	move.l	UI_Lock(a4),d1
	jsr	UnLock(a6)

	moveq	#-1,d0
SCANOUT	move.l	d0,-(sp)
	bsr.w	udel			;Delete All Files Again

	move.l	LIB_DosBase(a5),a6
	lea	UI_OutputFile(a4),a0
	move.l	a0,d1
	jsr	DeleteFile(a6)		;Delete Output File
	move.l	(sp)+,d0

	addq.l	#4,sp
	move.l	(sp)+,a6
	tst.l	d0
	rts

; Memory Error

SCMERR	move.w	#UERR_Memory,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	scanout

; Output Error

SCOERR	move.w	#UERR_Output,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	scanout

; Read/Write Error

SCRERR	move.w	#UERR_ReadWrite,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	scanout

; Extern Error

SCEERR	move.w	#UERR_Extern,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	scanout
;------------------------------------------------------------------------------
; Read One File
;

SCANJMP	move.l	LIB_DosBase(a5),a6
	lea	UI_LoadName(a4),a3
	cmp.b	#"*",(a3)		;Display Text File?
	beq.w	scanjmo			;Yap!

	move.l	a3,d1
	move.l	#1005,d2
	jsr	Open(a6)		;Open File
	move.l	d0,UI_FileHandler(a4)
	beq.w	scanjmo

	move.l	d0,d1
	moveq	#0,d2
	moveq	#1,d3			;End
	jsr	Seek(a6)
	move.l	UI_FileHandler(a4),d1
	moveq	#0,d2
	moveq	#-1,d3			;Beginning
	jsr	Seek(a6)
	move.l	d0,d7			;Number Of Bytes

	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcmem			;Allocate File
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	scanjmo

	move.l	UI_FileHandler(a4),d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Read(a6)

	move.l	d0,-(sp)
	move.l	UI_FileHandler(a4),d1
	jsr	Close(a6)
	clr.l	UI_FileHandler(a4)
	move.l	(sp)+,d0
	cmp.l	#-1,d0
	beq.b	scanjm1

	move.l	a6,-(sp)
	move.l	a5,a6
	bsr.w	unpaga			;Unpack Again
	move.l	(sp)+,a6

	st	UI_UseFilenamePointer(a4)
	tst.l	UI_Jump(a4)
	beq.b	scanjm1
	movem.l	d0-d7/a0-a6,-(sp)
	btst	#UFB_NoA4,UI_Flag(a4)
	bne.b	.noa4
	move.l	UI_Jump(a4),a0
	move.l	UI_UserData(a4),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d0-d7/a0-a6
	bra.b	scanjm1

.NOA4	move.l	a4,-(sp)
	movem.l	UI_Registers(a4),d0-d7/a0-a6
	move.l	(sp)+,a2
	move.l	UI_Jump(a2),a0
	move.l	UI_UserData(a2),a1
	jsr	(a0)			;Call User Routine
	movem.l	(sp)+,d0-d7/a0-a6

SCANJM1	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem			;Free File
	clr.l	UI_DecrunchAdr(a4)
SCANJMO	rts
;------------------------------------------------------------------------------
; Delete All Files Again
;

UDEL	btst	#UFB_Delete,UI_Flag(a4)	;Delete?
	beq.w	dellpo1			;Nip!!

	move.l	a6,-(sp)

	move.l	#260,d0
	bsr.w	alcmem			;Allocate Info Structure
	move.l	d0,UI_InfoAdr(a4)

	move.l	LIB_DosBase(a5),a6
	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Lock(a4)

	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,UI_OldLock(a4)

	moveq	#0,d7			;Number Of Under Directories

; Delete Loop

DELLOP	move.l	UI_Lock(a4),d1
	move.l	UI_InfoAdr(a4),d2
	jsr	Examine(a6)

DELLOP0	move.l	UI_Lock(a4),d1
	move.l	UI_InfoAdr(a4),d2
	jsr	ExNext(a6)
	tst.l	d0
	beq.b	dellop3

	move.l	UI_InfoAdr(a4),a0
	addq.l	#8,a0			;Filename
	move.l	a0,d1
	jsr	DeleteFile(a6)
	tst.l	d0
	bne.b	dellop

	move.l	UI_InfoAdr(a4),a0
	tst.l	4(a0)			;Directory?
	bmi.b	dellop3			;Nop!

	jsr	IOErr(a6)
	cmp.w	#202,d0			;Object In Use?
	beq.b	dellop0			;Yip!

	addq.w	#1,d7
	move.l	UI_OldLock(a4),-(sp)
	move.l	UI_Lock(a4),-(sp)
	move.l	UI_InfoAdr(a4),-(sp)

	move.l	#260,d0
	bsr.w	alcmem			;Allocate Info Structure
	move.l	d0,UI_InfoAdr(a4)

	move.l	(sp),a0
	addq.l	#8,a0
	move.l	a0,d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock New Directory
	move.l	d0,UI_Lock(a4)

	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,UI_OldLock(a4)
	bra.b	dellop

DELLOP3	move.l	UI_OldLock(a4),d1
	jsr	CurrentDir(a6)

	move.l	UI_InfoAdr(a4),a1
	bsr.w	fremem			;Free Info Structure

	move.l	UI_Lock(a4),d1
	jsr	UnLock(a6)
	tst.w	d7
	beq.b	dellopo
	subq.w	#1,d7
	move.l	(sp)+,UI_InfoAdr(a4)
	move.l	(sp)+,UI_Lock(a4)
	move.l	(sp)+,UI_OldLock(a4)
	bra.w	dellop

; Get Out

DELLOPO	move.l	UI_OldLock(a4),d1
	jsr	CurrentDir(a6)
	move.l	(sp)+,a6
DELLPO1	rts
;------------------------------------------------------------------------------
; Find Next Hunk
;
; IN :	A0 = Start Of Data
;
; OUT:	A0 = Pointer To Next Hunk
;	D0 = Success (0=Error)
;

NXTHUNK	cmp.l	#$3f3,(a0)
	bne.b	.err
	move.l	16(a0),d0
	sub.l	12(a0),d0
	lsl.l	#2,d0
	lea	32(a0,d0.l),a0
	moveq	#-1,d0
	rts

.ERR	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Check Routine
;
; IN :	D1 = Offset
;	D2 = Number Of Longwords - 1
;	A0 = Pointer To Data
;	A1 = Pointer To Check Table
;
; OUT:	D0 = Success (0=Error)
;

CHKTAB	moveq	#0,d0
	lea	(a0,d1.w),a2
	cmpm.l	(a1)+,(a2)+
	beq.b	chktab2
	subq.l	#4,a1
CHKTAB1	cmpm.l	(a1)+,(a2)+
	bne.b	chktab3
CHKTAB2	dbra	d2,chktab1
	moveq	#-1,d0
CHKTAB3	tst.w	d0
	rts
;------------------------------------------------------------------------------
;******************************************************************************
;* Unpacker Routines                                                          *
;******************************************************************************
;------------------------------------------------------------------------------
; This structure is for each unpacker:
;
; WORD  Pointer To Next Structure Or Null
; WORD  Pointer To The Name
; UWORD Crunch Number
; UWORD Type Number
; UBYTE Type
; UBYTE Flags
; WORD  Minimum File Size
; ULONG Test Data
; WORD  Pointer To Determine Table/Routine
; WORD  Pointer To Unpack Routine
; WORD  Pointer To Disk Unpack Routine
;
; All routines will be called with these parameters:
;
; A0 = Pointer To Crunched Data
; A1 = Pointer To Own Function
; A3 = Pointer To PackerStruct
; A4 = Pointer To CrunchStruct
;

FirstStruct
TYPENUM	SET	0

PSNAME	MACRO
	dc.b	\1
	dc.b	0
	even
	ENDM
;------------------------------------------------------------------------------
	INCDIR	".ASources:Utilities/Unpack/Sources/Decrunchers/"
	INCLUDE	"ANC-Cruncher.S"
	INCLUDE	"ByteKiller.S"
	INCLUDE	"Chryseis Cruncher.S"
	INCLUDE	"Crunch Master.S"
	INCLUDE	"Crunch-Mania.S"
	INCLUDE	"Crunch-o-Matic.S"
	INCLUDE	"Defjam.S"
	INCLUDE	"Discovery File Imploder.S"
	INCLUDE	"Dms.S"
	INCLUDE	"Double Action.S"
	INCLUDE	"DragPack.S"
	INCLUDE	"FlashSpeed.S"
	INCLUDE	"GnuPacker.S"
	INCLUDE	"High Pressure Cruncher.S"
	INCLUDE	"House.S"
	INCLUDE	"HQC.S"
	INCLUDE	"IAM Packer.S"
	INCLUDE	"Imploder.S"
	INCLUDE	"ISC.S"
	INCLUDE	"Lha.S"
	INCLUDE	"LightPack.S"
	INCLUDE	"Lzx.S"
	INCLUDE	"MasterCruncher.S"
	INCLUDE	"MaxPacker.S"
	INCLUDE	"MegaCruncher.S"
	INCLUDE	"P-Compress.S"
	INCLUDE	"PackIt.S"
	INCLUDE	"Pak.S"
	INCLUDE	"PHD.S"
	INCLUDE	"PMC.S"
	INCLUDE	"PowerPacker.S"
	INCLUDE	"ProPack.S"
	INCLUDE	"Relokit.S"
	INCLUDE	"S-Exec.S"
	INCLUDE	"SoundTracker Packed Song.S"
	INCLUDE	"Spike Cruncher.S"
	INCLUDE	"Stone Cracker.S"
	INCLUDE	"Super-Cruncher.S"
	INCLUDE	"SyncroPacker.S"
	INCLUDE	"TetraPack.S"
	INCLUDE	"TFA Cruncher.S"
	INCLUDE	"Time Cruncher.S"
	INCLUDE	"Titanics Cruncher.S"
	INCLUDE	"TNM Cruncher.S"
	INCLUDE	"Trash Eliminator.S"
	INCLUDE	"TryIt.S"
	INCLUDE	"TUC.S"
	INCLUDE	"TurboSqueezer.S"
	INCLUDE	"Turtle Smasher.S"
	INCLUDE	"Ultimate Packer.S"
	INCLUDE	"XPK.S"
;------------------------------------------------------------------------------
ALCDMEMJ	jmp	alcdmem
ALCMEMJ		jmp	alcmem
FREMEMJ		jmp	fremem
CHKTABJ		jmp	chktab
BYTUNP1J	jmp	bytunp1
BYTCHKJ		jmp	bytchk
;------------------------------------------------------------------------------
; Tables

	SECTION	Tables,DATA

	INCDIR	".ASources:Utilities/Unpack/Sources/Tables/"
	INCLUDE	"LH.S"
	INCLUDE	"Dms.S"
;------------------------------------------------------------------------------
SLUT

	IF	OBJ=0

	JUMPPTR	run
;	AUTO	jrun


RUN	lea	base(pc),a6
	move.l	a6,d0
	jsr	init

	jsr	upAllocCInfo(a6)
	move.l	d0,infohd
	beq.b	.err1
	move.l	d0,a4

; Start Decrunching

	move.l	#path,UI_Path(a4)
	move.l	#pattern,UI_LhaPattern(a4)
	move.l	#hej,UI_Jump(a4)
;	move.l	#unpsave,UI_Jump(a4)
	move.l	#hej,UI_TrackJump(a4)
	move.b	#UFN_Delete,UI_Flag(a4)

	move.l	a4,a0
	lea	fname(pc),a1
	jsr	upDetermineFile(a6)
	tst.l	d0
	beq.b	.err
	move.l	a4,a0
	jsr	upUnpack(a6)

.ERR	move.l	a4,a0
	jsr	upFreeCInfo(a6)

.ERR1	jsr	expunge
	rts

; Scan For Virus

hej	move.w	#$8000,d7
hej1	move.w	d7,d6
	and.w	#$0fff,d6
	move.w	d6,$dff180
	dbra	d7,hej1
	addq.l	#1,hej2
	moveq	#0,d0
	rts

hej2	dc.l	0



UNPSAVE	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	unpsavo

	move.l	base+lib_dosbase(pc),a6
	move.l	UI_LoadNamePoi(a4),d1
	move.l	#1006,d2
	jsr	Open(a6)
	tst.l	d0
	beq.b	unpsavo

	move.l	d0,-(sp)
	move.l	d0,d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Write(a6)

	move.l	(sp)+,d1
	jsr	Close(a6)
UNPSAVO	rts


INFOHD	dc.l	0

PATH	dc.b	"Ram Disk:u/",0
FNAME	dc.b	"dat:!unp/_data/mega12.obj2",0
;	dc.b	"dat:!unp/_data/crash/imploder/implode.packed2",0
PATTERN	dc.b	0
	even


	jmp	_GetUnpacker
	jmp	_NewUnpackNum
	jmp	_SendCmd
	jmp	_UnuseDrive
	jmp	_UseDrive
	jmp	_FreeFile
	jmp	_LoadFile
	jmp	_UnpackListNext
	jmp	_UnpackList
	jmp	_UnpackNum
	jmp	_TestHunk
	jmp	_Unpack
	jmp	_DetermineFile
	jmp	_FreeCInfo
	jmp	_AllocCInfo

	jmp	0
	jmp	0
	jmp	0
	jmp	0

BASE	blk.b	LibraryStruct_SIZEOF,0
	ENDC
