; Unpacker Test Program
;

	INCDIR	"Includes3.0:Include3.0/"
	INCLUDE	"Own/Unpack.i"
	INCLUDE	"Own/SystemOffsets.i"
	INCLUDE	"Own/SystemStructures.i"

START	move.l	4.w,a6
	cmp.w	#37,Library_Version(a6)	;We Need Kickstart 37+
	blt.w	getout

; Open Libraries

	lea	dosname(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)		;Open Dos.library
	move.l	d0,dosbase
	beq.w	getout

	lea	unpname(pc),a1
	moveq	#39,d0
	jsr	OpenLibrary(a6)		;Open Unpack.library
	move.l	d0,unpbase
	bne.b	unpok
	move.l	dosbase(pc),a6
	move.l	#unperr,d1
	jsr	PutStr(a6)		;Write Error!!!
	bra.w	clsdos

; Get Arguments

UNPOK	move.l	dosbase(pc),a6
	move.l	#cliargs,d1
	move.l	#cliarr,d2
	moveq	#0,d3
	jsr	ReadArgs(a6)
	move.l	d0,argmem
	bne.b	argok
	jsr	IOErr(a6)		;Get Error Code
	move.l	d0,d1
	moveq	#0,d2
	jsr	PrintFault(a6)		;Print Error Code
	bra.w	clsunp

; Allocate Unpack Structure

ARGOK	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)	;Allocate Structure
	move.l	d0,unpstr
	beq.w	frearg

	move.l	d0,a0
	move.l	cliarr+4(pc),UI_Path(a0);Store Path (Used With LHA)
	move.l	#unpsav,UI_Jump(a0)	;Set Jump Pointer To My Save Routine
	move.b	#UFN_Protect,UI_Flag(a0);The Unpack.library Will Change The
					;Protection Bits.

; Start To Determine File

	move.l	cliarr(pc),a4		;Pointer To Pointer Table
LOOPIT	move.l	(a4),d1			;Pointer To Input Filename
	beq.w	frestr

	lea	-42(sp),sp
	move.l	(a4),a0
	moveq	#-1,d0
COUNT	tst.b	(a0)+
	dbeq	d0,count
	add.w	#40,d0
	move.l	sp,a0

	move.l	(a4),a1
COPNAM	move.b	(a1)+,(a0)+
	bne.b	copnam
	subq.l	#1,a0
MAKSPC	move.b	#" ",(a0)+
	dbra	d0,makspc

	move.l	dosbase(pc),a6
	jsr	Output(a6)

	move.l	d0,d1
	move.l	sp,d2
	moveq	#40,d3
	jsr	Write(a6)
	lea	42(sp),sp

	move.l	unpbase(pc),a6
	move.l	(a4)+,a1
	move.l	unpstr(pc),a0
	jsr	upDetermineFile(a6)
	tst.w	d0
	bne.b	detok
	bsr.w	prierr
	bra.b	loopit

DETOK	move.l	unpstr(pc),a0
	move.b	UI_CrunchType(a0),d0
	and.b	#$7f,d0			;Mask Out Encrypt Bit
	cmp.b	#CRU_Track,d0
	bne.b	detok1
	move.l	dosbase(pc),a6
	move.l	#ntrkerr,d1		;Well, We Can't Unpack Track Crunched
	jsr	PutStr(a6)		;Files, So We Print A Error If So!!
	bra.b	loopit

; Begin To Unpack File

DETOK1	move.l	unpstr(pc),a0
	jsr	upUnpack(a6)		;Unpack File & Save It
	tst.w	d0
	bne.b	unpok1
	bsr.b	prierr			;Print Error
	bra.w	loopit

UNPOK1	move.l	dosbase(pc),a6
	move.l	unpstr(pc),a0
	move.l	UI_CruncherName(a0),d1
	jsr	PutStr(a6)
	move.l	#crtxt,d1
	jsr	PutStr(a6)
	bra.w	loopit

; Free Unpack Structure

FRESTR	move.l	unpbase(pc),a6
	move.l	unpstr(pc),a0
	jsr	upFreeCInfo(a6)		;Free Structure

; Free Arguments

FREARG	move.l	dosbase(pc),a6
	move.l	argmem(pc),d1
	jsr	FreeArgs(a6)

; Close Libraries

CLSUNP	move.l	4.w,a6
	move.l	unpbase(pc),a1
	jsr	CloseLibrary(a6)	;Close Unpack.library

CLSDOS	move.l	4.w,a6
	move.l	dosbase(pc),a1
	jsr	CloseLibrary(a6)	;Close Dos.library

GETOUT	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Print Unpack Error
;

PRIERR	move.l	unpstr(pc),a0
	move.l	UI_ErrorMsg(a0),d1
	move.l	dosbase(pc),a6
	jsr	PutStr(a6)

	move.l	#crtxt,d1
	jsr	PutStr(a6)
	rts
;------------------------------------------------------------------------------
; Save Unpacked File
;

UNPSAV	lea	-2*108(sp),sp
	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	unpsavo

	move.l	UI_LoadNamePoi(a4),d1	;******YOU HAVE TO DO THIS IF YOU
	tst.b	UI_UseFilenamePointer(a4);*****WANT YOUR SCAN ROUTINE TO
	bne.b	unpsav1			;******HANDLE RECURSIVE, LIKE PP IN
	move.l	UI_Filename(a4),a0	;******A LHA FILE.
	move.l	a0,a1
UNPSA00	tst.b	(a0)+
	bne.b	unpsa00

UNPSA01	cmp.l	a0,a1
	beq.b	unpsa03
	cmp.b	#":",-(a0)
	beq.b	unpsa02
	cmp.b	#"/",(a0)
	bne.b	unpsa01
UNPSA02	addq.l	#1,a0

UNPSA03	move.l	cliarr+4(pc),a1
	move.l	sp,a2
UNPSA04	move.b	(a1)+,(a2)+		;Copy Path
	bne.b	unpsa04
	subq.l	#1,a2

	cmp.b	#":",-1(a2)
	beq.b	unpsa05
	cmp.b	#"/",-1(a2)
	beq.b	unpsa05
	move.b	#"/",(a2)+
UNPSA05	move.b	(a0)+,(a2)+		;Copy Filename
	bne.b	unpsa05

UNPSAV1	move.l	dosbase(pc),a6
	move.l	sp,d1
	move.l	#1006,d2
	jsr	Open(a6)
	move.l	d0,d7
	beq.b	unpsavo

	move.l	d7,d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Write(a6)		;Write Decrunched File

	move.l	d7,d1
	jsr	Close(a6)
UNPSAVO	lea	2*108(sp),sp
	rts
;------------------------------------------------------------------------------
DOSNAME	dc.b	"dos.library",0
UNPNAME	dc.b	"unpack.library",0

CLIARGS	dc.b	"FILES/M/A,P=PATH/K/A",0

UNPERR	dc.b	"You need unpack.library 39+"
CRTXT	dc.b	10,0
NTRKERR	dc.b	"Can't unpack track crunched files",10,0
	even
;------------------------------------------------------------------------------
DOSBASE	dc.l	0
UNPBASE	dc.l	0
ARGMEM	dc.l	0
UNPSTR	dc.l	0

CLIARR	blk.l	2,0
;------------------------------------------------------------------------------
SLUT
