; $VER: Unpacker V2.1e
; Startup Code For Kickstart 1.3/2.0/3.0
; Coded by Tax of Access
; Release Date: 28/02-1994
;

	INCDIR	"Includes3.0:Include3.0/"
	INCLUDE	"Own/SystemOffsets.i"
	INCLUDE	"Own/SystemStructures.i"
	INCLUDE	"Own/SystemBases.i"
	INCLUDE	"Own/Unpack.i"
	INCLUDE	"Own/Reqtools.i"
	INCLUDE	"Own/ARexx.i"
	INCLUDE	"Dos/Dostags.i"

CLIONLY	=	0			;Only CLI Code: 0=No  1=Yes

OBJ	=	1			;Object Code: 0=No  1=Yes
ARGS	=	1			;Arguments: 0=No  1=Yes
WINDOW	=	0			;Open Window: 0=No  1=Yes
KICK	=	0			;Kickstart 37 Startup: 0=No  1=Yes
BACK	=	1			;Run As Background: 0=No  1=Yes

PRI	=	0			;Process Priority
STACK	=	4000			;Stack Size

MS_Popup	=	1
MS_Unpack	=	2
MS_CtrlC	=	3
MS_LMB		=	4


TITLE	MACRO
	dc.b	"Unpacker V2.1e"
	ENDM

	AUTO	e\
	IF	OBJ=0
	JUMPPTR	prg
	AUTO	jprg
	ENDC

	IF	KICK=0
LIBNUM	=	0
	ELSE
LIBNUM	=	37
	ENDC

MenuNULL	=	$ffff


; Segment One

	SECTION	Startup,CODE

START	bra.b	run
;------------------------------------------------------------------------------
	dc.b	"This program was coded by Tax of Access in 1994.",0
	even
;------------------------------------------------------------------------------
RUN	IF	ARGS<>0
	move.l	a0,a5			;Store Pointer To Command Line
	move.l	d0,d7
	subq.l	#1,d7
	ENDC

	move.l	4.w,a6
	sub.l	a1,a1			;Clear Argument A1
	jsr	FindTask(a6)		;Get Pointer
	move.l	d0,a4			;Pointer To Process In A4

	lea	sdosnam(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)		;Open Dos.library
	move.l	d0,sdosbas
	beq.w	serror

	tst.l	$ac(a4)			;pr_CLI: CLI Or WorkBench?
	bne.w	itcli			;It Was CLI!!

;******************************************************************************
;*  WorkBench Startup
;******************************************************************************

	bsr.w	getwork			;Get Workbench Message

	IF	KICK<>0
	move.l	4.w,a6
	cmp.w	#libnum,20(a6)
	blt.w	kickerr
	ENDC

	move.l	workpoi,a2
	move.l	WBStartup_ArgList(a2),d0
	beq.w	noargs
	move.l	d0,a0
	move.l	WBArg_Lock(a0),d1
	move.l	sdosbas(pc),a6
	jsr	CurrentDir(a6)
	move.l	d0,wblock

	IF	ARGS<>0
	move.l	4.w,a6
	lea	siconam(pc),a1
	moveq	#libnum,d0
	jsr	OpenLibrary(a6)		;Open Icon.library
	move.l	d0,sicobas
	beq.w	serror1

	move.l	d0,a6
	move.l	WBStartup_ArgList(a2),a0
	move.l	WBArg_Name(a0),a0
	jsr	GetDiskObject(a6)	;Read The .info File
	move.l	d0,-(sp)
	move.l	d0,a2
	move.l	DiskObject_ToolTypes(a2),a2

; Make Argument Link

	move.l	a2,a0
	moveq	#4+2,d2
.ARCOU	tst.l	(a0)
	beq.b	.arend
	move.l	(a0)+,a1
	move.l	a1,d1
.ARCOU1	tst.b	(a1)+
	bne.b	.arcou1
	sub.l	d1,a1
	add.l	a1,d2
	bra.b	.arcou

.AREND	move.l	4.w,a6
	move.l	d2,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)		;Allocate Argument Memory
	move.l	d0,argsmem
	bne.b	.arok

; ERROR!!!!

	move.l	sicobas,a6
	move.l	(sp)+,a0
	jsr	FreeDiskObject(a6)	;Free Memory Again
	bra.w	serror1

; Ok

.AROK	move.l	d0,a0
	move.l	d2,(a0)+
	sf	(a0)+			;NULL=Workbench
.ARCOP	tst.l	(a2)
	beq.b	.arcope
	move.l	(a2)+,a1
.ARCOP1	move.b	(a1)+,(a0)+		;Copy Arguments
	bne.b	.arcop1
	bra.b	.arcop

.ARCOPE	clr.b	(a0)
	move.l	sicobas,a6
	move.l	(sp)+,a0
	jsr	FreeDiskObject(a6)	;Free Memory Again
	ENDC

; Open Window or NIL:

NOARGS	move.l	sdosbas(pc),a6

	IF	WINDOW=0
	move.l	#nilname,d1
	ELSE
	move.l	#winname,d1
	ENDC

	move.l	#1005,d2
	jsr	Open(a6)		;Open CON: Window
	move.l	d0,outbase
	beq.w	serror1

	IF	KICK<>0
	lea	cretags,a0
	move.l	d0,12(a0)
	move.l	d0,20(a0)
	ENDC

	bra.b	wecont			;We Continue

;******************************************************************************
;*  CLI Startup
;******************************************************************************

ITCLI	IF	KICK<>0
	move.l	4.w,a6
	cmp.w	#libnum,20(a6)
	blt.w	kickerr
	ENDC

	IF	ARGS<>0
	move.l	4.w,a6
	moveq	#4+2,d2
	add.l	d7,d2
	move.l	d2,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)		;Allocate Argument String
	move.l	d0,argsmem
	beq.w	serror

	move.l	d0,a0
	move.l	d2,(a0)+
	st	(a0)+			;-1=CLI

.ARCOP	move.b	(a5)+,d0
	cmp.b	#10,d0
	beq.b	.arcope
	cmp.b	#" ",d0
	beq.b	.arcop
	cmp.b	#9,d0
	beq.b	.arcop
	cmp.b	#34,d0
	beq.b	.doquo

.ARCOP1	move.b	d0,(a0)+
	move.b	(a5)+,d0
	cmp.b	#10,d0
	beq.b	.arcope
	cmp.b	#" ",d0
	beq.b	.arcop2
	cmp.b	#9,d0
	bne.b	.arcop1
.ARCOP2	clr.b	(a0)+
	bra.b	.arcop

.DOQUO	move.b	(a5)+,d0
	cmp.b	#10,d0
	beq.b	.arcope
	cmp.b	#34,d0
	beq.b	.arcop2
	move.b	d0,(a0)+
	bra.b	.doquo

.ARCOPE	clr.b	(a0)
	ENDC

;******************************************************************************
;*  Start A New Process
;******************************************************************************

WECONT	IF	BACK<>0
	move.l	argsmem,a0
	addq.l	#4,a0
	tst.b	(a0)+
	beq.b	wecont0

	IF	CLIONLY=0
	tst.b	(a0)
	beq.b	wecont0
	ENDC

	jsr	prg
	bra.b	wecont1

WECONT0	move.l	sdosbas(pc),a6
	lea	start-4(pc),a0
	move.l	(a0),d3			;Segment 2
	clr.l	(a0)

	IF	KICK=0
	move.l	#procnam,d1		;Name
	moveq	#pri,d2			;Pri
	move.l	#stack,d4		;Stack
	jsr	CreateProc(a6)		;Create New Process
	ELSE
	move.l	#cretags,a0
	move.l	d3,4(a0)
	move.l	a0,d1
	jsr	CreateNewProc(a6)
	ENDC
	ENDC

WECONT1	move.l	4.w,a6
	move.l	sdosbas(pc),a1
	jsr	CloseLibrary(a6)	;Close Dos.library

	IF	BACK=0
	jsr	prg			;Start Program
	ENDC

	tst.l	workpoi
	beq.b	wecont2
	move.l	4.w,a6
	jsr	Forbid(a6)
	move.l	workpoi,a1
	jsr	ReplyMsg(a6)

WECONT2	moveq	#0,d0			;Make A Success Return
	rts
;------------------------------------------------------------------------------
; Get Workbench Message
;

GETWORK	lea	Process_MsgPort(a4),a0	;MessagePort In A0
	jsr	WaitPort(a6)		;Wait For Message
	lea	$5c(a4),a0		;RastPort Address In A0
	jsr	GetMsg(a6)		;Get Message
	move.l	d0,workpoi		;Store Message To Reply
	rts
;------------------------------------------------------------------------------
; ERROR!!!!!

SERROR	tst.l	Process_CLI(a4)		;Workbench?
	bne.b	nowork			;Nip!
	bsr.b	getwork

SERROR1	move.l	sdosbas(pc),a6
	move.l	wblock,d1
	beq.b	serror2
	jsr	CurrentDir(a6)

SERROR2	move.l	4.w,a6

	IF	ARGS<>0
	move.l	argsmem,d0
	beq.b	serror3
	move.l	d0,a1
	move.l	(a1),d0
	jsr	FreeMem(a6)

SERROR3	move.l	sicobas(pc),d0
	beq.b	serror4
	move.l	d0,a1
	jsr	CloseLibrary(a6)	;Close Icon.library
	ENDC

SERROR4	move.l	sdosbas(pc),a1
	jsr	CloseLibrary(a6)	;Close Dos.library

	move.l	workpoi,a1
	jsr	ReplyMsg(a6)
NOWORK	moveq	#-1,d0
	rts
;------------------------------------------------------------------------------
; Kickstart Error
;

	IF	KICK<>0
KICKERR	move.l	4.w,a6
	lea	sintnam(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)
	move.l	d0,sintbas
	beq.w	wecont1

	move.l	d0,a6
	lea	kickwin(pc),a0
	jsr	OpenWindow(a6)		;Open Window
	move.l	d0,swinhd
	beq.w	wecont1

	move.l	d0,a0
	move.l	Window_RPort(a0),a0
	lea	kickstr(pc),a1
	moveq	#0,d0
	moveq	#0,d1
	jsr	PrintIText(a6)

	move.l	swinhd(pc),a0
	move.l	Window_UserPort(a0),a0
	move.l	a0,-(sp)

	move.l	4.w,a6
KICKER1	move.l	(sp),a0
	jsr	WaitPort(a6)
	move.l	(sp),a0
	jsr	GetMsg(a6)
	tst.l	d0
	beq.b	kicker1

	move.l	d0,a0
	move.l	20(a0),d7		;Get Message

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	cmp.l	#$200,d7		;Close Window?
	bne.b	kicker1
	addq.l	#4,sp

	move.l	sintbas(pc),a6
	move.l	swinhd(pc),a0
	jsr	CloseWindow(a6)		;Close Window
	bra.w	wecont1
	ENDC
;------------------------------------------------------------------------------
SDOSBAS	dc.l	0

	IF	ARGS<>0
SICOBAS	dc.l	0
	ENDC

	IF	KICK<>0
SINTBAS	dc.l	0
SWINHD	dc.l	0
	ENDC
;------------------------------------------------------------------------------
SDOSNAM	dc.b	"dos.library",0

	IF	ARGS<>0
SICONAM	dc.b	"icon.library",0
	ENDC

	IF	KICK<>0
SINTNAM	dc.b	"intuition.library",0
	ENDC

	IF	WINDOW=0
NILNAME	dc.b	"NIL:",0
	ELSE
WINNAME	dc.b	"CON:0/0/640/128/"
	TITLE
	dc.b	" Output Window",0
	ENDC

PROCNAM	TITLE
	dc.b	0
	even

	IF	KICK<>0
KICKWIN	dc.w	100,40,440,30
	dc.b	0,1
	dc.l	$200,$100e,0,0,kicktit,0,0
	dc.w	0,0,0,0,1

KICKSTR	dc.b	1,0,0,0
	dc.w	7,15
	dc.l	0,kicktxt,0

KICKTIT	TITLE
	dc.b	" ERROR!!!!",0
KICKTXT	dc.b	"You need Kickstart 2.04 or higher to run this program",0
	even
	ENDC
;------------------------------------------------------------------------------
;******************************************************************************
;* The Main Program
;******************************************************************************

	SECTION	Program,CODE

PRG	move.l	4.w,a6
	sub.l	a1,a1
	jsr	FindTask(a6)
	move.l	d0,procadr

	lea	dosname(pc),a1
	moveq	#libnum,d0
	jsr	OpenLibrary(a6)		;Open Dos.library
	move.l	d0,dosbase
	beq.w	getout1
;------------------------------------------------------------------------------
; Main Program
;

	lea	intname(pc),a1
	moveq	#libnum,d0
	jsr	OpenLibrary(a6)		;Open Intuition.library
	move.l	d0,intbase
	beq.w	getout

	IF	CLIONLY=0
	lea	gfxname(pc),a1
	moveq	#libnum,d0
	jsr	OpenLibrary(a6)		;Open Graphics.library
	move.l	d0,gfxbase
	beq.w	getout

	lea	reqname(pc),a1
	moveq	#38,d0
	jsr	OpenLibrary(a6)		;Open Reqtools.library
	move.l	d0,reqbase
	bne.b	reqok
	lea	reqetxt(pc),a0
	bra.w	exterr
	ENDC

REQOK	lea	unpname(pc),a1
	moveq	#38,d0
	jsr	OpenLibrary(a6)		;Open Unpack.library
	move.l	d0,unpbase
	bne.b	unpok
	lea	unpetxt(pc),a0
	bra.w	exterr

UNPOK	IF	CLIONLY=0
	move.l	gfxbase(pc),a6
	lea	fontstr(pc),a0
	jsr	OpenFont(a6)		;Open Topaz.font
	move.l	d0,fntbase
	ENDC

	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)	;Allocate Info Structure
	move.l	d0,infadr
	beq.w	getout

	IF	CLIONLY=0
	jsr	upNewUnpackNum(a6)	;Get Version Numbers
	move.l	a0,a2
	lea	txt1a(pc),a0
	move.w	NS_Version(a2),d0
	bsr.w	todec
	move.w	NS_Revision(a2),d0
	lea	txt1b(pc),a0
	move.b	#".",-1(a0)
	bsr.w	todec
	move.w	NS_Types(a2),d0
	lea	txt2a(pc),a0
	bsr.w	todec
	move.w	NS_Unpackers(a2),d0
	lea	txt3a(pc),a0
	bsr.w	todec
	ENDC

	bsr.w	unppar			;Unpack With Parameters

	IF	CLIONLY=0
	beq.w	getout

; Continue Startup

NOPAR	move.l	reqbase(pc),a6
	moveq	#RT_FileReq,d0
	sub.l	a0,a0
	jsr	rtAllocRequestA(a6)	;Allocate FileRequester Structure
	move.l	d0,rfilstr
	beq.w	getout

	moveq	#RT_FileReq,d0
	sub.l	a0,a0
	jsr	rtAllocRequestA(a6)	;Allocate FileRequester Structure
	move.l	d0,wfilstr
	beq.w	getout

	moveq	#RT_FileReq,d0
	sub.l	a0,a0
	jsr	rtAllocRequestA(a6)	;Allocate VolumeRequester Structure
	move.l	d0,volstr
	beq.w	getout

	lea	arxporn(pc),a0
	sub.l	a1,a1
	bsr.w	InitARexx		;Make Port
	move.l	d0,arxport
	beq.w	getout

	move.l	#prename,d1
	bsr.w	rdpref			;Read Preferences
	bne.b	preok
	bsr.w	default

PREOK	bsr.w	insinp			;Install Input Handler
	bne.w	getout

	lea	filinfo,a0
	moveq	#0,d0
	move.w	#(bssend-filinfo)/2-1,d7
CLRBSS	move.w	d0,(a0)+
	dbra	d7,clrbss

	move.w	gads3+12(pc),d0
	btst	#7,d0
	beq.b	wewait
POPIT	bsr.w	popwin
	beq.w	outout

; Wait In Resident State

WEWAIT	move.l	4.w,a6
	move.l	inpport(pc),a0
	moveq	#0,d1
	moveq	#1,d2
	move.b	MsgPort_SigBit(a0),d1
	asl.l	d1,d2

	move.l	arxport(pc),a5
	bsr.w	ArexxSignal
	or.l	d2,d0

	jsr	Wait(a6)		;Wait For Signals

	move.l	arxport(pc),a5
	bsr.w	GetARexxMsg
	beq.b	noarx
	cmp.l	#-1,d0
	beq.b	noarx

	move.l	d0,arxmsg
	move.l	d0,a2
	bsr.w	CheckRexxMsg
	beq.b	noarx

	lea	arxcmd(pc),a0
	lea	arxarg(pc),a1
	move.l	arxmsg(pc),a2
	bsr.w	ARexxParse
	beq.b	noarx

	lea	arxjmp(pc),a0
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a0,d1.w),a0
	jsr	(a0)			;Start Arexx Command


NOARX	move.l	inpport(pc),a0
	jsr	GetMsg(a6)		;Get The Message
	tst.l	d0
	beq.b	wewait			;No Window Message

	move.l	d0,a0
	move.w	20(a0),d7
	cmp.w	#MS_Popup,d7
	beq.b	popit
	cmp.w	#MS_Unpack,d7
	bne.b	wewait
	bsr.w	unpck
	bra.w	wewait

; Quit Program

OUTOUT	bsr.w	reminp			;Remove Input Handler
	ENDC
;------------------------------------------------------------------------------
; Exit Routine

GETOUT	IF	CLIONLY=0
	move.l	arxport(pc),a5
	bsr.w	FreeARexx		;Close ARexx Port

	move.l	reqbase(pc),d0
	beq.b	noreq
	move.l	d0,a6
	move.l	rfilstr(pc),a1
	jsr	rtFreeRequest(a6)
	move.l	wfilstr(pc),a1
	jsr	rtFreeRequest(a6)
	move.l	volstr(pc),a1
	jsr	rtFreeRequest(a6)
	move.l	a6,a1
	move.l	4.w,a6
	jsr	CloseLibrary(a6)	;Close Reqtools.library
	ENDC

NOREQ	move.l	unpbase(pc),d0
	beq.b	nounp
	move.l	d0,a6
	move.l	infadr(pc),a0
	jsr	upFreeCInfo(a6)
	move.l	a6,a1
	move.l	4.w,a6
	jsr	CloseLibrary(a6)	;Close Unpack.library

NOUNP	IF	CLIONLY=0
	move.l	gfxbase(pc),d0
	beq.b	nogfx
	move.l	d0,a6
	move.l	fntbase(pc),d0
	beq.b	nofont
	move.l	d0,a1
	jsr	CloseFont(a6)		;Close Topaz.font
NOFONT	move.l	a6,a1
	move.l	4.w,a6
	jsr	CloseLibrary(a6)	;Close Graphics.library
	ENDC

NOGFX	move.l	intbase(pc),d0
	beq.b	noint
	move.l	d0,a6
	move.l	winhd(pc),d0
	beq.b	nowin
	move.l	d0,a0
	jsr	CloseWindow(a6)		;Close Window Again
NOWIN	move.l	a6,a1
	move.l	4.w,a6
	jsr	CloseLibrary(a6)	;Close Intuition.library

NOINT	IF	OBJ<>0
	move.l	dosbase(pc),a6
	move.l	outbase,d1
	beq.b	nowind
	jsr	Close(a6)		;Close Window or NIL:

NOWIND	move.l	wblock,d1
	beq.b	nocur
	jsr	CurrentDir(a6)		;Set Current Directory Back

NOCUR	IF	ARGS<>0
	IF	CLIONLY=0
	moveq	#0,d7
	ELSE
	moveq	#-1,d7
	ENDC
	move.l	4.w,a6
	move.l	argsmem,d0
	beq.b	noargm
	move.l	d0,a1
	move.l	(a1),d0
	tst.b	4(a1)
	beq.b	frearg
	tst.b	5(a1)
	beq.b	frearg
	moveq	#-1,d7
FREARG	jsr	FreeMem(a6)		;Free Argument Strings

NOARGM	move.l	dosbase(pc),a6
	ENDC

	IF	BACK<>0
	tst.w	d7
	bne.b	.out
	move.l	#prg-4,d1
	lsr.l	#2,d1
	jsr	UnloadSeg(a6)
	ENDC
	ENDC

.OUT	move.l	4.w,a6
	move.l	dosbase(pc),a1
	jsr	CloseLibrary(a6)	;Close Dos.library
GETOUT1	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Extern Library Error
;

EXTERR	move.l	a0,txtpoi
	move.l	intbase(pc),a6
	lea	ewinstr(pc),a0
	jsr	OpenWindow(a6)		;Open Window
	move.l	d0,winhd
	beq.w	getout

	move.l	d0,a0
	move.l	Window_RPort(a0),a0
	lea	txtstr(pc),a1
	moveq	#0,d0
	moveq	#0,d1
	jsr	PrintIText(a6)

	move.l	winhd(pc),a0
	move.l	Window_UserPort(a0),a0
	move.l	a0,-(sp)

	move.l	4.w,a6
EXTERR1	move.l	(sp),a0
	jsr	WaitPort(a6)
	move.l	(sp),a0
	jsr	GetMsg(a6)
	tst.l	d0
	beq.b	exterr1

	move.l	d0,a0
	move.l	20(a0),d7		;Get Message

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	cmp.l	#$200,d7		;Close Window?
	bne.b	exterr1
	addq.l	#4,sp
	bra.w	getout


EWINSTR	dc.w	193,40,254,30
	dc.b	0,1
	dc.l	$200,$100e,0,0,errtit,0,0
	dc.w	0,0,0,0,1

TXTSTR	dc.b	1,0,0,0
	dc.w	7,15
	dc.l	0
TXTPOI	dc.l	0,0

ERRTIT	dc.b	"ERROR!!!!",0
UNPETXT	dc.b	"You need unpack.library V38+",0
REQETXT	dc.b	"You need reqtools.library V38+",0
	even
;------------------------------------------------------------------------------
; Parse CLI Arguments
;

UNPPAR	moveq	#-1,d6
	move.l	argsmem,a0
	addq.l	#4,a0			;Skip Length
	tst.b	(a0)+			;CLI/Workbench
	beq.w	unpparo			;Workbench!!

	IF	CLIONLY=0
	tst.b	(a0)
	beq.w	unpparo			;No Parameters
	ENDC

	moveq	#0,d6
	move.l	a0,-(sp)
	lea	headtxt(pc),a0
	bsr.w	print
	move.l	(sp)+,a0
	sf	copflg
	sf	verflg

COPPAR1	cmp.b	#"-",(a0)
	bne.b	coppar2
	cmp.b	#"c",1(a0)		;Copy Always Flag
	beq.b	copcflg
	cmp.b	#"v",1(a0)		;Verify Flag
	bne.b	chlptxt

	st	verflg
	addq.l	#3,a0
	bra.b	coppar1

COPCFLG	st	copflg
	addq.l	#3,a0
	bra.b	coppar1


COPPAR2	tst.b	1(a0)
	bne.b	chlptxt
	cmp.b	#"e",(a0)		;Extract Command
	beq.b	copunp
	cmp.b	#"v",(a0)		;View Command
	beq.w	copvie

CHLPTXT	move.l	unpbase(pc),a6
	jsr	upNewUnpackNum(a6)
	movem.w	(a0)+,d0-d3
	movem.w	d0-d3,-(sp)

	move.l	4.w,a6
	lea	hlptxt(pc),a0		;Text
	move.l	sp,a1			;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print
	lea	4*4(sp),sp
	bra.w	unpparo

; Unpack File

COPUNP	addq.l	#2,a0
	lea	axarg1,a1
	lea	axarg2,a2
COPPAR3	move.b	(a0),(a1)+		;Copy Parameter #1
	move.b	(a0)+,(a2)+
	bne.b	coppar3

	tst.b	(a0)
	beq.b	coppa4a
	lea	axarg2,a1
COPPAR4	move.b	(a0)+,(a1)+		;Copy Parameter #2
	bne.b	coppar4

COPPA4a	lea	cupatx1(pc),a0
	bsr.w	print
	moveq	#-1,d7
	bsr.w	arunp			;Unpack & Save File
	bne.w	unperr

COPPAR5	lea	txtdat,a0
	move.l	#axarg1,(a0)+
	move.l	#axarg2,(a0)+
	move.l	d1,(a0)+
	move.l	d2,(a0)+
	move.l	a1,(a0)+

	move.l	4.w,a6
	lea	cuptxt(pc),a0		;Text
	lea	txtdat,a1		;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print
	bra.w	unpparo

; View File

COPVIE	addq.l	#2,a0

	tst.b	(a0)
	beq.w	chlptxt
	lea	axarg1,a1
COPPAR7	move.b	(a0)+,(a1)+		;Copy Parameter #1
	bne.b	coppar7

	lea	cupatx2(pc),a0
	bsr.w	print

	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)
	tst.l	d0
	beq.w	unpmerr

COPPAR8	move.l	d0,-(sp)
	move.l	d0,a0
	lea	axarg1,a1
	jsr	upDetermineFile(a6)
	tst.w	d0
	bne.b	coppar9
	move.l	(sp),a0
	move.l	UI_ErrorMsg(a0),a5
	move.w	UI_ErrorNum(a0),d7
	cmp.w	#ERR_Determine,d7
	beq.b	coppa10
	move.l	(sp)+,a0
	jsr	upFreeCInfo(a6)
	bra.w	unperr1

COPPAR9	move.l	(sp),a0
	move.l	UI_CruncherName(a0),a1
	bra.b	coppa11

COPPA10	lea	cuptxt3(pc),a1
COPPA11	lea	txtdat,a0
	move.l	#axarg1,(a0)+
	move.l	a1,(a0)+

	move.l	4.w,a6
	lea	cuptxt0(pc),a0		;Text
	lea	txtdat,a1		;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print

	move.l	unpbase(pc),a6
	move.l	(sp)+,a0
	jsr	upFreeCInfo(a6)
	bra.b	unpparo

; Store Character

STOCHR	move.b	d0,(a3)+
	rts

; Error Routine

UNPERR	tst.b	copflg
	beq.b	unperr1
	cmp.w	#ERR_Memory,d0
	beq.b	unpmerr
	cmp.w	#ERR_Determine,d0
	bne.b	unperr1

; Copy File

	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)
	tst.l	d0
	beq.b	unpmerr

UNPECP	move.l	d0,-(sp)
	move.l	d0,a0
	move.l	#axarg1,UI_FileName(a0)

	jsr	upLoadFile(a6)		;Load The File
	tst.w	d0
	bne.b	unpecp1
	move.l	(sp)+,a0
	move.l	UI_ErrorMsg(a0),a5
	jsr	upFreeCInfo(a6)
	bra.b	unperr1

UNPECP1	move.l	d0,d7
	move.l	(sp),a4
	bsr.w	arusav			;Save The File
	move.l	unpbase(pc),a6
	move.l	(sp),a0
	jsr	upFreeFile(a6)		;Free The Memory Again
	move.l	(sp)+,a0
	jsr	upFreeCInfo(a6)

	lea	cuptxt3(pc),a1
	move.l	d7,d1
	move.l	d7,d2
	bra.w	coppar5


UNPMERR	lea	errmem(pc),a5
UNPERR1	move.l	a5,-(sp)
	lea	cuptxt1(pc),a0
	bsr.b	print
	move.l	(sp)+,a0
	bsr.b	print
	lea	cuptxt2(pc),a0
	bsr.b	print

UNPPARO	tst.l	d6
	rts
;------------------------------------------------------------------------------
; CLI Print Text
;
; IN :	A0 = Pointer To A String
;
; OUT:	Nothing
;

PRINT	movem.l	d0-d3/a0/a6,-(sp)
	move.l	a0,d2
	moveq	#-1,d3
PRINT1	addq.l	#1,d3
	tst.b	(a0)+			;Search For Zero
	bne.b	print1

	move.l	dosbase(pc),a6
	jsr	Output(a6)
	move.l	d0,d1
	jsr	Write(a6)
	movem.l	(sp)+,d0-d3/a0/a6
	rts
;------------------------------------------------------------------------------
; Convert To Decimal
;

	IF	CLIONLY=0
TODEC	lea	dectab(pc),a1
	moveq	#0,d5
	moveq	#3-1,d6
TODEC1	moveq	#0,d4
TODEC2	cmp.b	(a1),d0
	bcs.b	todec3
	sub.b	(a1),d0
	addq.w	#1,d4
	bra.b	todec2

TODEC3	addq.l	#1,a1
	tst.w	d5
	bne.b	todec4
	tst.w	d4
	beq.b	todec5
TODEC4	add.b	#"0",d4
	move.b	d4,(a0)+
	moveq	#-1,d5
TODEC5	dbra	d6,todec1
	clr.b	(a0)
	rts

DECTAB	dc.b	100,10,1
	even
;------------------------------------------------------------------------------
; Install Input Handler
;

INSINP	move.l	4.w,a6
	sub.l	a1,a1
	jsr	FindTask(a6)

	lea	portstr(pc),a1
	move.l	d0,$10(a1)
	jsr	AddPort(a6)		;Add Port

	lea	stdreq(pc),a1
	lea	devname(pc),a0
	moveq	#0,d0
	moveq	#0,d1
	jsr	OpenDevice(a6)		;Open Input.device
	tst.l	d0
	bne.b	insinp1

	lea	irqstr(pc),a0
	lea	stdreq(pc),a1
	lea	portstr(pc),a2
	move.l	a2,$0e(a1)
	move.w	#9,$1c(a1)		;Command: ADDHANDLER
	move.b	#0,$1e(a1)		;Flags
	move.l	a0,$28(a1)		;Data
	jsr	DoIO(a6)

	moveq	#0,d0
	sub.l	a0,a0
	bsr.w	CreatePort		;Create Send Message Port
	move.l	d0,inpport
	beq.b	reminp
	moveq	#0,d0
	sub.l	a0,a0
	bsr.w	CreatePort		;Create Reply Port
	move.l	d0,irpport
	beq.b	reminp
	moveq	#0,d0
INSINP1	rts
;------------------------------------------------------------------------------
; Remove Input Handler
;

REMINP	move.l	inpport(pc),a0
	bsr.w	DeletePort

REMINP1	move.l	4.w,a6
	lea	irqstr(pc),a0
	lea	stdreq(pc),a1
	move.w	#10,$1c(a1)		;Command: REMHANDLER
	move.b	#0,$1e(a1)		;Flags
	move.l	a0,$28(a1)		;Data
	jsr	DoIO(a6)

	lea	portstr(pc),a1
	jsr	RemPort(a6)		;Remove Port

	lea	stdreq(pc),a1
	jsr	CloseDevice(a6)

	move.l	irpport(pc),a0
	bsr.w	DeletePort
	moveq	#-1,d0
	rts
;------------------------------------------------------------------------------
; Handler
;

HANDLER	move.l	a0,-(sp)
	movem.l	d1-d7/a1-a6,-(sp)

HAND1	move.b	4(a0),d6		;Get Class
	cmp.b	#1,d6			;RAW_KEY
	bne.w	keyout

	move.w	6(a0),d0		;Get Code
	btst	#7,d0
	bne.w	nokey
	cmp.b	#$62,d0			;SHIFT LOCK?
	bne.b	keybrd1			;Nop!
	bset	#0,shftflg		;Set SHIFT LOCK Flag
KEYBRD1	cmp.b	#$61,d0			;RIGHT SHIFT?
	bne.b	keybrd2			;Nap!
	bset	#1,shftflg		;Set RIGHT SHIFT Flag
KEYBRD2	cmp.b	#$60,d0			;LEFT SHIFT?
	bne.b	keybrd3			;Nip!
	bset	#2,shftflg		;Set LEFT SHIFT Flag

KEYBRD3	cmp.b	#$65,d0			;RIGHT ALT?
	bne.b	keybrd4			;Nep!
	bset	#0,altflg		;Set RIGHT ALT Flag
KEYBRD4	cmp.b	#$64,d0			;LEFT ALT?
	bne.b	keybrd5			;Nup!
	bset	#1,altflg		;Set LEFT ALT Flag

KEYBRD5	cmp.b	#$67,d0			;RIGHT AMIGA?
	bne.b	keybrd6			;Nup!
	bset	#0,amiflg		;Set RIGHT AMIGA Flag
KEYBRD6	cmp.b	#$66,d0			;LEFT AMIGA?
	bne.b	keybrd7			;Nip!
	bset	#1,amiflg		;Set LEFT AMIGA Flag

KEYBRD7	cmp.b	#$63,d0			;CTRL?
	bne.b	keybrd8			;Nip!
	bset	#0,ctrlflg		;Set CTRL Flag

; Test For Popup Keys

KEYBRD8	lea	popkey(pc),a2
	move.b	(a2),d7
	cmp.b	ctrlflg(pc),d7
	beq.b	keybr8a
	and.b	ctrlflg(pc),d7
	beq.b	keybrd9
KEYBR8a	move.b	1(a2),d7
	cmp.b	shftflg(pc),d7
	beq.b	keybr8b
	and.b	shftflg(pc),d7
	beq.b	keybrd9
KEYBR8b	move.b	2(a2),d7
	cmp.b	altflg(pc),d7
	beq.b	keybr8c
	and.b	altflg(pc),d7
	beq.b	keybrd9
KEYBR8c	move.b	3(a2),d7
	cmp.b	amiflg(pc),d7
	beq.b	keybr8d
	and.b	amiflg(pc),d7
	beq.b	keybrd9
KEYBR8d	cmp.b	4(a2),d0
	bne.b	keybrd9

	clr.b	4(a0)			;Intuition Can't Read Key
	tst.b	keyflg
	bne.w	keyout
	tst.b	nomsg
	bne.w	keyout
	st	keyflg
	moveq	#MS_Popup,d2		;Pop Up
	bsr.w	inpsend
	bra.w	keyout

; Test For Unpack Keys

KEYBRD9	lea	unpkey(pc),a2
	move.b	(a2),d7
	cmp.b	ctrlflg(pc),d7
	beq.b	keybr9a
	and.b	ctrlflg(pc),d7
	beq.b	keybr10
KEYBR9a	move.b	1(a2),d7
	cmp.b	shftflg(pc),d7
	beq.b	keybr9b
	and.b	shftflg(pc),d7
	beq.b	keybr10
KEYBR9b	move.b	2(a2),d7
	cmp.b	altflg(pc),d7
	beq.b	keybr9c
	and.b	altflg(pc),d7
	beq.b	keybr10
KEYBR9c	move.b	3(a2),d7
	cmp.b	amiflg(pc),d7
	beq.b	keybr9d
	and.b	amiflg(pc),d7
	beq.b	keybr10
KEYBR9d	cmp.b	4(a2),d0
	bne.b	keybr10

	clr.b	4(a0)			;Intuition Can't Read Key
	tst.b	keyflg
	bne.w	keyout
	tst.b	nomsg
	bne.w	keyout
	st	keyflg
	moveq	#MS_Unpack,d2		;Unpack
	bsr.w	inpsend
	bra.w	keyout

; Test For CTRL+C Keys

KEYBR10	tst.b	ctrlflg
	beq.w	keyout
	cmp.b	#$33,d0			;C
	bne.w	keyout
	tst.b	crlflg
	beq.w	keyout

	clr.b	4(a0)			;Intuition Can't Read Key
	tst.b	keyflg
	bne.w	keyout
	tst.b	nomsg
	bne.w	keyout
	st	keyflg
	moveq	#MS_CtrlC,d2		;CTRL+C
	bsr.w	inpsend
	bra.b	keyout


NOKEY	sf	keyflg
	and.b	#$7f,d0
	cmp.b	#$62,d0			;SHIFT LOCK?
	bne.b	nokey1			;Nup!
	bclr	#0,shftflg		;Clear SHIFT LOCK Flag
NOKEY1	cmp.b	#$61,d0			;RIGHT SHIFT?
	bne.b	nokey2			;Nap!
	bclr	#1,shftflg		;Clear RIGHT SHIFT Flag
NOKEY2	cmp.b	#$60,d0			;LEFT SHIFT?
	bne.b	nokey3			;Nep!
	bclr	#2,shftflg		;Clear LEFT SHIFT Flag

NOKEY3	cmp.b	#$65,d0			;RIGHT ALT?
	bne.b	nokey4			;Nip!
	bclr	#0,altflg		;Clear RIGHT ALT Flag
NOKEY4	cmp.b	#$64,d0			;LEFT ALT?
	bne.b	nokey5			;Nop!
	bclr	#1,altflg		;Clear LEFT ALT Flag

NOKEY5	cmp.b	#$67,d0			;RIGHT AMIGA?
	bne.b	nokey6			;Nep!
	bclr	#0,amiflg		;Clear RIGHT AMIGA Flag
NOKEY6	cmp.b	#$66,d0			;LEFT AMIGA?
	bne.b	nokey7			;Nip!
	bclr	#1,amiflg		;Clear LEFT AMIGA Flag

NOKEY7	cmp.b	#$63,d0			;CTRL?
	bne.b	keyout			;Nip!
	bclr	#0,ctrlflg		;Set CTRL Flag

; Test For Mouse

KEYOUT	cmp.b	#2,d6			;RAW_Mouse
	bne.b	mousout

	move.w	6(a0),d0		;Get Code
	btst	#7,d0
	bne.b	mousout
	cmp.b	#$68,d0			;Left Mouse Button
	bne.b	mousout
	tst.b	lmbflg
	beq.b	mousout
	moveq	#MS_LMB,d2		;Left Mouse Button
	bsr.b	inpsend

MOUSOUT	move.l	(a0),d0
	move.l	d0,a0
	bne.w	hand1

	move.l	a0,-(sp)
	tst.b	nomsg
	bne.b	norepl
	move.l	4.w,a6
	move.l	irpport(pc),a0
	jsr	GetMsg(a6)		;Get Message From Reply Port
	tst.l	d0
	beq.b	norepl
	move.l	d0,a1
	cmp.b	#7,8(a1)		;Reply Message
	bne.b	norepl
	moveq	#14+4+2*2,d0
	jsr	FreeMem(a6)		;Free Message From Memory
NOREPL	move.l	(sp)+,a0

	movem.l	(sp)+,d1-d7/a1-a6
	move.l	(sp)+,d0
	rts

; Send Message

INPSEND	move.l	4.w,a6
	moveq	#14+4+2*2,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)
	tst.l	d0
	beq.b	inpsndo
	move.l	d0,a1
	move.l	inpport(pc),a0
	move.l	irpport(pc),a2
	move.b	#5,8(a1)		;Type NT_Message
	move.l	a2,14(a1)		;Reply Port
	move.w	#22,18(a1)		;Length
	move.w	d2,20(a1)		;Message Action
	jsr	PutMsg(a6)
INPSNDO	rts
;------------------------------------------------------------------------------
; CreatePort
;
; IN :	D0 = Priority
;	A0 = Name
;
; OUT:	D0 = Port (0=Error)
;

CreatePort
	movem.l	d2-d5/a2/a6,-(sp)
	move.l	a0,d3
	move.l	d0,d2

	move.l	4.w,a6
	moveq	#-1,d0	
	jsr	AllocSignal(a6)
	move.b	d0,d1
	moveq	#0,d0
	move.b	d1,d0
	move.l	d0,d4
	cmp.l	d0,d1
	bne.b	.cport1
	moveq	#0,d0
	bra.b	.cport5

.CPORT1	moveq	#34,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)
	move.l	d0,a2
	move.l	a2,d5
	bne.b	.cport2
	move.l	d4,d0
	jsr	FreeSignal(a6)
	moveq	#0,d0
	bra.b	.cport5

.CPORT2	move.l	d3,$0a(a2)
	move.b	d2,$09(a2)
	move.b	#4,$08(a2)
	clr.b	14(a2)
	move.b	d4,$0f(a2)
	sub.l	a1,a1
	jsr	FindTask(a6)
	move.l	d0,$10(a2)

	tst.l	d3
	beq.b	.cport3
	move.l	a2,a1
	jsr	AddPort(a6)
	bra.b	.cport4

.CPORT3	lea	$14(a2),a0
	move.l	a0,(a0)
	addq.l	#4,(a0)
	clr.l	$04(a0)
	move.l	a0,$08(a0)
.CPORT4	move.l	a2,d0
.CPORT5	movem.l	(sp)+,d2-d5/a2/a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; DeletePort
;
; IN :	A0 = Port
;
; OUT:	Nothing
;

DeletePort
	movem.l	a2/a6,-(sp)

	moveq	#0,d0
	cmp.l	a0,d0
	beq.b	.dport2
	move.l	a0,a2
	move.l	4.w,a6
.DPORT0	move.l	a2,a0
	jsr	GetMsg(a6)
	tst.l	d0
	beq.b	.dpor00
	move.l	a2,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)
	bra.b	.dport0

.DPOR00	tst.l	$0a(a2)
	beq.b	.dport1
	move.l	a2,a1
	jsr	RemPort(a6)

.DPORT1	move.b	#-1,$08(a2)
	moveq	#-1,d0
	move.l	d0,$14(a2)
	moveq	#0,d0
	move.b	$0f(a2),d0
	jsr	FreeSignal(a6)

	moveq	#34,d0
	move.l	a2,a1
	jsr	FreeMem(a6)

.DPORT2	movem.l	(sp)+,a2/a6
	rts
;------------------------------------------------------------------------------
; Read Preferences Routine
;
; IN :	D1 = Filename
;
; OUT:	D0 = Success
;

RDPREF	move.l	dosbase(pc),a6
	move.l	#1005,d2
	jsr	Open(a6)		;Open File
	move.l	d0,filhd
	beq.w	rdprefo

	move.l	d0,d1
	move.l	#tstlong,d2
	moveq	#4,d3
	jsr	Read(a6)		;Read Mark
	cmp.l	#-1,d0
	beq.w	rdpref9

	moveq	#-1,d0
	move.l	tstlong(pc),d1
	cmp.l	prelong(pc),d1
	bne.w	rdpref9

	move.l	filhd(pc),d1
	move.l	#popbuf,d2
	moveq	#32,d3
	jsr	Read(a6)		;Read Buffer 1
	cmp.l	#-1,d0
	beq.w	rdpref9

	move.l	filhd(pc),d1
	move.l	#unpbuf,d2
	moveq	#32,d3
	jsr	Read(a6)		;Read Buffer 2
	cmp.l	#-1,d0
	beq.w	rdpref9

	move.l	filhd(pc),d1
	move.l	#sufbuf,d2
	moveq	#8,d3
	jsr	Read(a6)		;Read Buffer 3
	cmp.l	#-1,d0
	beq.w	rdpref9

	move.l	filhd(pc),d1
	move.l	#gads3+12,d2
	moveq	#2,d3
	jsr	Read(a6)		;Read Flag 1
	cmp.l	#-1,d0
	beq.w	rdpref9

	move.l	filhd(pc),d1
	move.l	#gads4+12,d2
	moveq	#2,d3
	jsr	Read(a6)		;Read Flag 2
	cmp.l	#-1,d0
	beq.b	rdpref9

	move.l	filhd(pc),d1
	move.l	#gads5+12,d2
	moveq	#2,d3
	jsr	Read(a6)		;Read Flag 3
	cmp.l	#-1,d0
	beq.b	rdpref9

	lea	m3txt,a2
	lea	am1str,a3
	moveq	#10-1,d7
RDPREF1	move.l	filhd(pc),d1
	move.l	a3,d2
	moveq	#64,d3
	jsr	Read(a6)		;Read ARexx Macro Name
	cmp.l	#-1,d0
	beq.b	rdpref9

; Strip Path

	move.l	a3,a0
RDPREF2	tst.b	(a0)+
	bne.b	rdpref2

RDPREF3	cmp.b	#"/",-(a0)
	beq.b	rdpref4
	cmp.b	#":",(a0)
	beq.b	rdpref4
	cmp.l	a0,a3
	bne.b	rdpref3

RDPREF4	addq.l	#1,a0
	moveq	#20-1,d6
RDPREF5	move.b	(a0)+,(a2)+
	beq.b	rdpref6
	dbra	d6,rdpref5
	bra.b	rdpref8

RDPREF6	subq.l	#1,a2
RDPREF7	move.b	#" ",(a2)+
	dbra	d6,rdpref7

RDPREF8	addq.l	#4,a2
	lea	64(a3),a3
	dbra	d7,rdpref1

RDPREF9	move.l	d0,-(sp)
	move.l	filhd(pc),d1
	jsr	Close(a6)		;Close File
	move.l	(sp)+,d0

	cmp.l	#-1,d0
	bne.b	rdprefo
	moveq	#0,d0
RDPREFO	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Write Preferences Routine
;
; IN :	D1 = Filename
;
; OUT:	D0 = Success
;

WRPREF	move.l	dosbase(pc),a6
	move.l	#1006,d2
	jsr	Open(a6)		;Open File
	move.l	d0,filhd
	beq.w	wrprefo

	move.l	d0,d1
	move.l	#prelong,d2
	moveq	#4,d3
	jsr	Write(a6)		;Write Mark
	cmp.l	#-1,d0
	beq.w	wrpref2

	move.l	filhd(pc),d1
	move.l	#popbuf,d2
	moveq	#32,d3
	jsr	Write(a6)		;Write Buffer 1
	cmp.l	#-1,d0
	beq.w	wrpref2

	move.l	filhd(pc),d1
	move.l	#unpbuf,d2
	moveq	#32,d3
	jsr	Write(a6)		;Write Buffer 2
	cmp.l	#-1,d0
	beq.w	wrpref2

	move.l	filhd(pc),d1
	move.l	#sufbuf,d2
	moveq	#8,d3
	jsr	Write(a6)		;Write Buffer 3
	cmp.l	#-1,d0
	beq.b	wrpref2

	move.l	filhd(pc),d1
	move.l	#gads3+12,d2
	moveq	#2,d3
	jsr	Write(a6)		;Write Flag 1
	cmp.l	#-1,d0
	beq.b	wrpref2

	move.l	filhd(pc),d1
	move.l	#gads4+12,d2
	moveq	#2,d3
	jsr	Write(a6)		;Write Flag 2
	cmp.l	#-1,d0
	beq.b	wrpref2

	move.l	filhd(pc),d1
	move.l	#gads5+12,d2
	moveq	#2,d3
	jsr	Write(a6)		;Write Flag 3
	cmp.l	#-1,d0
	beq.b	wrpref2

	lea	am1str,a2
	moveq	#10-1,d7
WRPREF1	move.l	filhd(pc),d1
	move.l	a2,d2
	moveq	#64,d3
	jsr	Write(a6)		;Write ARexx Macro Name
	cmp.l	#-1,d0
	beq.b	wrpref2
	lea	64(a2),a2
	dbra	d7,wrpref1

WRPREF2	move.l	d0,-(sp)
	move.l	filhd(pc),d1
	jsr	Close(a6)		;Close File
	move.l	(sp)+,d0

	cmp.l	#-1,d0
	bne.b	wrprefo
	moveq	#0,d0
WRPREFO	tst.l	d0
	rts

TSTLONG	dc.l	0
PRELONG	dc.l	"UP20"
;------------------------------------------------------------------------------
; Show Requester
;
; IN :	A1 = Text
;	A2 = Gadget Text
;	A3 = Array List
;
; OUT:	D0 = Success
;

REQUS	movem.l	a0/a3-a4/a6,-(sp)
	lea	reqtags(pc),a0
REQUS1	move.l	reqbase(pc),a6
	move.l	a3,a4
	sub.l	a3,a3
	jsr	rtEZRequestA(a6)
	movem.l	(sp)+,a0/a3-a4/a6
	tst.l	d0
	rts

REQTAGS	dc.l	RT_LockWindow,1
	dc.l	RT_UnderScore,"_"
	dc.l	TAG_END
;------------------------------------------------------------------------------
; Make FileRequester
;
; IN :	A3 = Title
;	D0 = Requester Type (0=Load  1=Save  2=No Files)
;
; OUT:	D0 = Action (0=Cancel  1=Ok)
;

FI_Load		=	0
FI_Save		=	1
FI_NoFiles	=	2
FI_Multi	=	4

FILREQ	movem.l	d1/d6-d7/a0-a2/a6,-(sp)
	st	nomsg
	moveq	#FREQF_PatGad,d1
	btst	#1,d0
	beq.b	filreq1
	or.l	#FREQF_NoFiles,d1

FILREQ1	btst	#2,d0
	beq.b	filrq1a
	or.l	#FREQF_MultiSelect,d1

FILRQ1a	move.l	rfilstr(pc),a1
	btst	#0,d0
	beq.b	filreq2
	move.l	wfilstr(pc),a1
	or.l	#FREQF_Save,d1
FILREQ2	move.l	d1,frtflg+4

	move.l	reqbase(pc),a6
	lea	fname1,a2
	lea	frtags(pc),a0
	move.l	a1,-(sp)
	jsr	rtFileRequestA(a6)	;Show FileRequester
	move.l	(sp)+,a0
	tst.l	d0
	beq.b	filreqo

	move.l	RFI_Dir(a0),a0
	lea	fname,a1
	moveq	#0,d6
	moveq	#108-1,d7
FILREQ3	tst.b	(a0)
	beq.b	filreq4
	moveq	#-1,d6
	move.b	(a0)+,(a1)+		;Copy Directory
	dbra	d7,filreq3

FILREQ4	tst.w	d6
	beq.b	filreq5
	cmp.b	#":",-1(a1)
	beq.b	filreq5
	move.b	#"/",(a1)+

FILREQ5	move.l	frtflg+4(pc),d1
	and.l	#FREQF_MultiSelect,d1
	bne.b	filreq7

	lea	fname1,a0
	moveq	#108-1,d7
FILREQ6	move.b	(a0)+,(a1)+		;Copy Filename
	beq.b	filreqo
	dbra	d7,filreq6
FILREQ7	clr.b	(a1)

FILREQO	sf	nomsg
	movem.l	(sp)+,d1/d6-d7/a0-a2/a6
	tst.l	d0
	rts

; FileRequester Tags

FRTAGS	dc.l	RT_ReqPos,REQPOS_CenterScr
	dc.l	RT_LockWindow,1
FRTFLG	dc.l	RTFI_Flags,0
	dc.l	RTFI_Height,224
	dc.l	TAG_END
;------------------------------------------------------------------------------
; Make VolumeRequester
;
; IN :	Nothing
;
; OUT:	D0 = Action (0=Cancel  1=Ok)
;

VOLREQ	movem.l	d7/a0-a3/a6,-(sp)
	st	nomsg

	move.l	reqbase(pc),a6
	sub.l	a2,a2
	lea	voltags(pc),a0
	move.l	volstr(pc),a1
	lea	voltit(pc),a3
	jsr	rtFileRequestA(a6)	;Show FileRequester
	tst.l	d0
	beq.b	volreqo

	move.l	volstr(pc),a0
	move.l	RFI_Dir(a0),a0
	lea	fname,a1
	moveq	#108-1,d7
VOLREQ1	tst.b	(a0)
	beq.b	volreq2
	move.b	(a0)+,(a1)+		;Copy Directory
	dbra	d7,volreq1

VOLREQ2	clr.b	(a1)

VOLREQO	sf	nomsg
	movem.l	(sp)+,d7/a0-a3/a6
	tst.l	d0
	rts

; VolumeRequester Tags

VOLTAGS	dc.l	RT_ReqPos,REQPOS_CenterScr
	dc.l	RT_LockWindow,1
	dc.l	RTFI_Flags,FREQF_NoBuffer!FREQF_NoFiles
	dc.l	RTFI_VolumeRequest,VREQF_NoAssigns!VREQF_AllDisks
	dc.l	RTFI_Height,224
	dc.l	TAG_END

VOLTIT	dc.b	"Select unpack drive",0
	even
;------------------------------------------------------------------------------
; Pop Up Window
;

POPWIN	move.l	arxport(pc),a5
	bsr.w	ARexxName
	lea	txt4a(pc),a0
	move.l	d0,a1
	moveq	#7-1,d0
POPWIN0	move.b	(a1)+,(a0)+
	dbeq	d0,popwin0

	move.l	intbase(pc),a6
	move.l	IntuitionBase_FirstScreen(a6),a0
POPWIN1	move.l	Screen_DefaultTitle(a0),a1
	cmp.l	#"Work",(a1)
	beq.b	fouwork
	tst.l	(a0)
	beq.w	winerr
	move.l	(a0),a0
	bra.b	popwin1

FOUWORK	lea	Screen_RastPort(a0),a0
	move.l	RastPort_Font(a0),a0
	move.w	$14(a0),d7		;Font YSize

; Setup Boxes and Text Structures

	lea	borstr(pc),a1
FIXBORD	move.w	d7,Border_TopEdge(a1)
	tst.l	Border_NextBorder(a1)
	beq.b	fixbout
	move.l	Border_NextBorder(a1),a1
	bra.b	fixbord

FIXBOUT	lea	textstr(pc),a1
FIXTEXT	move.w	20(a1),d0
	add.w	d7,d0
	move.w	d0,IntuiText_TopEdge(a1)
	tst.l	IntuiText_NextText(a1)
	beq.b	fixtout
	move.l	IntuiText_NextText(a1),a1
	bra.b	fixtext

FIXTOUT	lea	gads(pc),a1
FIXGADS	move.w	44(a1),d0
	add.w	d7,d0
	move.w	d0,Gadget_TopEdge(a1)
	tst.l	(a1)
	beq.b	fixgout
	move.l	(a1),a1
	bra.b	fixgads

; Open The Window

FIXGOUT	lea	winstr(pc),a0
	add.w	#148,d7
	move.w	d7,NewWindow_Height(a0)
	jsr	OpenWindow(a6)		;Open The Window
	move.l	d0,winhd
	beq.w	winerr

	bsr.w	setmenu			;Setup Menu

; Draw The Window

	move.l	intbase(pc),a6
	move.l	winhd(pc),a0
	move.l	Window_RPort(a0),a0
	move.l	a0,-(sp)
	lea	borstr(pc),a1
	moveq	#0,d0
	moveq	#0,d1
	jsr	DrawBorder(a6)		;Draw Borders

	move.l	(sp)+,a0
	lea	textstr(pc),a1
	moveq	#0,d0
	moveq	#0,d1
	jsr	PrintIText(a6)		;Print Text

	move.l	winhd(pc),a0
	lea	menustr,a1
	jsr	SetMenuStrip(a6)	;Setup Menu

	move.l	procadr(pc),a0
	move.l	Process_WindowPtr(a0),oldwptr
	move.l	winhd(pc),Process_WindowPtr(a0)

; Copy Buffers

	lea	popbuf(pc),a0
	lea	unpbuf(pc),a1
	lea	cbuf1(pc),a2
	lea	cbuf2(pc),a3
	moveq	#32-1,d7
COPBUF	move.b	(a0)+,(a2)+
	move.b	(a1)+,(a3)+
	dbra	d7,copbuf

	lea	sufbuf(pc),a0
	lea	cbuf3(pc),a1
	moveq	#8-1,d7
COPBUF1	move.b	(a0)+,(a1)+
	dbra	d7,copbuf1

	lea	cbuf4(pc),a0
	move.w	gads3+12(pc),(a0)
	move.w	gads4+12(pc),2(a0)
	move.w	gads5+12(pc),4(a0)

; Wait For Signals

MWAIT	move.l	winhd(pc),a0
	move.l	Window_UserPort(a0),a0
	move.l	a0,-(sp)

MWAIT1	move.l	(sp),a0
	moveq	#0,d1
	moveq	#1,d2
	move.b	MsgPort_SigBit(a0),d1
	asl.l	d1,d2

	move.l	arxport(pc),a5
	bsr.w	ArexxSignal
	or.l	d2,d0

	move.l	inpport(pc),a0
	moveq	#0,d1
	moveq	#1,d2
	move.b	MsgPort_SigBit(a0),d1
	asl.l	d1,d2
	or.l	d2,d0

	move.l	4.w,a6
	jsr	Wait(a6)		;Wait For Signals

MWAIT1a	move.l	4.w,a6
	move.l	(sp),a0
	jsr	GetMsg(a6)		;Get The Message
	tst.l	d0
	beq.b	mwait2			;No Window Message

	move.l	d0,a0
	move.l	20(a0),d7		;Get Message
	move.l	28(a0),d6		;Address
	move.w	24(a0),d5

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	moveq	#7,d0
	cmp.l	#$200,d7		;Close Window?
	beq.w	mgad1			;Yup!
	cmp.l	#$40,d7			;Gadget Selected?
	beq.w	mgad			;Yop!
	cmp.l	#$100,d7		;Menu Selected?
	beq.w	mmenu			;Yip!
	cmp.l	#$200000,d7		;Key Pressed?
	beq.w	mkey			;Yap!
	cmp.l	#$400,d7		;RawKey Pressed?
	beq.w	rkey			;Yep!


MWAIT2	move.l	4.w,a6
	move.l	inpport(pc),a0
	jsr	GetMsg(a6)		;Get The Message
	tst.l	d0
	beq.b	mwait4			;No Window Message

	move.l	d0,a0
	move.w	20(a0),d7

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	cmp.w	#MS_Popup,d7		;Pop Up
	bne.b	mwait3
	move.l	intbase(pc),a6
	move.l	winhd(pc),a0
	jsr	WindowToFront(a6)
	move.l	winhd(pc),a0
	jsr	ActivateWindow(a6)
	bra.b	mwait2

MWAIT3	cmp.w	#MS_Unpack,d7		;Unpack
	bne.b	mwait4
	bsr.w	unpck
	bra.b	mwait2


MWAIT4	move.l	arxport(pc),a5
	bsr.w	GetARexxMsg
	beq.w	mwait1
	cmp.l	#-1,d0
	beq.w	mwait1

	move.l	d0,arxmsg
	move.l	d0,a2
	bsr.w	CheckRexxMsg
	beq.w	mwait1

	lea	arxcmd(pc),a0
	lea	arxarg(pc),a1
	move.l	arxmsg(pc),a2
	bsr.w	ARexxParse
	beq.w	mwait1

	lea	arxjmp(pc),a0
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a0,d1.w),a0
	jsr	(a0)			;Start Arexx Command
	bra.w	mwait1

; Menu Selected

MMENU	cmp.w	#MenuNULL,d5
	beq.w	mwait1a

MMENU1	move.w	d5,-(sp)
	move.w	d5,d6
	move.w	d6,d7
	and.w	#%0000000000011111,d5	;Menu Number
	and.w	#%0000011111100000,d6
	lsr.w	#5,d6			;Item Number
	and.w	#%1111100000000000,d7
	lsr.w	#8,d7
	lsr.w	#3,d7			;SubItem Number

	lea	mmenadr(pc),a1
	add.w	d5,d5
	add.w	d5,d5
	move.l	(a1,d5.w),a1
	add.w	d6,d6
	add.w	d6,d6
	move.l	(a1,d6.w),a1
	cmp.l	#0,a1
	beq.b	mmenu2
	jsr	(a1)			;Call Routine

; Test For NextSelect

MMENU2	move.l	intbase(pc),a6
	move.w	(sp)+,d0		;Get Item Number
	lea	menustr,a0
	jsr	ItemAddress(a6)		;Get Item Address

	move.l	d0,a0
	move.w	32(a0),d5
	cmp.w	#MenuNULL,d5		;Test NextSelect
	bne.b	mmenu1
	bra.w	mwait1a

MMENADR	dc.l	mjmptb1,mjmptb2,mjmptb3

MJMPTB1	dc.l	opn,savep,saveas,0,about,0,quit
MJMPTB2	dc.l	default,lastsav,restore
MJMPTB3	dc.l	selam1,selam2,selam3,selam4,selam5
	dc.l	selam6,selam7,selam8,selam9,selam10

; Gadget Selected

MGAD	move.l	d6,a0
	move.w	38(a0),d0		;Get Gadget ID
	beq.w	mwait1a

MGAD1	lea	gjmptab-4(pc),a1
	add.w	d0,d0
	add.w	d0,d0
	move.l	(a1,d0.w),a1
	cmp.l	#0,a1
	beq.w	mwait2
	jsr	(a1)			;Call Routine
	bra.w	mwait1a

GJMPTAB	dc.l	0,0,0,0,0,0
KJMPTAB	dc.l	use,unpck,list,cancel

; Key Pressed

MKEY	lea	keytab(pc),a0
	lea	kjmptab(pc),a1
	moveq	#5-1,d7
MKEY1	cmp.b	(a0)+,d5
	beq.b	mkey2
	addq.l	#4,a1
	dbra	d7,mkey1
	bra.w	mwait1a

MKEY2	move.l	(a1),d0
	beq.w	mwait2
	move.l	d0,a1
	jsr	(a1)
	bra.w	mwait1a

KEYTAB	dc.b	"uplc"
	even

; RawKey Pressed

RKEY	cmp.b	#$4f,d5
	bls.w	mwait1a
	cmp.b	#$5a,d5
	bhi.w	mwait1a
	move.w	d5,-(sp)

	move.l	arxport(pc),a5
	tst.l	PH_RexxSysBase(a5)
	bne.b	rkey1
	move.l	4.w,a6
	lea	slibnam(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)
	move.l	d0,PH_RexxSysBase(a5)
	bne.b	rkey1

	lea	arxerr(pc),a1
	lea	oktxt(pc),a2
	bsr.w	requs
	addq.l	#2,sp
	bra.w	mwait1a

RKEY1	move.w	(sp)+,d5
	sub.b	#$50,d5
	moveq	#0,d0
	move.b	d5,d0
	lsl.l	#6,d0
	lea	am1str,a0
	add.l	d0,a0
	moveq	#0,d0
	move.l	arxport(pc),a5
	bsr.w	SendARexxMsg		;Start Macro
	bne.w	mwait1a

	lea	arxerr1(pc),a1
	lea	oktxt(pc),a2
	bsr.w	requs
	bra.w	mwait1a

ARXERR	dc.b	"You need the rexxsyslib.library",0
ARXERR1	dc.b	"Couldn't start this ARexx macro",0
	even
;------------------------------------------------------------------------------
; Close Window
;

CLSWIN	move.l	4.w,a6
	move.l	winhd(pc),a0
	move.l	Window_UserPort(a0),a0
	move.l	a0,-(sp)

CWLOOP	move.l	(sp),a0
	jsr	GetMsg(a6)		;Get The Message
	tst.l	d0
	bne.b	cwloop			;A Window Message!

	move.l	procadr(pc),a0
	move.l	oldwptr(pc),Process_WindowPtr(a0)

	move.l	intbase(pc),a6
	move.l	winhd(pc),a0
	jsr	ClearMenuStrip(a6)	;Remove Menu
	move.l	winhd(pc),a0
	jsr	CloseWindow(a6)		;Close Window
	clr.l	winhd
	addq.l	#4,sp
WINERR	rts
;------------------------------------------------------------------------------
; Parse Hotkeys
;

PARSE	lea	popbuf(pc),a0
	lea	popkey(pc),a1
	bsr.b	pars
	beq.b	parse1
	lea	gadsa(pc),a0
	move.w	d7,8(a0)		;Set New Cursor Position

	move.l	intbase(pc),a6
	lea	gads(pc),a0
	move.l	winhd(pc),a1
	sub.l	a2,a2
	jsr	ActivateGadget(a6)
	moveq	#-1,d6
	rts

PARSE1	lea	unpbuf(pc),a0
	lea	unpkey(pc),a1
	bsr.b	pars
	beq.b	parseo
	lea	gads1a(pc),a0
	move.w	d7,8(a0)		;Set New Cursor Position

	move.l	intbase(pc),a6
	lea	gads1(pc),a0
	move.l	winhd(pc),a1
	sub.l	a2,a2
	jsr	ActivateGadget(a6)
	moveq	#-1,d6
PARSEO	rts


PARS	moveq	#0,d6
	clr.b	(a1)
	clr.b	1(a1)
	clr.b	2(a1)
	clr.b	3(a1)
	clr.b	4(a1)
	move.l	a0,a5

PARS0	moveq	#0,d0
	move.l	a0,a2
PARS1	tst.b	(a0)+
	beq.b	pars2
	cmp.b	#" ",-1(a0)
	beq.b	pars2
	addq.w	#1,d0
	bra.b	pars1

PARS2	cmp.w	#1,d0
	bne.b	pars5
	move.b	(a2),d0
PARS2a	lea	normasc+104(pc),a3
	moveq	#104-1,d7
PARS3	cmp.b	-(a3),d0
	beq.b	pars4
	dbra	d7,pars3

PARSERR	sub.l	a5,a2
	move.l	a2,d7
	moveq	#-1,d6
	lea	pararg(pc),a3
	move.l	a5,(a3)
	lea	parerr(pc),a1
	lea	oktxt(pc),a2
	lea	abotags(pc),a0
	pea	parso(pc)
	movem.l	a0/a3-a4/a6,-(sp)
	bra.w	requs1

PARS4	move.b	d7,4(a1)
	bra.b	pars6

PARS5	lea	ctrlkey(pc),a3
	moveq	#0,d1
	bsr.b	pars7
	lea	shftkey(pc),a3
	moveq	#1,d1
	bsr.b	pars7
	lea	altkey(pc),a3
	moveq	#2,d1
	bsr.b	pars7
	lea	amikey(pc),a3
	moveq	#3,d1
	bsr.b	pars7

	lea	spckeys(pc),a3
PARS5a	move.l	a2,a4
PARS5d	tst.b	(a4)
	beq.b	pars5c
	move.b	(a4)+,d0
	cmp.b	(a3)+,d0
	beq.b	pars5d
PARS5b	tst.b	(a3)+
	bne.b	pars5b
	addq.l	#1,a3
	tst.b	(a3)
	bne.b	pars5a
	bra.b	parserr

PARS5c	move.b	1(a3),d0
	bra.b	pars2a

PARS6	tst.b	(a0)
	bne.w	pars0
	tst.b	4(a1)
	beq.b	parserr
PARSO	tst.w	d6
	rts

PARS7	move.l	a2,a4
	cmp.b	(a3)+,d0
	bne.b	pars8a
PARS8	tst.b	(a3)
	beq.b	pars9
	move.b	(a4)+,d0
	cmp.b	(a3)+,d0
	beq.b	pars8
PARS8a	rts
PARS9	move.b	#-1,(a1,d1.w)
	addq.l	#4,sp
	bra.b	pars6

PARARG	dc.l	0
PARERR	dc.b	"Can't parse the following hotkey:",10,"'%s'",0

CTRLKEY	dc.b	4,"ctrl",0
SHFTKEY	dc.b	5,"shift",0
ALTKEY	dc.b	3,"alt",0
AMIKEY	dc.b	5,"amiga",0

SPCKEYS	dc.b	"esc",0,27
	dc.b	"del",0,20
	dc.b	"help",0,15
	dc.b	"f1",0,133
	dc.b	"f2",0,134
	dc.b	"f3",0,135
	dc.b	"f4",0,136
	dc.b	"f5",0,137
	dc.b	"f6",0,138
	dc.b	"f7",0,139
	dc.b	"f8",0,140
	dc.b	"f9",0,141
	dc.b	"f10",0,142
	dc.b	"space",0,32
	dc.b	"return",0,10
	dc.b	0
	even
;------------------------------------------------------------------------------
; Setup The Menu
;

SETMENU	move.l	winhd(pc),a0
	move.l	Window_WScreen(a0),a0
	lea	Screen_RastPort(a0),a0
	move.l	RastPort_Font(a0),a0
	move.l	$2c(a0),a1		;Font Size Table
	move.l	$30(a0),a5		;Kern Table
	moveq	#0,d7
	move.b	$15(a0),d7		;Font YSize

	lea	menustr,a2
MENLOP	moveq	#0,d6
	move.l	Menu_FirstItem(a2),a3
	move.l	Menu_MenuName(a2),a4
	bsr.w	calwidt
	add.w	$18(a0),d1
	move.w	d1,Menu_Width(a2)
	move.w	d7,Menu_Height(a2)

	moveq	#0,d5
MENLOP1	move.l	MenuItem_ItemFill(a3),a4
	move.l	IntuiText_IText(a4),a4
	cmp.w	#$c0,MenuItem_Flags(a3)
	beq.b	menlop2
	bsr.w	calwidt
	move.w	d1,-(sp)
	moveq	#0,d1
	lea	keytxt(pc),a4
	move.b	MenuItem_Command(a3),d0
	beq.b	menlp1a
	move.b	d0,(a4)
	bsr.b	calwidt
MENLP1a	add.w	(sp)+,d1
	cmp.w	d5,d1
	blt.b	menlop2
	move.w	d1,d5
MENLOP2	tst.l	(a3)
	beq.b	menlop3
	move.l	(a3),a3
	bra.b	menlop1

MENLOP3	tst.b	MenuItem_Command(a3)
	beq.b	menlp3a
	move.w	$18(a0),d1
	mulu	#5,d1
	add.w	d1,d5
MENLP3a	move.l	Menu_FirstItem(a2),a3
MENLOP4	move.w	d6,MenuItem_TopEdge(a3)
	cmp.w	#$c0,MenuItem_Flags(a3)
	bne.b	menlop5
	addq.w	#8,d6
	move.l	MenuItem_ItemFill(a3),a4
	move.w	d5,Image_Width(a4)
	bra.b	menlop6

MENLOP5	move.w	d7,d1
	addq.w	#2,d1
	move.w	d1,MenuItem_Height(a3)
	add.w	d7,d6
	addq.w	#2,d6

MENLOP6	move.w	d5,MenuItem_Width(a3)
	tst.l	(a3)
	beq.b	menlop7
	move.l	(a3),a3
	bra.b	menlop4

MENLOP7	tst.l	(a2)
	beq.b	menlop8
	move.w	Menu_Width(a2),d0
	add.w	$18(a0),d0
	add.w	$18(a0),d0
	add.w	Menu_LeftEdge(a2),d0
	move.l	(a2),a2
	move.w	d0,Menu_LeftEdge(a2)
	bra.w	menlop

MENLOP8	rts

; Calculate Width

CALWIDT	moveq	#0,d1
CALWID1	moveq	#0,d0
	move.b	(a4)+,d0
	beq.b	calout
	sub.b	$20(a0),d0
	add.w	d0,d0
	move.l	a1,d2
	beq.b	calwid2
	add.w	(a1,d0.w),d1
	add.w	(a5,d0.w),d1
	bra.b	calwid1
CALWID2	add.w	$18(a0),d1
	bra.b	calwid1
CALOUT	rts

KEYTXT	dc.b	0,0
;------------------------------------------------------------------------------
; About
;

ABOUT	move.l	reqbase(pc),a6
	sub.l	a3,a3
	lea	abotags(pc),a0
	lea	abotxt(pc),a1
	lea	oktxt(pc),a2
	jsr	rtEZRequestA(a6)
	rts

ABOTAGS	dc.l	RT_LockWindow,1
	dc.l	RT_UnderScore,"_"
	dc.l	RTEZ_Flags,EZREQF_CenterText
	dc.l	TAG_END

ABOTXT	TITLE
	dc.b	10,10
	dc.b	"A File Unpacker",10
	dc.b	" Copyright 1993-94, Thomas Neumann",10
	dc.b	"All rights reserved",10,10
	dc.b	"Thanks to Nico Franois for",10
	dc.b	"the brilliant reqtools.library",10,10
	dc.b	"Assembled on 28-Feb-1994",0
	even
;------------------------------------------------------------------------------
; Cancel
;

CANCEL	bsr.w	restore
	bra.b	use1

USE	bsr.w	parse
	bne.b	useo
USE1	bsr.w	clswin
	addq.l	#8,sp
	moveq	#-1,d0
USEO	rts
;------------------------------------------------------------------------------
; Quit
;

QUIT	bsr.w	clswin
	lea	10(sp),sp
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Save As
;

SAVEAS	lea	sptit(pc),a3
	moveq	#FI_Save,d0
	bsr.w	filreq
	beq.b	saveaso

	move.l	#fname,d1
	bra.b	savep1

SPTIT	dc.b	"Save Preferences...",0
	even
;------------------------------------------------------------------------------
; Save Preferences
;

SAVEP	move.l	#prename,d1
SAVEP1	move.l	d1,d7
	move.l	reqbase(pc),a6
	move.l	winhd(pc),a0
	jsr	rtLockWindow(a6)
	move.l	d0,-(sp)
	move.l	d7,d1
	bsr.w	wrpref			;Write Preferences
	bne.b	savepo
	lea	preerr(pc),a1
	lea	oktxt(pc),a2
	bsr.w	requs

SAVEPO	move.l	reqbase(pc),a6
	move.l	winhd(pc),a0
	move.l	(sp)+,a1
	jsr	rtUnlockWindow(a6)
SAVEASO	rts

PREERR	dc.b	"Preferences NOT saved!!!!",0
OKTXT	dc.b	"Okay",0
	even
;------------------------------------------------------------------------------
; Open
;

OPN	lea	rptit(pc),a3
	moveq	#FI_Load,d0
	bsr.w	filreq
	beq.b	saveaso

	move.l	#fname,d1
	bra.b	lstsav1

RPTIT	dc.b	"Read Preferences...",0
	even
;------------------------------------------------------------------------------
; Last Saved
;

LASTSAV	move.l	#prename,d1
LSTSAV1	move.l	d1,d7
	move.l	reqbase(pc),a6
	move.l	winhd(pc),a0
	jsr	rtLockWindow(a6)
	move.l	d0,-(sp)
	move.l	d7,d1
	bsr.w	rdpref			;Read Preferences
	bne.b	lstsav2
	lea	preerr1(pc),a1
	lea	oktxt(pc),a2
	bsr.w	requs

LSTSAV2	move.l	reqbase(pc),a6
	move.l	winhd(pc),a0
	move.l	(sp)+,a1
	jsr	rtUnlockWindow(a6)

	move.l	intbase(pc),a6
	lea	gads(pc),a0
	move.l	winhd(pc),a1
	sub.l	a2,a2
	jsr	RefreshGadgets(a6)
	rts

PREERR1	dc.b	"Error while reading preferences!!!",0
	even
;------------------------------------------------------------------------------
; Reset To Default
;

DEFAULT	lea	popbuf(pc),a0
	lea	unpbuf(pc),a1
	lea	dbuf1(pc),a2
	lea	dbuf2(pc),a3
	moveq	#32-1,d7
DEFBUF1	move.b	(a2)+,(a0)+
	move.b	(a3)+,(a1)+
	dbra	d7,defbuf1

	lea	sufbuf(pc),a0
	lea	dbuf3(pc),a1
	moveq	#8-1,d7
DEFBUF2	move.b	(a1)+,(a0)+
	dbra	d7,defbuf2

	lea	dbuf4(pc),a0
	move.w	(a0),gads3+12
	move.w	2(a0),gads4+12
	move.w	4(a0),gads5+12

	lea	m3txt,a0
	moveq	#10-1,d7
DEFBUF3	moveq	#20-1,d6
DEFBUF4	move.b	#" ",(a0)+
	dbra	d6,defbuf4
	addq.l	#4,a0
	dbra	d7,defbuf3

	move.l	winhd(pc),d0
	beq.b	defbuf5
	move.l	intbase(pc),a6
	lea	gads(pc),a0
	move.l	d0,a1
	sub.l	a2,a2
	jsr	RefreshGadgets(a6)
DEFBUF5	rts
;------------------------------------------------------------------------------
; Restore
;

RESTORE	lea	popbuf(pc),a0
	lea	unpbuf(pc),a1
	lea	cbuf1(pc),a2
	lea	cbuf2(pc),a3
	moveq	#32-1,d7
RESBUF1	move.b	(a2)+,(a0)+
	move.b	(a3)+,(a1)+
	dbra	d7,resbuf1

	lea	sufbuf(pc),a0
	lea	cbuf3(pc),a1
	moveq	#8-1,d7
RESBUF2	move.b	(a1)+,(a0)+
	dbra	d7,resbuf2

	lea	cbuf4(pc),a0
	move.w	(a0),gads3+12
	move.w	2(a0),gads4+12
	move.w	4(a0),gads5+12

	move.l	intbase(pc),a6
	lea	gads(pc),a0
	move.l	winhd(pc),a1
	sub.l	a2,a2
	jsr	RefreshGadgets(a6)
	rts
;------------------------------------------------------------------------------
; Print Text
;
; IN :	A0 = Pointer To A String
;
; OUT:	Nothing
;

LPRINT	movem.l	d0-d3/a0/a6,-(sp)
	move.l	a0,d2
	moveq	#-1,d3
LPRINT1	tst.b	(a0)+			;Count Length
	dbeq	d3,lprint1
	not.l	d3

	move.l	dosbase(pc),a6
	move.l	lwinhd(pc),d1
	jsr	Write(a6)
	movem.l	(sp)+,d0-d3/a0/a6
	rts
;------------------------------------------------------------------------------
; List Files
;

LIST	lea	lstit(pc),a3
	moveq	#FI_Load!FI_Multi,d0
	bsr.w	filreq
	beq.w	listo
	move.l	d0,fillst

	move.l	dosbase(pc),a6
	move.l	#conwin,d1
	move.l	#1005,d2
	jsr	Open(a6)		;Open List Window
	move.l	d0,lwinhd
	beq.w	listo

	move.l	#fname,d1
	moveq	#-2,d2
	jsr	Lock(a6)
	move.l	d0,lstlock
	beq.w	listo1

	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,oldlock

; Main Loop

	st	crlflg
	move.l	fillst(pc),a4
LIST1	move.l	rfl_Name(a4),a0
	move.l	rfl_StrLen(a4),d7
	lea	sname,a1
LIST2	move.b	(a0)+,(a1)+		;Copy Filename
	subq.l	#1,d7
	bne.b	list2
	clr.b	(a1)

	lea	sname,a0
	bsr.w	lprint			;Print Filename
	lea	scurtxt(pc),a0
	bsr.w	lprint			;Set Cursor

	move.l	unpbase(pc),a6
	move.l	infadr(pc),a0
	lea	sname,a1
	jsr	upDetermineFile(a6)
	tst.w	d0
	bne.b	list3
	lea	nctxt(pc),a0
	bsr.w	lprint
	bra.b	list4

LIST3	lea	boldtxt(pc),a0
	bsr.w	lprint
	move.l	infadr(pc),a0
	move.l	UI_CruncherName(a0),a0
	bsr.w	lprint
	lea	crtxt(pc),a0
	bsr.w	lprint

LIST4	move.l	4.w,a6
	move.l	inpport(pc),a0
	jsr	GetMsg(a6)		;A Message From The Input.device
	tst.l	d0
	beq.b	list4a			;Nup!
	move.l	d0,a0
	move.w	20(a0),d7

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	cmp.w	#MS_CtrlC,d7		;CTRL+C
	beq.b	list5

LIST4a	tst.l	(a4)
	beq.b	list5
	move.l	(a4),a4
	bra.w	list1

; Finished

LIST5	sf	crlflg
	lea	lmbtxt(pc),a0
	bsr.w	lprint

	st	lmbflg
LIST6	move.l	inpport(pc),a0
	moveq	#0,d1
	moveq	#1,d0
	move.b	MsgPort_SigBit(a0),d1
	asl.l	d1,d0

	move.l	4.w,a6
	jsr	Wait(a6)		;Wait For Signals

	move.l	inpport(pc),a0
	jsr	GetMsg(a6)		;Get The Message
	tst.l	d0
	beq.b	list6			;No Window Message

	move.l	d0,a0
	move.w	20(a0),d7

	move.l	a0,a1
	jsr	ReplyMsg(a6)		;Send Message Back (Free Memory)

	cmp.w	#MS_LMB,d7		;Left Mouse Button
	bne.b	list6
	sf	lmbflg

LISTO2	move.l	dosbase(pc),a6
	move.l	oldlock(pc),d1
	jsr	CurrentDir(a6)

	move.l	lstlock(pc),d1
	jsr	Unlock(a6)

LISTO1	move.l	lwinhd(pc),d1
	jsr	Close(a6)		;Close Window Again

	move.l	reqbase(pc),a6
	move.l	fillst(pc),a0
	jsr	rtFreeFileList(a6)
	clr.l	fillst
LISTO	rts

LSTIT	dc.b	"Select files to scan...",0
CONWIN	dc.b	"CON:0/0/640/200/Unpacker List",0
BOLDTXT	dc.b	$9b,"1;31;40m",0
SCURTXT	dc.b	13,$9b,"50C",0
NCTXT	dc.b	"Not crunched"
CRTXT	dc.b	10,$9b,"0;31;40m",0
LMBTXT	dc.b	$9b,"3;31;40mPress left mouse button to continue...",10,0
	even
;------------------------------------------------------------------------------
; Unpack Files
;

UNPCK	lea	unptit(pc),a3
	moveq	#FI_Load!FI_Multi,d0
	bsr.w	filreq
	beq.w	unpo
	move.l	d0,fillst

	lea	fname,a0
	lea	dname,a5
UNPCK1	move.b	(a0)+,(a5)+		;Copy Directory Name
	bne.b	unpck1

	move.l	fillst(pc),a0
	move.l	a0,a4
	subq.l	#1,a5
	moveq	#1,d6
	moveq	#1,d5
UNPCK1a	tst.l	(a0)
	beq.b	unpck1b
	addq.l	#1,d6
	move.l	(a0),a0
	bra.b	unpck1a

UNPCK1b	move.l	infadr(pc),a0
	move.l	a5,UI_UserData(a0)
	move.l	#fname,UI_Path(a0)
	move.l	#unpsave,UI_Jump(a0)
	move.l	#untrsav,UI_TrackJump(a0)
	move.l	#untrerr,UI_TrkErrJump(a0)
	move.b	#UFN_Protect,UI_Flag(a0)

	lea	fname1,a0
	moveq	#108-1,d7
UNPCK2	clr.b	(a0)+
	dbra	d7,unpck2

	lea	unptit1(pc),a3
	moveq	#FI_Save!FI_NoFiles,d0
	bsr.w	filreq
	beq.w	unpo1

; Make Process Window

	move.l	a4,-(sp)
	move.l	reqbase(pc),a6
	lea	protags(pc),a0
	lea	protxt(pc),a1
	lea	pstptxt(pc),a2
	sub.l	a3,a3
	sub.l	a4,a4
	jsr	rtEZRequestA(a6)	;Process Window
	cmp.l	#Call_Handler,d0
	bne.w	unpo1

	move.l	intbase(pc),a6
	move.l	IntuitionBase_ActiveWindow(a6),preqhd
	bsr.w	pdrwbor
	move.l	(sp)+,a4
	move.l	#0,-(sp)

; Main Loop

UNPCK3	move.l	rfl_Name(a4),a0
	move.l	rfl_StrLen(a4),d7
	move.l	a5,a1
	move.l	a0,ncrdat
UNPCK4	move.b	(a0)+,(a1)+		;Copy Filename
	subq.l	#1,d7
	bne.b	unpck4
	clr.b	(a1)

	lea	fuctxt1(pc),a0
	move.l	a5,a1
	moveq	#17,d0
	bsr.w	fucpri			;Print Filename

	lea	notxt(pc),a0
	moveq	#43,d0
	bsr.w	fucpri			;Clear Cruncher Field

	bsr.w	pdrwbor
	move.l	d5,d0
	move.l	d6,d1
	bsr.w	pfilbox			;Fill Box

	move.l	unpbase(pc),a6
	move.l	infadr(pc),a0
	lea	dname,a1
	jsr	upDetermineFile(a6)
	tst.w	d0
	bne.b	unpck7

; Determine Error!!

	move.l	infadr(pc),a0
	move.w	gads5+12(pc),d0
	btst	#7,d0
	beq.w	unpcker
	cmp.w	#ERR_Determine,UI_ErrorNum(a0)
	bne.w	unpcker

; Copy File

	jsr	upLoadFile(a6)		;Load The File
	tst.w	d0
	beq.w	unpcker
	move.l	a4,-(sp)
	move.l	infadr(pc),a4
	move.l	UI_UserData(a4),a1
	bsr.w	unpsav0			;Save The File
	move.l	(sp)+,a4
	move.l	unpbase(pc),a6
	move.l	infadr(pc),a0
	jsr	upFreeFile(a6)		;Free The Memory Again
	bra.w	unpck8

UNPCK5	lea	gadtxt(pc),a2
	lea	ncrdat(pc),a3
	bsr.w	requs
	beq.w	unpo2
	bsr.w	pdrwbor
	bra.w	unpck8

UNPCK7	lea	fuctxt2(pc),a0
	move.l	infadr(pc),a1
	move.l	UI_CruncherName(a1),a1
	moveq	#43,d0
	bsr.w	fucpri			;Print Cruncher

	move.l	infadr(pc),a0
	move.b	UI_CrunchType(a0),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Track,d0
	bne.b	unpck7a
	bsr.w	volreq
	beq.b	unpck8

	bsr.w	pdrwbor
	move.l	d5,d0
	move.l	d6,d1
	bsr.w	pfilbox			;Fill Box

	lea	fuctxt1(pc),a0
	move.l	a5,a1
	moveq	#17,d0
	bsr.w	fucpri			;Print Filename

	move.l	unpbase(pc),a6
	move.l	infadr(pc),a0
	lea	fname,a1
	jsr	upUseDrive(a6)
	move.l	d0,udrvinf
	beq.b	unpcker

UNPCK7a	sf	noerr
	move.l	infadr(pc),a0
	jsr	upUnpack(a6)
	tst.w	d0
	bne.b	unpck8

; Unpack Error

UNPCKER	move.l	udrvinf(pc),d0
	beq.b	unpcke1
	move.l	d0,a0
	jsr	upUnuseDrive(a6)
	clr.l	udrvinf

UNPCKE1	tst.b	noerr
	beq.b	unpcke2
	move.l	#-1,(sp)
	bra.b	unpck8

UNPCKE2	move.l	infadr(pc),a0
	move.l	UI_ErrorMsg(a0),a1
	bra.w	unpck5

UNPCK8	move.l	udrvinf(pc),d0
	beq.b	unpck8a
	move.l	d0,a0
	jsr	upUnuseDrive(a6)
	clr.l	udrvinf

UNPCK8a	tst.l	(a4)
	beq.b	unpo2

	bsr.w	pwinmes
	beq.b	unpck9
	move.l	#-1,(sp)
	bra.b	unpo2

UNPCK9	move.l	(a4),a4
	addq.l	#1,d5
	bra.w	unpck3

; Get Out

UNPO2	tst.l	(sp)+
	bne.b	unpo1
	move.l	reqbase(pc),a6
	move.l	phanpoi(pc),a1
	lea	rendtag(pc),a0
	moveq	#0,d0
	jsr	rtReqHandlerA(a6)	;Stop Requester
	clr.l	phanpoi

UNPO1	move.l	reqbase(pc),a6
	move.l	fillst(pc),a0
	jsr	rtFreeFileList(a6)
	clr.l	fillst
UNPO	rts

; Save Routine

UNPSAVE	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	unpsavo

UNPSAV0	lea	fname,a0
UNPSAV1	tst.b	(a0)+
	bne.b	unpsav1
	subq.l	#1,a0
	move.l	a0,a3

	tst.b	UI_UseFilenamePointer(a4)
	beq	unpsav2
	move.l	UI_Filename(a4),a1
UNPSAV2	move.b	(a1)+,(a0)+
	bne.b	unpsav2
	subq.l	#1,a0

	lea	sufbuf(pc),a1
UNPSAV3	move.b	(a1)+,(a0)+
	bne.b	unpsav3

UNPSAV4	move.l	dosbase(pc),a6
	move.l	#fname,d1
	move.l	#1006,d2
	jsr	Open(a6)
	tst.l	d0
	beq.b	unpsav5

	move.l	d0,-(sp)
	move.l	d0,d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Write(a6)

	move.l	(sp)+,d1
	jsr	Close(a6)
UNPSAV5	clr.b	(a3)
UNPSAVO	rts

; Track-Packed Save Routine

UNTRSAV	lea	utrktxt(pc),a0
	move.w	UI_Track(a4),d0
	swap	d0
	move.l	d0,a1
	moveq	#43,d0
	bsr.w	fucpri

	move.l	udrvinf(pc),a0
	move.l	UI_DecrunchAdr(a4),a1
	move.l	UI_Offset(a4),d1
	move.l	UI_DecrunchLen(a4),d2
	moveq	#3,d0			;CMD_Write
	jsr	upSendCmd(a6)
	bne.w	untrsv4

	move.w	gads4+12(pc),d0		;Verify?
	btst	#7,d0
	beq.b	untrsv2			;Nap!

	lea	uvertxt(pc),a0
	move.w	UI_Track(a4),d0
	swap	d0
	move.l	d0,a1
	moveq	#43,d0
	bsr.w	fucpri

	move.l	4.w,a6
	move.l	UI_DecrunchLen(a4),d0
	move.l	#$10002,d1
	jsr	AllocMem(a6)
	tst.l	d0
	beq.b	untrsv2
	move.l	d0,a5

	move.l	unpbase(pc),a6
	move.l	udrvinf(pc),a0
	move.l	a5,a1
	move.l	UI_Offset(a4),d1
	move.l	UI_DecrunchLen(a4),d2
	moveq	#2,d0			;CMD_Read
	jsr	upSendCmd(a6)
	bne.b	untrsv4

	move.l	a5,a0
	move.l	UI_DecrunchAdr(a4),a1
	move.l	UI_DecrunchLen(a4),d6
UNTRSV1	move.b	(a0)+,d0
	cmp.b	(a1)+,d0
	bne.b	untrsv3
	subq.l	#1,d6
	bne.b	untrsv1

	move.l	4.w,a6
	move.l	a5,a1
	move.l	UI_DecrunchLen(a4),d0
	jsr	FreeMem(a6)

UNTRSV2	lea	uunptxt(pc),a0
	move.w	UI_Track(a4),d0
	swap	d0
	move.l	d0,a1
	moveq	#43,d0
	bsr.w	fucpri

	moveq	#0,d0
	bsr.w	pwinmes
	beq.b	untsv2a
	st	noerr
	moveq	#-1,d0
UNTSV2a	rts

UNTRSV3	move.l	4.w,a6
	move.l	a5,a1
	move.l	UI_DecrunchLen(a4),d0
	jsr	FreeMem(a6)

	lea	verrtxt(pc),a1
	moveq	#0,d0
	bra.b	untrsv5

UNTRSV4	lea	trkerr(pc),a1
UNTRSV5	moveq	#-1,d6
	move.w	d0,-(sp)
	lea	trgdtxt(pc),a2
	move.l	sp,a3
	bsr.w	requs
	beq.b	untrsv6
	moveq	#0,d6

UNTRSV6	bsr.w	pdrwbor
	move.l	d5,d0
	move.l	d6,d1
	bsr.w	pfilbox			;Fill Box

	addq.l	#2,sp
	move.l	d6,d0
	rts

; Track-Packer Error Routine

UNTRERR	moveq	#-1,d6
	move.l	UI_ErrorMsg(a4),a1
	lea	trgdtxt(pc),a2
	bsr.w	requs
	beq.b	untrero
	moveq	#0,d6

UNTRERO	move.l	d6,d0
	rts

UTRKTXT	dc.b	"Writing   track %2d....",0
UVERTXT	dc.b	"Verifying track %2d....",0
UUNPTXT	dc.b	"Unpacking track %2d....",0
	even
;------------------------------------------------------------------------------
; Test For Window Message

PWINMES	movem.l	d0-d1/a0-a1/a6,-(sp)
	move.l	reqbase(pc),a6
	move.l	phanpoi(pc),a1
	sub.l	a0,a0
	moveq	#0,d0
	cmp.l	a1,d0
	bne.b	pwimes1
	move.l	#Call_Handler,d7
	bra.b	pwimes2

PWIMES1	jsr	rtReqHandlerA(a6)
	move.l	d0,d7
PWIMES2	movem.l	(sp)+,d0-d1/a0-a1/a6
	cmp.l	#Call_Handler,d7
	rts
;------------------------------------------------------------------------------
; Draw Border
;

PDRWBOR	tst.l	phanpoi
	beq.b	pdrboro
	move.l	intbase(pc),a6
	move.l	preqhd(pc),a0
	move.l	Window_RPort(a0),a0
	lea	probor(pc),a1
	moveq	#32+2,d0
	moveq	#19,d1
	jsr	DrawBorder(a6)		;Draw Main Border
PDRBORO	rts
;------------------------------------------------------------------------------
; Fill Box
;
; IN :	D0 = Number Of Files Taken
;	D1 = Total Number Of Files
;

PFILBOX	movem.l	d0-d4/a0-a1/a5-a6,-(sp)
	tst.l	phanpoi
	beq.b	pfiboxo

	move.l	d1,d2
	moveq	#100,d1
	bsr.w	mul32
	move.l	d2,d0
	bsr.w	div32
	add.l	d0,d0
	add.l	d0,d0
	move.l	d0,d2			;Width
	beq.b	pfiboxo

	move.l	gfxbase(pc),a6
	move.l	preqhd(pc),a5
	move.l	Window_RPort(a5),a5

	move.l	a5,a1
	moveq	#0,d0
	jsr	SetDrMd(a6)		;Set New Drawing Mode
	move.l	a5,a1
	moveq	#3,d0
	jsr	SetAPen(a6)		;Set New Pen Color
	move.l	a5,a1
	moveq	#33+2,d0
	moveq	#29,d1
	add.w	d0,d2
	moveq	#38,d3
	jsr	RectFill(a6)		;Fill Area
PFIBOXO	movem.l	(sp)+,d0-d4/a0-a1/a5-a6
	rts
;------------------------------------------------------------------------------
; Function Print Routine
;

FUCPRI	movem.l	d0-d1/a0-a3/a6,-(sp)
	move.w	d0,fpripo1+2
	move.w	d0,fpripo2+2
	move.l	a1,parpoi
	tst.l	phanpoi
	beq.b	fucprio

	move.l	4.w,a6
	lea	parpoi(pc),a1
	lea	fucpri1(pc),a2		;Store Character Routine
	lea	fuctxt(pc),a3		;New Text
	clr.w	ptxtlen			;Clear Line Counter
	jsr	RawDoFmt(a6)

	move.w	ptxtlen(pc),d0
	sub.w	#50,d0
	neg.w	d0
	lsl.w	#2,d0			;*8/2
	add.w	#32+2,d0
	move.w	d0,fpripo2

	move.l	intbase(pc),a6
	move.l	preqhd(pc),a0
	move.l	Window_RPort(a0),a0
	lea	fpristr(pc),a1
	moveq	#0,d0
	moveq	#0,d1
	jsr	PrintIText(a6)		;Clear Message Line

FUCPRIO	movem.l	(sp)+,d0-d1/a0-a3/a6
	rts

; Count Routine

FUCPRI1	tst.b	d0
	beq.b	fucpri2
	move.b	d0,(a3)+
	cmp.w	#50,ptxtlen
	beq.b	fucpri2
	addq.w	#1,ptxtlen
	rts

FUCPRI2	clr.b	(a3)
	rts
;------------------------------------------------------------------------------
; Multiply32
;
; IN :	D0 = Number 1
;	D1 = Number 2
;
; OUT:	D0 = Result High 32 Bit
;	D1 = Result Low 32 Bit
;

MUL32	movem.l	d2-d4,-(sp)
	move.w	d1,d2
	move.l	d1,d3
	swap	d3
	move.w	d3,d4

	mulu	d0,d1
	mulu	d0,d3
	swap	d0
	mulu	d0,d2
	mulu	d4,d0

	swap	d1
	add.w	d2,d1
	clr.w	d2
	swap	d2
	addx.l	d2,d0

	add.w	d3,d1
	clr.w	d3
	swap	d3
	addx.l	d3,d0

	swap	d1
	movem.l	(sp)+,d2-d4
	rts
;------------------------------------------------------------------------------
; Divide32
;
; IN :	D0 = Denominator
;	D1 = Numerator
;
; OUT:	D0 = Result
;

DIV32	movem.l	d1-d2,-(sp)
	moveq	#0,d2

	REPT	33
	sub.l	d0,d2
	bcc.b	*+4
	add.l	d0,d2
	addx.l	d1,d1
	addx.l	d2,d2
	ENDR

	not.l	d1
	move.l	d1,d0
	movem.l	(sp)+,d1-d2
	rts
;------------------------------------------------------------------------------
NCRDAT	dc.l	0
PREQHD	dc.l	0
PHANPOI	dc.l	0
FILLST	dc.l	0
PTXTLEN	dc.w	0
PARPOI	dc.l	0

PROTAGS	dc.l	RTEZ_ReqTitle,protit
	dc.l	RT_ReqPos,ReqPos_CenterWin
	dc.l	RT_ReqHandler,phanpoi
	dc.l	RT_UnderScore,"_"
	dc.l	RT_LockWindow,1
	dc.l	TAG_END,0

RENDTAG	dc.l	RTRH_EndRequest,0
	dc.l	TAG_END,0

PROBOR	dc.w	0,0
	dc.b	1,0,0,3
	dc.l	procor,probor1

PROBOR1	dc.w	0,0
	dc.b	2,0,0,3
	dc.l	procor1,0

PROCOR	dc.w	0,20,0,9,402,9
PROCOR1	dc.w	402,9,402,20,0,20

FPRISTR	dc.b	1,0,1,0
FPRIPO1	dc.w	32+2,17
	dc.l	0,fuctxtc,fprist1

FPRIST1	dc.b	1,0,0,0
FPRIPO2	dc.w	0,17
	dc.l	0,fuctxt,0

PROTIT	dc.b	"Unpacking.....",0
UNPTIT	dc.b	"Select Files to Unpack...",0
UNPTIT1	dc.b	"Select File-Unpack Directory...",0
UNPTIT2	dc.b	"Save File...",0
GADTXT	dc.b	"Continue| Cancel ",0

PROTXT	dc.b	10
	blk.b	50,32
	dc.b	10,0
PSTPTXT	dc.b	"_STOP",0

FUCTXTC	blk.b	50,32
	dc.b	0
FUCTXT	blk.b	50,32
	dc.b	0

FUCTXT1	dc.b	"Unpacking '%s'",0
FUCTXT2	dc.b	"Crunched with %s",0
NOTXT	dc.b	0
	even
;------------------------------------------------------------------------------
; Select New ARexx Macro
;

SELAM1	lea	am1str,a0
	lea	m3txt,a1
	bra.b	selma

SELAM2	lea	am2str,a0
	lea	m3txt1,a1
	bra.b	selma

SELAM3	lea	am3str,a0
	lea	m3txt2,a1
	bra.b	selma

SELAM4	lea	am4str,a0
	lea	m3txt3,a1
	bra.b	selma

SELAM5	lea	am5str,a0
	lea	m3txt4,a1
	bra.b	selma

SELAM6	lea	am6str,a0
	lea	m3txt5,a1
	bra.b	selma

SELAM7	lea	am7str,a0
	lea	m3txt6,a1
	bra.b	selma

SELAM8	lea	am8str,a0
	lea	m3txt7,a1
	bra.b	selma

SELAM9	lea	am9str,a0
	lea	m3txt8,a1
	bra.b	selma

SELAM10	lea	am10str,a0
	lea	m3txt9,a1

SELMA	movem.l	a0-a1,-(sp)
	lea	selatit(pc),a3
	moveq	#FI_Load,d0
	bsr.w	filreq
	beq.b	selmao

	movem.l	(sp)+,a0-a1
	lea	fname,a2
	moveq	#64-1,d7
SELMA1	move.b	(a2)+,(a0)+
	beq.b	selma2
	dbra	d7,selma1

SELMA2	lea	fname1,a2
	moveq	#20-1,d6
SELMA3	move.b	(a2)+,(a1)+
	beq.b	selma4
	dbra	d6,selma3
	bra.b	selma6

SELMA4	subq.l	#1,a1
SELMA5	move.b	#" ",(a1)+
	dbra	d6,selma5
SELMA6	rts

SELMAO	addq.l	#8,sp
	rts

SELATIT	dc.b	"Select ARexx Macro",0
	even
;------------------------------------------------------------------------------
; Define Port Handler
;

	STRUCTURE PortHandler,0
	APTR	PH_ARexxPort		;The port the messages come in at
	APTR	PH_RexxSysBase		;The library pointer
	LONG	PH_OutStanding		;The count of outstanding ARexx Msg.
	STRUCT	PH_PortName,24		;The port name
	STRUCT	PH_ErrorName,28		;The name of the <base>.LASTERROR
	STRUCT	PH_ResultName,26	;The name of the <base>.RESULT
	STRUCT	PH_Extension,8		;Default filename extension
	LABEL	PortHandler_SIZEOF

REXX_RETURN_ERROR	=	-1
;------------------------------------------------------------------------------
; **** InitARexx ****
;
; IN :	A0 = Name of the port - Has to be null-terminated
;	A1 = File extension (0=Rexx) - Has to be null-terminated
;
; OUT:	D0 = Port Handler (0=No Port Made)
;

InitARexx
	movem.l	d7/a3-a6,-(sp)
	move.l	a0,a3
	move.l	a1,a4

	move.l	4.w,a6
	moveq	#PortHandler_SIZEOF,d0
	move.l	#$10001,d1
	jsr	AllocMem(a6)		;Allocate Port Handler
	move.l	d0,a5
	beq.w	initaro

;	lea	slibnam(pc),a1
;	moveq	#0,d0
;	jsr	OpenLibrary(a6)
;	move.l	d0,PH_RexxSysBase(a5)
;	beq	initare

; Setup Extension

	move.l	a4,d0
	bne.b	initar1
	lea	defext(pc),a4
INITAR1	lea	PH_Extension(a5),a0
	moveq	#8-1,d7
INITAR2	move.b	(a4)+,d0
	beq.b	initar3
	move.b	d0,(a0)+
	dbra	d7,initar2
INITAR3	clr.b	(a0)

; Setup Port Name

;	move.l	PH_RexxSysBase(a5),a6
	lea	PH_PortName(a5),a0
	move.l	a0,a1
	moveq	#16-1,d7
INITAR4	move.b	(a3)+,d0
	beq.b	initar5
;	jsr	Rexx_ToUpper(a6)
	move.b	d0,(a0)+
	dbra	d7,initar4
INITAR5	clr.b	(a0)

; Setup The Last Error RVI Name & Result Variable

	lea	PH_PortName(a5),a0
	lea	PH_ErrorName(a5),a1
	lea	PH_ResultName(a5),a2
INITAR6	move.b	(a0),(a1)+
	move.b	(a0)+,(a2)+
	bne.b	initar6
	subq.l	#1,a1
	subq.l	#1,a2

	lea	lsterr(pc),a0
INITAR7	move.b	(a0)+,(a1)+
	bne.b	initar7

	lea	resstr(pc),a0
INITA7a	move.b	(a0)+,(a2)+
	bne.b	inita7a

; Test For Existing Ports

	move.l	4.w,a6
	jsr	Forbid(a6)

	lea	PH_PortName(a5),a4
	move.l	a4,a3
INITAR8	tst.b	(a3)+
	bne.b	initar8
	subq.l	#1,a3

INITAR9	move.l	a4,a1
	jsr	FindPort(a6)		;Find Port
	tst.l	d0
	beq.b	inita11			;Did NOT Exist!

	tst.b	(a3)
	bne.b	inita10
	move.b	#"0",(a3)
INITA10	addq.b	#1,(a3)
	cmp.b	#$3a,(a3)		; Can Only Make 10 Ports, Else An Error
	bne.b	initar9
	jsr	Permit(a6)
	bra.b	initare

; Made The Port

INITA11	lea	PH_PortName(a5),a0
	moveq	#0,d0
	bsr.w	CreatePort
	move.l	d0,PH_ARexxPort(a5)
	bne.b	inita12
	jsr	Permit(a6)
	bra.b	initare

INITA12	jsr	Permit(a6)
	move.l	a5,d0

INITARO	movem.l	(sp)+,d7/a3-a6
	tst.l	d0
	rts

; Error Routine

INITARE	move.l	4.w,a6
	tst.l	PH_RexxSysBase(a5)
	beq.b	initae1
	move.l	PH_RexxSysBase(a5),a1
	jsr	CloseLibrary(a6)

INITAE1	move.l	a5,a1
	moveq	#PortHandler_SIZEOF,d0
	jsr	FreeMem(a6)
	moveq	#0,d0
	bra.b	initaro

SLIBNAM	dc.b	"rexxsyslib.library",0
DEFEXT	dc.b	"rexx",0
LSTERR	dc.b	".LASTERROR",0
RESSTR	dc.b	".RESULT",0
	even
;------------------------------------------------------------------------------
; **** FreeARexx ****
;
; IN :	A5 = Port Handler
;
; OUT:	Nothing
;

FreeARexx
	movem.l	a4-a6,-(sp)
	move.l	a5,d0
	beq.b	freeao
	clr.b	PH_PortName(a5)		;Clear Port Name So It Can't Be Found

	move.l	4.w,a6
FREEAR1	tst.l	PH_Outstanding(a5)
	beq.b	freear3
	move.l	PH_ARexxPort(a5),a0
	jsr	WaitPort(a6)
FREEAR2	bsr.w	GetARexxMsg
	beq.b	freear1
	cmp.l	#REXX_RETURN_ERROR,d0
	beq.b	freear2
	move.l	d0,a4

; Blown Away All Messages

	move.l	a4,a0
	lea	errstr(pc),a1
	bsr.w	SetARexxLastError
	move.l	a4,a0
	sub.l	a1,a1
	moveq	#100,d0
	bsr.w	ReplyARexxMsg
	bra.b	freear2

; Clean Up The Port And Delete It

FREEAR3	tst.l	PH_ARexxPort(a5)
	beq.b	freear6
FREEAR4	bsr.b	GetARexxMsg
	beq.b	freear5
	move.l	d0,a4

	move.l	a4,a0
	lea	errstr(pc),a1
	bsr.w	SetARexxLastError
	move.l	a4,a0
	sub.l	a1,a1
	moveq	#100,d0
	bsr.w	ReplyARexxMsg
	bra.b	freear4

FREEAR5	move.l	PH_ARexxPort(a5),a0
	bsr.w	DeletePort

; Close Library And Free Memory

FREEAR6	tst.l	PH_RexxSysBase(a5)
	beq.b	freear7
	move.l	PH_RexxSysBase(a5),a1
	jsr	CloseLibrary(a6)

FREEAR7	move.l	a5,a1
	moveq	#PortHandler_SIZEOF,d0
	jsr	FreeMem(a6)

FREEAO	movem.l	(sp)+,a4-a6
	rts

ERRSTR	dc.b	"99: Port Closed!!",0
	even
;------------------------------------------------------------------------------
; **** ARexxName ****
;
; IN :	A5 = Port Handler
;
; OUT:	D0 = Port Name
;

ARexxName
	lea	PH_PortName(a5),a0
	move.l	a0,d0
	rts
;------------------------------------------------------------------------------
; **** ARexxSignal ****
;
; IN :	A5 = Port Handler
;
; OUT:	D0 = Signal Mask
;

ARexxSignal
	movem.l	d2/a5,-(sp)
	moveq	#0,d0
	move.l	a5,d1
	beq.b	arsigo

	moveq	#0,d1
	moveq	#1,d2
	move.l	PH_ARexxPort(a5),a0
	move.b	15(a0),d1
	asl.l	d1,d2
	move.l	d2,d0

ARSIGO	movem.l	(sp)+,d2/a5
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; **** GetARexxMsg ****
;
; IN :	A5 = Port Handler
;
; OUT:	D0 = Message
;

GetARexxMsg
	movem.l	d7/a4-a6,-(sp)
	sub.l	a4,a4
	move.l	a5,d0
	beq.b	getarmo

	move.l	4.w,a6
	move.l	PH_ARexxPort(a5),a0
	jsr	GetMsg(a6)
	move.l	d0,a4
	tst.l	d0
	beq.b	getarmo

	cmp.b	#7,8(a4)		;Reply Message?
	bne.b	getarmo			;Nip!
	moveq	#0,d7
	tst.l	RM_Result1(a4)
	beq.b	getarm1
	moveq	#-1,d7

; Free The Arguments And The Message

GETARM1	move.l	PH_RexxSysBase(a5),a6
	move.l	RM_Args(a4),a0
	jsr	Rexx_DeleteArgString(a6)

	move.l	a4,a0
	jsr	Rexx_DeleteRexxMsg(a6)
	subq.l	#1,PH_Outstanding(a5)

; Return The Error If There Was One

	sub.l	a4,a4
	tst.w	d7
	beq.b	getarmo
	move.l	#-1,a4

GETARMO	move.l	a4,d0
	movem.l	(sp)+,d7/a4-a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; **** ReplyARexxMsg ****
;
; IN :	A0 = Message
;	A1 = Pointer To A Result String
;	D0 = Error (0=Ok)
;	A5 = Port Handler
;
; OUT:	Nothing
;

ReplyARexxMsg
	movem.l	d7/a2/a4-a6,-(sp)

	move.l	d0,d7
	move.l	a5,d0
	beq.b	reparmo
	move.l	a0,d0
	beq.b	reparmo
	cmp.l	#REXX_RETURN_ERROR,a0
	beq.b	reparmo

	move.l	a0,a4
	clr.l	RM_Result2(a4)
	move.l	d7,RM_Result1(a4)	;Set The Variable RC To Error Number

	move.l	a1,d0
	beq.b	reparm2
	move.l	a1,a2
REPARM1	tst.b	(a2)+
	bne.b	reparm1
	subq.l	#1,a2
	sub.l	a1,a2
	move.l	a2,-(sp)		;Length
	move.l	a1,-(sp)		;String
	lea	PH_ResultName(a5),a0
	move.l	a0,-(sp)		;Result Name
	move.l	a4,-(sp)		;Message
	bsr.w	SetRexxVar
	lea	16(sp),sp

; Reply The Message To ARexx

REPARM2	move.l	4.w,a6
	move.l	a4,a1
	jsr	ReplyMsg(a6)

REPARMO	movem.l	(sp)+,d7/a2/a4-a6
	rts
;------------------------------------------------------------------------------
; **** SendARexxMsg ****
;
; IN :	A0 = Pointer To A String
;	D0 = String File Flag
;	A5 = Port Handler
;
; OUT:	D0 = Success (0=Error)
;

SendARexxMsg
	movem.l	d6-d7/a2-a6,-(sp)
	move.l	d0,d6
	move.l	a0,a3

	moveq	#0,d7
	move.l	a5,d0
	beq.w	sendaro
	move.l	a3,d0
	beq.w	sendaro

	move.l	PH_RexxSysBase(a5),a6
	move.l	PH_ARexxPort(a5),a0
	lea	PH_Extension(a5),a1
	lea	PH_PortName(a5),a2
	move.l	a2,d0
	jsr	Rexx_CreateRexxMsg(a6)
	move.l	d0,a4
	tst.l	d0
	beq.b	sendaro

	moveq	#0,d0
	tst.w	d6
	beq.b	sendar1
	moveq	#4,d0
	swap	d0
SENDAR1	or.l	#RXFUNC,d0
	move.l	d0,RM_Action(a4)

	move.l	a3,a0
SENDAR2	tst.b	(a0)+
	bne.b	sendar2
	subq.l	#1,a0
	sub.l	a3,a0
	move.l	a0,d0
	move.l	a3,a0
	jsr	Rexx_CreateArgString(a6)
	move.l	d0,RM_Args(a4)
	beq.b	sendar5

; Find REXX Port

	move.l	4.w,a6
	jsr	Forbid(a6)
	lea	rexxnam(pc),a1
	jsr	FindPort(a6)
	move.l	d0,a0
	tst.l	d0
	beq.b	sendar3

; We Found It, So We Send The Message

	move.l	a4,a1
	jsr	PutMsg(a6)
	addq.l	#1,PH_Outstanding(a5)
	moveq	#-1,d7
	bra.b	sendar4

; No Port Found

SENDAR3	move.l	PH_RexxSysBase(a5),a6
	move.l	RM_Args(a4),a0
	jsr	Rexx_DeleteArgString(a6)
	move.l	a4,a0
	jsr	Rexx_DeleteRexxMsg(a6)

SENDAR4	move.l	4.w,a6
	jsr	Permit(a6)
	bra.b	sendaro

SENDAR5	move.l	PH_RexxSysBase(a5),a6
	move.l	a4,a0
	jsr	Rexx_DeleteRexxMsg(a6)

SENDARO	move.l	d7,d0
	movem.l	(sp)+,d6-d7/a2-a6
	tst.l	d0
	rts

REXXNAM	dc.b	"REXX",0
	even
;------------------------------------------------------------------------------
; **** SetARexxLastError ****
;
; IN :	A0 = Message
;	A1 = Error String
;	A5 = Port Handler
;
; OUT:	D0 = Success (0=Error)
;

SetARexxLastError
	movem.l	d7/a2-a5,-(sp)
	move.l	a0,a4
	move.l	a1,a3
	moveq	#0,d7

	move.l	a5,d0
	beq.b	setaro
	move.l	a4,d0
	beq.b	setaro

	move.l	a4,a2
	bsr.b	CheckRexxMsg
	beq.b	setaro

	move.l	a3,a0
SETAR1	tst.b	(a0)+
	bne.b	setar1
	subq.l	#1,a0
	sub.l	a3,a0
	move.l	a0,-(sp)		;Length
	move.l	a3,-(sp)		;String
	lea	PH_ErrorName(a5),a0
	move.l	a0,-(sp)		;Error Name
	move.l	a4,-(sp)		;Message
	bsr.b	SetRexxVar
	lea	16(sp),sp
	tst.l	d0
	bne.b	setaro
	moveq	#-1,d7

SETARO	move.l	d7,d0
	movem.l	(sp)+,d7/a2-a5
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; CheckRexxMsg
;
; IN :	A2 = Message
;
; OUT:	D0 = Success (0=Error)
;

CheckRexxMsg
	movem.l	d2/a2/a6,-(sp)

	move.l	4.w,a6
	lea	slibnam(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)
	move.l	d0,d2
	beq.b	.check1
	move.l	d0,a1
	jsr	CloseLibrary(a6)

	moveq	#0,d0
	cmp.l	RM_LibBase(a2),d2
	bne.b	.check1
	cmp.l	RM_TaskBlock(a2),d1
	beq.b	.check1

	move.l	a2,a0
	move.l	d2,a6
	jsr	Rexx_IsRexxMsg(a6)

.CHECK1	movem.l	(sp)+,d2/a2/a6
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; SetRexxVar
;
; IN :	Message, Variable, Value
;
; OUT:	Success (0=Error)
;

SetRexxVar
	movem.l	4(sp),a0-a1
	movem.l	12(sp),d0-d1
	movem.l	d2-d7/a2-a6,-(sp)
	lea	-12(sp),sp

	move.l	a0,a2
	move.l	a1,a3
	move.l	d0,a5
	move.l	d1,d3
	lea	.setrx1(pc),a0
	move.l	sp,a1
	bsr.w	.serx14
	move.l	a2,a0
	bsr.b	CheckRexxMsg
	beq.b	.setrx2

	move.l	RM_LibBase(a2),a6
	moveq	#9,d0
	cmp.l	#$ffff,d3
	bgt.b	.setrx3
	move.l	RM_TaskBlock(a2),a0
	jsr	Rexx_CurrentEnv(a6)
	move.l	a0,a4
	move.l	a3,a0
	bsr.b	.setrx4
	bne.b	.setrx3
	move.l	a1,a2
	move.l	d1,d2
	move.l	a4,a0
	move.l	d2,d0
	jsr	Rexx_EnterSymbol(a6)
	move.l	d0,d4
	move.l	a4,a0
	move.l	a5,a1
	move.l	d3,d0
	bsr.w	.serx10
	beq.b	.setrx1
	move.l	a4,a0
	move.l	d0,a1
	move.l	d4,d0
	jsr	Rexx_SetValue(a6)
	moveq	#0,d0
	bra.b	.setrx3

.SETRX1	moveq	#3,d0
	bra.b	.setrx3

.SETRX2	moveq	#10,d0
.SETRX3	move.l	sp,a0
	move.l	d0,-(sp)
	bsr.w	.serx15
	move.l	(sp)+,d0
	lea	12(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts

.SETRX4	movem.l	d2-d3/a2-a3,-(sp)
	moveq	#0,d2
	moveq	#0,d3
	jsr	Rexx_StrLen(a6)
	move.l	a0,a1
	move.l	a4,a0
	bsr.b	.serx10
	move.l	d0,a2
	beq.b	.setrx7
	lea	8(a2),a1
	move.w	4(a2),d0
	move.l	a1,d1
.SETRX5	cmp.b	#".",(a1)+
	dbeq	d0,.setrx5
	bne.b	.setrx6
	exg	d1,a1
	sub.l	a1,d1
	move.l	a2,d3
	move.l	a4,a0
	move.l	d1,d0
	bsr.b	.serx10
	move.l	d0,a2
	beq.b	.setrx7
.SETRX6	lea	8(a2),a0
	jsr	Rexx_IsSymbol(a6)
	cmp.w	4(a2),d1
	beq.b	.setrx8
	moveq	#40,d2
	bra.b	.setrx8

.SETRX7	moveq	#3,d2
.SETRX8	tst.l	d2
	beq.b	.setrx9
	move.l	a4,a0
	move.l	a2,a1
	bsr.b	.serx12
	move.l	a4,a0
	move.l	d3,a1
	bsr.b	.serx12
.SETRX9	move.l	a2,a1
	move.l	d3,d1
	move.l	d2,d0
	movem.l	(sp)+,d2-d3/a2-a3
	rts

.SERX10	movem.l	d0/a1,-(sp)
	addq.l	#8,d0
	addq.l	#1,d0
	jsr	Rexx_GetSpace(a6)
	movem.l	(sp)+,d0/a1
	beq.b	.serx11
	move.l	a0,-(sp)
	clr.l	(a0)
	move.w	d0,4(a0)
	move.b	#2,6(a0)
	clr.b	8(a0,d0.l)
	addq.l	#8,a0
	jsr	Rexx_StrCpyN(a6)
	move.l	(sp)+,a0
	move.b	d0,7(a0)
.SERX11	move.l	a0,d0
	rts

.SERX12	move.l	a1,d1
	beq.b	.serx13
	moveq	#1,d0
	and.b	6(a1),d0
	bne.b	.serx13
	move.w	4(a1),d0
	addq.l	#8,d0
	addq.l	#1,d0
	jsr	Rexx_FreeSpace(a6)
.SERX13	rts

.SERX14	move.l	a3,-(sp)
	move.l	$14(a2),a3
	move.l	a2,(a1)
	movem.l	$fc(a3),d0-d1
	movem.l	a0-a1,$fc(a3)
	movem.l	d0-d1,4(a1)
	move.l	(sp)+,a3
	rts

.SERX15	move.l	(a0),a1
	move.l	$14(a1),a1
	movem.l	4(a0),d0-d1
	movem.l	d0-d1,$fc(a1)
	rts
;------------------------------------------------------------------------------
; **** ARexxParse ****
;
; IN :	A0 = Pointer To Command String Table (Has To Be UpperCased)
;	A1 = Pointer To Argument Table (8 Arguments)
;	A2 = Message
;	A5 = Port Handler
;
; OUT:	D0 = Success (0=Not Found, Will Set The Error Variable)
;	D1 = Command Number
;
; Command List:
;
; BYTE		Command Length
; STRING	Command
; BYTE		Number Of Arguments
;

ARexxParse
	movem.l	d2/d5-d7/a2-a6,-(sp)
	moveq	#0,d7
	move.l	a5,d0
	beq.w	arparo
	move.l	a2,d0
	beq.w	arparo
	cmp.l	#REXX_RETURN_ERROR,d0
	beq.w	arparo

	movem.l	a2/a5,-(sp)
	move.l	RM_Args(a2),a3
	move.l	a3,a6
ARPAR	cmp.b	#" ",(a6)+
	beq.b	arpar1
	tst.b	-1(a6)
	bne.b	arpar
ARPAR1	subq.l	#1,a6
	move.l	a6,a4			;Argument Start Address
	sub.l	a3,a6
	move.l	a6,d0

; Try To Find The Command

	moveq	#0,d7
	moveq	#0,d6
	moveq	#0,d2
ARPAR2	tst.b	(a0)
	beq.b	arpar8
	move.b	(a0)+,d2
	cmp.b	d2,d0			;Length Equal?
	bne.b	arpar3a			;Nap!
	move.l	a3,a5
	move.l	a0,a6
	move.w	d0,d5
	subq.w	#1,d5
ARPAR3	move.b	(a5)+,d1
	cmp.b	(a6)+,d1
	bne.b	arpar3a
	dbra	d5,arpar3
	bra.b	arpar3b

ARPAR3a	add.l	d2,a0
	addq.l	#1,a0
	addq.l	#1,d6
	bra.b	arpar2

; Found!!! Setup Arguments

ARPAR3b	moveq	#-1,d7
	moveq	#0,d5
	add.l	d2,a0
	move.b	(a0)+,d5		;Max Number Of Arguments
	subq.w	#1,d5
	bmi.b	arpar7a			;No Arguments
ARPAR4	move.l	(a1)+,a6
	tst.b	(a4)+
	beq.b	arpar7b			;ERROR!!!!
	tst.w	d5
	beq.b	arpar7

ARPAR5	cmp.b	#" ",(a4)
	beq.b	arpar6
	tst.b	(a4)
	beq.b	arpar6
	move.b	(a4)+,(a6)+		;Copy Argument
	bra.b	arpar5

ARPAR6	clr.b	(a6)
	dbra	d5,arpar4		;Will Always Jump, Will Never Be -1

; One Argument Parse

ARPAR7	move.b	(a4)+,(a6)+		;Copy Argument
	bne.b	arpar7
ARPAR7a	addq.l	#8,sp
	bra.b	arparo

ARPAR7b	lea	aperr1(pc),a1
	moveq	#17,d5
	bra.b	arpar8a

; Not Found!!!

ARPAR8	lea	aperr(pc),a1
	moveq	#15,d5
ARPAR8a	movem.l	(sp)+,a2/a5
	move.l	a2,a0
	bsr.w	SetARexxLastError

	move.l	a2,a0
	sub.l	a1,a1
	move.l	d5,d0
	bsr.w	ReplyARexxMsg
	moveq	#0,d7

ARPARO	move.l	d7,d0
	move.l	d6,d1
	movem.l	(sp)+,d2/d5-d7/a2-a6
	tst.l	d0
	rts

APERR	dc.b	"Error 15: Function NOT found",0
APERR1	dc.b	"Error 17: Wrong number of arguments",0
	even
;------------------------------------------------------------------------------
;******************************************************************************
;* ARexx Commands                                                             *
;******************************************************************************
;------------------------------------------------------------------------------
; Send Message Back
;

ARXCANC	sub.l	a1,a1
	moveq	#1,d0
ARXOK	move.l	arxmsg(pc),a0
	move.l	arxport(pc),a5
	bsr.w	ReplyArexxMsg		;Reply Message
	rts
;------------------------------------------------------------------------------
; Command: GetFile
;
; INPUT : Window Title
;
; OUTPUT: Filename With Path
;

ARexxGetFile
	lea	axarg1,a3
	moveq	#FI_Load,d0
	bsr.w	filreq			;Show FileRequester
	beq.b	arxcanc

	lea	fname,a1
	moveq	#0,d0
	bra.b	arxok
;-----------------------------------------------------------------------------
; Command: GetDir
;
; INPUT : Window Title
;
; OUTPUT: Directory Path
;

ARexxGetDir
	lea	fname1,a0
	moveq	#108-1,d7
AGETDIR	clr.b	(a0)+
	dbra	d7,agetdir

	lea	axarg1,a3
	moveq	#FI_NoFiles,d0
	bsr.w	filreq			;Show FileRequester
	beq.b	arxcanc

	lea	fname,a1
	moveq	#0,d0
	bra.b	arxok
;-----------------------------------------------------------------------------
; Command: Request1
;
; INPUT : String
;
; OUTPUT: Nothing
;

ARexxRequest1
	lea	axarg1,a1
	lea	okgad(pc),a2
	sub.l	a3,a3
	bsr.w	requs

	sub.l	a1,a1
	moveq	#0,d0
	bra.b	arxok

OKGAD	dc.b	" Okay ",0
	even
;-----------------------------------------------------------------------------
; Command: Request2
;
; INPUT : String
;
; OUTPUT: Nothing
;

ARexxRequest2
	lea	axarg1,a1
	lea	okcagad(pc),a2
	sub.l	a3,a3
	bsr.w	requs

	sub.l	a1,a1
	eor.w	#1,d0
	bra.w	arxok

OKCAGAD	dc.b	" Okay |Cancel",0
	even
;-----------------------------------------------------------------------------
; Command: GetString
;
; INPUT : Title
;
; OUTPUT: String
;

ARexxGetString
	move.l	reqbase(pc),a6
	lea	axarg8,a1
	lea	axarg1,a2
	sub.l	a3,a3
	lea	gstrtag(pc),a0
	move.l	#256,d0
	clr.b	(a1)
	jsr	rtGetStringA(a6)
	tst.l	d0
	beq.w	arxcanc

	lea	axarg8,a1
	moveq	#0,d0
	bra.w	arxok

GSTRTAG	dc.l	RT_LockWindow,1
	dc.l	RT_UnderScore,"_"
	dc.l	TAG_END
;-----------------------------------------------------------------------------
; Command: GetSuffix
;
; INPUT : Nothing
;
; OUTPUT: Suffix String
;

ARexxGetSuffix
	lea	sufbuf(pc),a1
	moveq	#0,d0
	bra.w	arxok
;-----------------------------------------------------------------------------
; Command: StripPath
;
; INPUT : String
;
; OUTPUT: New String
;

ARexxStripPath
	lea	axarg1,a0
	move.l	a0,a1
ARSTRI1	tst.b	(a0)+
	beq.b	arstrio
	cmp.b	#"/",-1(a0)
	beq.b	arstri2
	cmp.b	#":",-1(a0)
	bne.b	arstri1
	move.l	a0,a1
	bra.b	arstri1

ARSTRI2	move.l	a0,a1
ARSTRIO	moveq	#0,d0
	bra.w	arxok
;------------------------------------------------------------------------------
; Command: Determine
;
; INPUT : Filename
;
; OUTPUT: Error or Cruncher name
;

ARexxDetermine
	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)
	tst.l	d0
	beq.b	armerr

	move.l	d0,-(sp)
	move.l	d0,a0
	lea	axarg1,a1
	jsr	upDetermineFile(a6)	;Determine File
	tst.w	d0
	bne.b	ardet1
	move.l	(sp)+,a0
	move.l	UI_ErrorMsg(a0),a5
	jsr	upFreeCInfo(a6)
	bra.b	arerr

ARDET1	move.l	(sp)+,a0
	move.l	UI_CruncherName(a0),a1
	moveq	#0,d0
	jsr	upFreeCInfo(a6)
	bra.w	arxok

; Error Routine

ARMERR	lea	errmem(pc),a5
ARERR	move.l	a5,a1
	bra.w	arxok
	ENDC

ERRMEM	dc.b	"Memory Allocation Error",0
	even
;-----------------------------------------------------------------------------
; Command: Unpack
;
; INPUT : In-Filename  Out-Filename
;
; OUTPUT: Error or Cruncher name
;

	IF	CLIONLY=0
ARexxUnpack
	sf	verflg
	move.w	gads4+12(pc),d0		;Verify
	btst	#7,d0
	beq.b	arxunp1			;Nap!
	st	verflg

ARXUNP1	moveq	#0,d7
	bsr.b	arunp
	bne.b	arerr
	bra.w	arxok
	ENDC


ARUNP	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)
	tst.l	d0
	bne.b	arunp1
	lea	errmem(pc),a5
	moveq	#ERR_Memory,d0
	rts

ARUNP1	move.l	d0,-(sp)
	move.l	d0,a0
	move.l	d7,UI_UserData(a0)
	move.b	#UFN_Protect,UI_Flag(a0)

	lea	axarg1,a1
	jsr	upDetermineFile(a6)	;Determine File
	tst.w	d0
	bne.b	arunp2

ARUNP1a	move.l	drvinf(pc),d0
	beq.b	arunp1b
	move.l	d0,a0
	jsr	upUnuseDrive(a6)
	clr.l	drvinf

ARUNP1b	move.l	(sp)+,a0
	moveq	#0,d0
	move.w	UI_ErrorNum(a0),d0
	move.l	UI_ErrorMsg(a0),a5
	jsr	upFreeCInfo(a6)
	moveq	#-1,d1
	rts

; Strip Filename

ARUNP2	move.l	(sp),a0
	lea	axarg2,a1
	lea	axarg8,a2
	move.l	a2,a3
ARUNP3	move.b	(a1)+,(a2)+
	beq.b	arunp5
	cmp.b	#"/",-1(a1)
	beq.b	arunp4
	cmp.b	#":",-1(a1)
	bne.b	arunp3
	move.l	a2,a3
	bra.b	arunp3

ARUNP4	move.l	a2,a3
ARUNP5	clr.b	(a3)

	move.b	UI_CrunchType(a0),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Track,d0
	bne.b	arunp6
	lea	axarg8,a1

	IF	CLIONLY=0
	tst.w	d7
	bne.b	arunp5a
	bsr.w	volreq
	beq.b	arunp1a
	lea	fname,a1
	ENDC

ARUNP5a	jsr	upUseDrive(a6)
	move.l	d0,drvinf
	beq.w	arunp1a

ARUNP6	move.l	#axarg8,UI_Path(a0)
	move.l	#arusav,UI_Jump(a0)
	move.l	#artrsav,UI_TrackJump(a0)
	move.l	#artrerr,UI_TrkErrJump(a0)
	clr.b	UI_Flag(a0)
	jsr	upUnpack(a6)		;Unpack The File
	tst.w	d0
	beq.w	arunp1a

	move.l	drvinf(pc),d0
	beq.b	arunp7
	move.l	d0,a0
	move.l	UI_DecrunchAdr(a4),a1
	move.l	UI_Offset(a4),d1
	move.l	UI_DecrunchLen(a4),d2
	moveq	#4,d0			;CMD_Update
	jsr	upSendCmd(a6)

	move.l	drvinf(pc),a0
	jsr	upUnuseDrive(a6)
	clr.l	drvinf

ARUNP7	move.l	(sp)+,a0
	move.l	UI_CrunchLen(a0),d1
	move.l	UI_DecrunchLen(a0),d2
	move.l	UI_CruncherName(a0),a1
	jsr	upFreeCInfo(a6)
	moveq	#0,d0
	rts

; Save Routine

ARUSAV	move.b	UI_CrunchType(a4),d0
	and.b	#$7f,d0
	cmp.b	#CRU_Archive,d0
	beq.b	arusavo

	move.l	#axarg2,d1
	tst.b	UI_UseFilenamePointer(a4)
	beq	arusav1
	move.l	UI_Filename(a4),d1
ARUSAV1	move.l	dosbase(pc),a6
	move.l	#1006,d2
	jsr	Open(a6)
	tst.l	d0
	beq.b	arusavo

	move.l	d0,-(sp)
	move.l	d0,d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Write(a6)

	move.l	(sp)+,d1
	jsr	Close(a6)
ARUSAVO	rts

; Track-Packed Save Routine

ARTRSAV	move.l	a1,d7
	beq.b	artrsv1

	move.l	4.w,a6
	lea	trktxt(pc),a0		;Text
	lea	UI_Track(a4),a1		;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print

ARTRSV1	move.l	unpbase(pc),a6
	move.l	drvinf(pc),a0
	move.l	UI_DecrunchAdr(a4),a1
	move.l	UI_Offset(a4),d1
	move.l	UI_DecrunchLen(a4),d2
	moveq	#3,d0			;CMD_Write
	jsr	upSendCmd(a6)
	bne.w	artrsv5

	tst.b	verflg			;Verify?
	beq.b	artrsv3			;Nap!

	tst.w	d7
	beq.b	artsv1a

	move.l	4.w,a6
	lea	tvertxt(pc),a0		;Text
	lea	UI_Track(a4),a1		;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print

ARTSV1a	move.l	UI_DecrunchLen(a4),d0
	move.l	#$10002,d1
	jsr	AllocMem(a6)
	tst.l	d0
	beq.b	artrsv3
	move.l	d0,a5

	move.l	unpbase(pc),a6
	move.l	drvinf(pc),a0
	move.l	a5,a1
	move.l	UI_Offset(a4),d1
	move.l	UI_DecrunchLen(a4),d2
	moveq	#2,d0			;CMD_Read
	jsr	upSendCmd(a6)
	bne.b	artrsv5

	move.l	a5,a0
	move.l	UI_DecrunchAdr(a4),a1
	move.l	UI_DecrunchLen(a4),d6
ARTRSV2	move.b	(a0)+,d0
	cmp.b	(a1)+,d0
	bne.b	artrsv4
	subq.l	#1,d6
	bne.b	artrsv2

	move.l	4.w,a6
	move.l	a5,a1
	move.l	UI_DecrunchLen(a4),d0
	jsr	FreeMem(a6)

ARTRSV3	tst.w	d7
	beq.b	artsv3a

	move.l	4.w,a6
	lea	tunptxt(pc),a0		;Text
	lea	UI_Track(a4),a1		;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	txtbuf,a0
	bsr.w	print

ARTSV3a	moveq	#0,d0
	rts

ARTRSV4	move.l	4.w,a6
	move.l	a5,a1
	move.l	UI_DecrunchLen(a4),d0
	jsr	FreeMem(a6)

	lea	verrtxt(pc),a1
	moveq	#0,d0
	bra.b	artrsv6

ARTRSV5	lea	trkerr(pc),a1
ARTRSV6	moveq	#-1,d6
	move.w	d0,-(sp)
	lea	trgdtxt(pc),a2
	move.l	sp,a3

	IF	CLIONLY=0
	tst.w	d7
	beq.b	artrs6a
	ENDC

	move.l	4.w,a6
	move.l	a1,a0			;Text
	move.l	a3,a1			;Data Stream
	lea	stochr(pc),a2		;Store Character Routine
	lea	txtbuf,a3		;New Text
	jsr	RawDoFmt(a6)

	lea	crettxt(pc),a0
	bsr.w	print
	lea	txtbuf,a0
	bsr.w	print
	lea	crettxt(pc),a0
	bsr.w	print
	IF	CLIONLY=0
	bra.b	artrsv7

ARTRS6a	bsr.w	requs
	beq.b	artrsv7
	moveq	#0,d6
	ENDC

ARTRSV7	addq.l	#2,sp
	move.l	d6,d0
	rts

; Track-Packer Error Routine

ARTRERR	moveq	#-1,d6

	IF	CLIONLY=0
	move.l	a1,d7
	bne.b	artrero
	move.l	UI_ErrorMsg(a4),a1
	lea	trgdtxt(pc),a2
	bsr.w	requs
	beq.b	artrero
	moveq	#0,d6
	ENDC

ARTRERO	move.l	d6,d0
	rts

TRKTXT	dc.b	11,"Writing   track %d....",10,0
TVERTXT	dc.b	11,"Verifying track %d....",10,0
TUNPTXT	dc.b	11,"Unpacking track %d....",10,0
TRKERR	dc.b	"Error #%d while writing",0
VERRTXT	dc.b	"Verify error",0
TRGDTXT	dc.b	"_Continue|  _Stop  ",0
	even
;------------------------------------------------------------------------------
; Command: GetType
;
; INPUT : Filename
;
; OUTPUT: Error or Type
;

	IF	CLIONLY=0
ARexxGetType
	move.l	unpbase(pc),a6
	jsr	upAllocCInfo(a6)
	tst.l	d0
	bne.b	artyp1
	lea	errmem(pc),a5
	moveq	#ERR_Memory,d0
	bra.w	arerr

ARTYP1	move.l	d0,-(sp)
	move.l	d0,a0
	lea	axarg1,a1
	jsr	upDetermineFile(a6)	;Determine File
	tst.w	d0
	bne.b	artyp2
	move.l	(sp)+,a0
	move.l	UI_ErrorMsg(a0),a5
	jsr	upFreeCInfo(a6)
	bra.w	arerr

ARTYP2	move.l	(sp)+,a0
	moveq	#0,d1
	move.b	UI_CrunchType(a0),d1
	and.b	#$7f,d1
	jsr	upFreeCInfo(a6)

	lea	atyptab-4(pc),a1
	lsl.w	#2,d1
	move.l	(a1,d1.w),a1
	moveq	#0,d0
	bra.w	arxok

ATYPTAB	dc.l	atyparc,atypdat,atypob1,atypob2,atypob3

ATYPARC	dc.b	"Archive",0
ATYPDAT	dc.b	"Data",0
ATYPOB1	dc.b	"Object-One Segment",0
ATYPOB2	dc.b	"Object-Many Segments",0
ATYPOB3	dc.b	"Track-Packed",0
	even
;------------------------------------------------------------------------------
ARXARG	dc.l	axarg1,axarg2,axarg3,axarg4,axarg5,axarg6,axarg7,axarg8

ARXJMP	dc.l	ARexxGetFile,ARexxGetDir,ARexxRequest1,ARexxRequest2
	dc.l	ARexxGetString,ARexxGetSuffix,ARexxStripPath
	dc.l	ARexxDetermine,ARexxUnpack,ARexxGetType

ARXCMD	dc.b	7,"GETFILE",1
	dc.b	6,"GETDIR",1
	dc.b	8,"REQUEST1",1
	dc.b	8,"REQUEST2",1
	dc.b	9,"GETSTRING",1
	dc.b	9,"GETSUFFIX",0
	dc.b	9,"STRIPPATH",1
	dc.b	9,"DETERMINE",1
	dc.b	6,"UNPACK",2
	dc.b	7,"GETTYPE",1
	dc.b	0
	even
	ENDC
;------------------------------------------------------------------------------
PROCADR	dc.l	0
INFADR	dc.l	0
DRVINF	dc.l	0
WINHD	dc.l	0

UNPBASE	dc.l	0
DOSBASE	dc.l	0
INTBASE	dc.l	0

	IF	CLIONLY=0
GFXBASE	dc.l	0
REQBASE	dc.l	0
FNTBASE	dc.l	0

OLDWPTR	dc.l	0
FILHD	dc.l	0
INPPORT	dc.l	0
IRPPORT	dc.l	0
RFILSTR	dc.l	0
WFILSTR	dc.l	0
VOLSTR	dc.l	0
UDRVINF	dc.l	0

LWINHD	dc.l	0
LSTLOCK	dc.l	0
OLDLOCK	dc.l	0

ARXPORT	dc.l	0
ARXMSG	dc.l	0

NOERR	dc.b	0

NOMSG	dc.b	0
LMBFLG	dc.b	0
CRLFLG	dc.b	0
KEYFLG	dc.b	0
CTRLFLG	dc.b	0
SHFTFLG	dc.b	0
ALTFLG	dc.b	0
AMIFLG	dc.b	0
	ENDC

COPFLG	dc.b	0
VERFLG	dc.b	0
;------------------------------------------------------------------------------
; CLI Texts

HEADTXT	dc.b	$9b,"0;33;40m"
	TITLE
	dc.b	$9b,"0;31;40m coded by Thomas Neumann",10,10,0

HLPTXT	dc.b	$9b,"1;31;40mLibrary Version: %d.%d",10
	dc.b	"Unpacker Types : %d",10
	dc.b	"Unpackers      : %d",10,10

	dc.b	$9b,"0;32;40mUSAGE: Unpacker [flags] command parameters",10,10
	dc.b	$9b,"0;31;40mFlags:",10,"------",10
	dc.b	"-c : Copy always",10
	dc.b	"-v : Verify",10,10
	dc.b	"Commands:             Parameters:",10
	dc.b	"----------------------------------------------------",10
	dc.b	"v  : View File        Filename",10
	dc.b	"e  : Extract File     InFilename [OutFilename/Drive]",10,10,0

CRETTXT	dc.b	10,0

CUPATX1	dc.b	$9b,"3;31;40mUnpacking.....",10,$9b,"0;31;40m",0
CUPATX2	dc.b	$9b,"3;31;40mDetermining.....",10,$9b,"0;31;40m",0

CUPTXT	dc.b	10,"Loaded file    : %s"
	dc.b	10,"Saved file     : %s"
	dc.b	10,"Packed length  : %ld"
	dc.b	10,"Original length: %ld"
	dc.b	10,"Cruncher       : %s",10,0

CUPTXT0	dc.b	10,"Selected file: %s"
	dc.b	10,"Cruncher     : %s",10,0

CUPTXT1	dc.b	$9b,"0;32;40mERROR: ",0
CUPTXT2	dc.b	$9b,"0;31;40m",10,0
CUPTXT3	dc.b	"None",0
	even
;------------------------------------------------------------------------------
	IF	CLIONLY=0
WINSTR	dc.w	118,20,404,148
	dc.b	0,1
	dc.l	$200740,$20100e,gads,0,wintit,0,0
	dc.w	0,0,0,0,1

FONTSTR	dc.l	fontnam			;Font Name
	dc.w	8			;Font Size
	dc.b	0,0			;Style, Flags

WINTIT	TITLE
	dc.b	" by Thomas Neumann",0
FONTNAM	dc.b	"topaz.font",0
	even
;------------------------------------------------------------------------------
BOX	MACRO
	dc.w	0,0
	dc.b	2,0,0,3
	dc.l	.corl,.bord

.BORD	dc.w	0,0
	dc.b	2,0,0,2
	dc.l	.corl1,.bord1

.BORD1	dc.w	0,0
	dc.b	1,0,0,3
	dc.l	.cord,.bord2

.BORD2	dc.w	0,0
	dc.b	1,0,0,2
	dc.l	.cord1,\1

.CORL	dc.w	\2,\3+\5,\2,\3,\2+\4,\3
.CORL1	dc.w	\2+1,\3+\5-1,\2+1,\3+1
.CORD	dc.w	\2+\4,\3,\2+\4,\3+\5,\2+1,\3+\5
.CORD1	dc.w	\2+\4-1,\3+1,\2+\4-1,\3+\5-1
	ENDM

TXT	MACRO
	dc.b	\2,0,0,0
	dc.w	\3,\4
	dc.l	fontstr,\5,\1
	dc.w	\4			;My Own Variable
	ENDM

BORSTR	BOX	bord1,102,8,25*8,42
BORD1	BOX	bord2,12,66,208,50
BORD2	BOX	0,231,66,161,50

TEXTSTR	TXT	text1,1,116,12,txt1
TEXT1	TXT	text2,1,116,20,txt2
TEXT2	TXT	text3,1,116,28,txt3
TEXT3	TXT	text4,2,132,40,txt4

TEXT4	TXT	text5,1,84,57,txt5
TEXT5	TXT	0,1,288,57,txt6


TXT1	dc.b	"Library Version: "
TXT1a	dc.b	"  ."
TXT1b	dc.b	"   ",0
TXT2	dc.b	"Unpacker Types : "
TXT2a	dc.b	"   ",0
TXT3	dc.b	"Unpackers      : "
TXT3a	dc.b	"   ",0
TXT4	dc.b	"ARexx Port: "
TXT4a	dc.b	"UNPACK ",0

TXT5	dc.b	"Hotkeys",0
TXT6	dc.b	"Flags",0
	even
;------------------------------------------------------------------------------
IMAG	MACRO
	dc.w	0,0,26,11,2
	dc.l	\1
	dc.b	3,0
	dc.l	0
	ENDM

STRBOR	MACRO
	dc.w	0,0
	dc.b	2,0,0,3
	dc.l	.corl,.bord

.BORD	dc.w	0,0
	dc.b	2,0,0,2
	dc.l	.corl1,.bord1

.BORD1	dc.w	0,0
	dc.b	2,0,0,3
	dc.l	.corl2,.bord2

.BORD2	dc.w	0,0
	dc.b	2,0,0,2
	dc.l	.corl3,.bord3

.BORD3	dc.w	0,0
	dc.b	1,0,0,3
	dc.l	.cord,.bord4

.BORD4	dc.w	0,0
	dc.b	1,0,0,2
	dc.l	.cord1,.bord5

.BORD5	dc.w	0,0
	dc.b	1,0,0,3
	dc.l	.cord2,.bord6

.BORD6	dc.w	0,0
	dc.b	1,0,0,2
	dc.l	.cord3,0

.CORL	dc.w	\1,\2+\4,\1,\2,\1+\3-1,\2
.CORL1	dc.w	\1+1,\2+\4-1,\1+1,\2+1
.CORL2	dc.w	\1+3,\2+\4-1,\1+\3-2,\2+\4-1,\1+\3-2,\2+1
.CORL3	dc.w	\1+\3-3,\2+\4-2,\1+\3-3,\2+2

.CORD	dc.w	\1+\3,\2,\1+\3,\2+\4,\1+1,\2+\4
.CORD1	dc.w	\1+\3-1,\2+1,\1+\3-1,\2+\4-1
.CORD2	dc.w	\1+\3-3,\2+1,\1+2,\2+1,\1+2,\2+\4-1
.CORD3	dc.w	\1+3,\2+2,\1+3,\2+\4-2
	ENDM

GBOX	MACRO
	BOX	.gbord,\2,\3,\4,\5

.GBORD	dc.w	0,0
	dc.b	1,0,0,2
	dc.l	.gcord,0

.GCORD	dc.w	\2+16+\1*8,\3+11,\2+24+\1*8,\3+11
	ENDM


GADS	dc.l	gads1
	dc.w	86,72,120,13,3,$2,4
	dc.l	gadsb,0,poptxt0,0,gadsa
	dc.w	1
	dc.l	0
	dc.w	72

GADSa	dc.l	popbuf,popundo
	dc.w	0,30,0,0,0,0,0,0
	dc.l	0,0,0

POPTXT0	TXT	0,1,-(8*8+2),0,poptxt2

POPBUF	blk.b	32,0
POPUNDO	blk.b	32,0

GADS1	dc.l	gads2
	dc.w	86,87,120,13,3,$2,4
	dc.l	gadsb,0,unptxt0,0,gads1a
	dc.w	1
	dc.l	0
	dc.w	87

GADS1a	dc.l	unpbuf,unpundo
	dc.w	0,30,0,0,0,0,0,0
	dc.l	0,0,0

UNPTXT0	TXT	0,1,-(8*8+2),0,unptxt1

UNPBUF	blk.b	32,0
UNPUNDO	blk.b	32,0

GADS2	dc.l	gads3
	dc.w	86,102,120,13,3,$2,4
	dc.l	gadsb,0,suftxt0,0,gads2a
	dc.w	1
	dc.l	0
	dc.w	102

GADS2a	dc.l	sufbuf,sufundo
	dc.w	0,6,0,0,0,0,0,0
	dc.l	0,0,0

SUFTXT0	TXT	0,1,-(8*8+2),0,suftxt2

SUFBUF	blk.b	8,0
SUFUNDO	blk.b	8,0

GADSB	STRBOR	-6,-3,16*8+3,13

GADS3	dc.l	gads4
	dc.w	239,70,26,11,$86,$102,1
	dc.l	gadsi,gadsi1,poptxt,0,0
	dc.w	4
	dc.l	0
	dc.w	70

POPTXT	TXT	0,1,32,2,poptxt1

GADS4	dc.l	gads5
	dc.w	239,86,26,11,$6,$102,1
	dc.l	gadsi,gadsi1,vertxt,0,0
	dc.w	5
	dc.l	0
	dc.w	86

VERTXT	TXT	0,1,32,2,vertxt1

GADS5	dc.l	gads6
	dc.w	239,102,26,11,$6,$102,1
	dc.l	gadsi,gadsi1,coptxt,0,0
	dc.w	6
	dc.l	0
	dc.w	102

COPTXT	TXT	0,1,32,2,coptxt1

GADSI	IMAG	flagun
GADSI1	IMAG	flagsel

; Function Gadgets

GADS6	dc.l	gads7
	dc.w	12,128,33+3*8,14,$0,$1,1
	dc.l	funbor1,0,futxt1,0,0
	dc.w	7
	dc.l	0
	dc.w	128

FUNBOR1	GBOX	0,0,0,32+3*8,13
FUTXT1	TXT	0,1,16,3,funtxt1

GADS7	dc.l	gads8
	dc.w	105,128,33+6*8,14,$0,$1,1
	dc.l	funbor2,0,futxt2,0,0
	dc.w	8
	dc.l	0
	dc.w	128

FUNBOR2	GBOX	2,0,0,32+6*8,13
FUTXT2	TXT	0,1,16,3,funtxt2

GADS8	dc.l	gads9
	dc.w	217,128,33+4*8,14,$0,$1,1
	dc.l	funbor3,0,futxt3,0,0
	dc.w	9
	dc.l	0
	dc.w	128

FUNBOR3	GBOX	0,0,0,32+4*8,13
FUTXT3	TXT	0,1,16,3,funtxt3

GADS9	dc.l	0
	dc.w	312,128,33+6*8,14,$0,$1,1
	dc.l	funbor4,0,futxt4,0,0
	dc.w	10
	dc.l	0
	dc.w	128

FUNBOR4	GBOX	0,0,0,32+6*8,13
FUTXT4	TXT	0,1,16,3,funtxt4


POPTXT1	dc.b	"Pop Up",0
POPTXT2	dc.b	"Pop Up:",0
VERTXT1	dc.b	"Verify",0
UNPTXT1	dc.b	"Unpack:",0
COPTXT1	dc.b	"Copy Always",0
SUFTXT2	dc.b	"Suffix:",0

FUNTXT1	dc.b	"Use",0
FUNTXT2	dc.b	"Unpack",0
FUNTXT3	dc.b	"List",0
FUNTXT4	dc.b	"Cancel",0
	even
;------------------------------------------------------------------------------
POPKEY	dc.b	-1,0,-1,0,25
UNPKEY	dc.b	-1,0,-1,0,22
;------------------------------------------------------------------------------
; Cancel & Default Buffers
;

CBUF1	blk.b	32,0
CBUF2	blk.b	32,0
CBUF3	blk.b	8,0
CBUF4	dc.w	0,0,0

DBUF1	dc.b	"ctrl alt p"
	blk.b	22,0
DBUF2	dc.b	"ctrl alt u"
	blk.b	22,0
DBUF3	dc.b	".UNP",0,0,0,0
DBUF4	dc.w	$86,$6,$6
	ENDC
;------------------------------------------------------------------------------
UNPNAME	dc.b	"unpack.library",0
DOSNAME	dc.b	"dos.library",0
INTNAME	dc.b	"intuition.library",0
	IF	CLIONLY=0
GFXNAME	dc.b	"graphics.library",0
REQNAME	dc.b	"reqtools.library",0
DEVNAME	dc.b	"input.device",0

HANNAME	TITLE
	dc.b	" Input Handler",0
ARXPORN	dc.b	"UNPACK",0
PRENAME	dc.b	"S:Unpack.prefs",0
	even
;------------------------------------------------------------------------------
STDREQ	blk.b	$14,0			;Message Structure
	dc.l	0			;IO_Device
	dc.l	0			;IO_Unit
	dc.w	0			;IO_Command
	dc.b	0			;IO_Flags
	dc.b	0			;IO_Error
	dc.l	0			;IO_Actual
	dc.l	0			;IO_Length
	dc.l	0			;IO_Data
	dc.l	0			;IO_Offset

PORTSTR	blk.l	8,0

IRQSTR	dc.l	0,0
	dc.b	4,60
	dc.l	hanname,0,handler
;------------------------------------------------------------------------------
; Normal ASCII Table (Danish)

NORMASC	dc.b	$60,$31,$32,$33,$34,$35,$36,$37
	dc.b	$38,$39,$30,$2b,$00,$5c,$00,$30
	dc.b	$71,$77,$65,$72,$74,$79,$75,$69
	dc.b	$6f,$70,$e5,$00,$00,$31,$32,$33
	dc.b	$61,$73,$64,$66,$67,$68,$6a,$6b
	dc.b	$6c,$e6,$f8,$27,$00,$34,$35,$36
	dc.b	$3c,$7a,$78,$63,$76,$62,$6e,$6d
	dc.b	$2c,$2e,$2d,$00,$2e,$37,$38,$39
	dc.b	$20,$08,$09,$0a,$0a,$1b,$14,$00
	dc.b	$00,$00,$2d,$00,$91,$11,$1d,$9d
	dc.b	$85,$86,$87,$88,$89,$8a,$8b,$8c
	dc.b	$8d,$8e,$5b,$5d,$2f,$2a,$2b,$0f
	dc.b	$00,$00,$00,$00,$00,$00,$00,$00
;------------------------------------------------------------------------------
	SECTION	Menus,DATA

MENHEAD	MACRO
	dc.l	\1
	dc.w	4+13*8*\2,0,8+\3,10,$1
	dc.l	\4,\5
	dc.w	0,0,0,0
	ENDM

MENITEM	MACRO
	dc.l	\1
	dc.w	0,0,5*8+\5,0,$42!\2
	dc.l	0,.mtxstr,0
	dc.b	\3,0
	dc.l	\6
	dc.w	0

.MTXSTR	dc.b	0,1,0,0
	dc.w	0,2
	dc.l	0,\4,0
	ENDM

MENLINE	MACRO
	dc.l	\1
	dc.w	0,0,5*8+\2,10,$c0
	dc.l	0,.mimstr,0
	dc.b	0,0
	dc.l	0,0

.MIMSTR	dc.w	0,3,5*8+\2,2,1
	dc.l	menimag
	dc.b	1,2
	dc.l	0
	ENDM


MENUSTR
MENU1	MENHEAD	menu2,0,7*8,m1head,m1str
M1STR	MENITEM	m1str1,$14,"O",m1txt,10*8,0
M1STR1	MENITEM	m1str2,$14,"S",m1txt1,10*8,0
M1STR2	MENITEM	m1str3,$14,"A",m1txt2,10*8,0
M1STR3	MENLINE	m1str4,10*8
M1STR4	MENITEM	m1str5,$14,"?",m1txt4,10*8,0
M1STR5	MENLINE	m1str6,10*8
M1STR6	MENITEM	0,$14,"Q",m1txt6,10*8,0

MENU2	MENHEAD	menu3,1,4*8,m2head,m2str
M2STR	MENITEM	m2str1,$14,"D",m2txt,16*8,0
M2STR1	MENITEM	m2str2,$14,"L",m2txt1,16*8,0
M2STR2	MENITEM	0,$14,"R",m2txt2,16*8,0

MENU3	MENHEAD	0,2,5*8,m3head,m3str
M3STR	MENITEM	m3str1,$10,0,m3txt,24*8,0
M3STR1	MENITEM	m3str2,$10,0,m3txt1,24*8,0
M3STR2	MENITEM	m3str3,$10,0,m3txt2,24*8,0
M3STR3	MENITEM	m3str4,$10,0,m3txt3,24*8,0
M3STR4	MENITEM	m3str5,$10,0,m3txt4,24*8,0
M3STR5	MENITEM	m3str6,$10,0,m3txt5,24*8,0
M3STR6	MENITEM	m3str7,$10,0,m3txt6,24*8,0
M3STR7	MENITEM	m3str8,$10,0,m3txt7,24*8,0
M3STR8	MENITEM	m3str9,$10,0,m3txt8,24*8,0
M3STR9	MENITEM	0,$10,0,m3txt9,24*8,0


M1HEAD	dc.b	"Project",0
M1TXT	dc.b	"Open...",0
M1TXT1	dc.b	"Save",0
M1TXT2	dc.b	"Save As...",0
M1TXT4	dc.b	"About...",0
M1TXT6	dc.b	"Quit",0

M2HEAD	dc.b	"Edit",0
M2TXT	dc.b	"Reset To Default",0
M2TXT1	dc.b	"Last Saved",0
M2TXT2	dc.b	"Restore",0

M3HEAD	dc.b	"ARexx",0
M3TXT	dc.b	"                     F1",0
M3TXT1	dc.b	"                     F2",0
M3TXT2	dc.b	"                     F3",0
M3TXT3	dc.b	"                     F4",0
M3TXT4	dc.b	"                     F5",0
M3TXT5	dc.b	"                     F6",0
M3TXT6	dc.b	"                     F7",0
M3TXT7	dc.b	"                     F8",0
M3TXT8	dc.b	"                     F9",0
M3TXT9	dc.b	"                     F10",0

; Real Macro Names

AM1STR	blk.b	64,0
AM2STR	blk.b	64,0
AM3STR	blk.b	64,0
AM4STR	blk.b	64,0
AM5STR	blk.b	64,0
AM6STR	blk.b	64,0
AM7STR	blk.b	64,0
AM8STR	blk.b	64,0
AM9STR	blk.b	64,0
AM10STR	blk.b	64,0
	even
;------------------------------------------------------------------------------
	SECTION	Graphics,DATA_C

FLAGUN	dc.l	%00000000000000000000000001000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%01111111111111111111111111000000

	dc.l	%11111111111111111111111110000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%10000000000000000000000000000000

FLAGSEL	dc.l	%00000000000000000000000001000000
	dc.l	%00000000000000000000000011000000
	dc.l	%00000000000000000111000011000000
	dc.l	%00000000000000001100000011000000
	dc.l	%00000000000000011000000011000000
	dc.l	%00000001110000110000000011000000
	dc.l	%00000000111001100000000011000000
	dc.l	%00000000011111000000000011000000
	dc.l	%00000000001110000000000011000000
	dc.l	%00000000000000000000000011000000
	dc.l	%01111111111111111111111111000000

	dc.l	%11111111111111111111111110000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%11000000000000000000000000000000
	dc.l	%10000000000000000000000000000000

MENIMAG	blk.b	80*2,255
	ENDC
;------------------------------------------------------------------------------
	SECTION	FileInfo,BSS

	IF	CLIONLY=0
FILINFO	ds.b	260
SNAME	ds.b	110
DNAME	ds.b	110
FNAME	ds.b	108*2
FNAME1	ds.b	108
	ENDC

TXTDAT	ds.l	10
TXTBUF	ds.b	256

AXARG1	ds.b	256
AXARG2	ds.b	256

	IF	CLIONLY=0
AXARG3	ds.b	256
AXARG4	ds.b	256
AXARG5	ds.b	256
AXARG6	ds.b	256
AXARG7	ds.b	256
	ENDC
AXARG8	ds.b	256
BSSEND
;------------------------------------------------------------------------------
	SECTION	StartupData,DATA

WBLOCK	dc.l	0
OUTBASE	dc.l	0
WORKPOI	dc.l	0

	IF	ARGS<>0
ARGSMEM	dc.l	0
	ENDC

	IF	KICK<>0
CRETAGS	dc.l	NP_Seglist,0
	dc.l	NP_Input,0
	dc.l	NP_Output,0
	dc.l	NP_CloseInput,0
	dc.l	NP_CloseOutput,0
	dc.l	NP_Name,procnam
	dc.l	NP_Priority,pri
	dc.l	NP_StackSize,stack
	dc.l	TAG_DONE
	ENDC
;------------------------------------------------------------------------------
SLUT
